2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	* lisp/ldefs-boot.el: Regenerate.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Bump Emacs version to 29.0.90

	* README:
	* configure.ac:
	* nt/README.W32:
	* msdos/sed2v2.inp: Bump version to 29.0.90.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Fix some cases of incomplete code's indentation [c/c++-ts-mode]

	* lisp/progmodes/c-ts-mode.el (c-ts-base--before-indent): Try to
	guess when the parse tree is incomplete, and provide a better node
	to indent against (bug#62717).
	(c-ts-base-mode): Set up advice for local treesit-indent-function.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	project-search: Pipe the list of files through 'file-regular-p'

	* lisp/progmodes/project.el (project-search): Pipe the list of
	files through 'file-regular-p' to skip directories (bug#62735).

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Update ChangeLog and AUTHORS for Emacs 29

	* admin/authors.el: Update for Emacs 29.

	* etc/AUTHORS: Re-generate for Emacs 29.

	* ChangeLog.4: New generated file.
	* Makefile.in (PREFERRED_BRANCH): Update to emacs-29.
	(CHANGELOG_HISTORY_INDEX_MAX): Bump to 4.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Backport: Eglot: no more tests based on Pylsp (bug#62694)

	The functionality under test in eglot.el is exactly the same, but use
	the clangd server only, as that is used in more tests, and it is much
	easier to check if it misbehaves or not.

	Tests pass with clangd version 15.

	* test/lisp/progmodes/eglot-tests.el (python): Don't require it.
	(eglot--call-with-fixture): Simplify.
	(eglot--wait-for-clangd): New helper.
	(eglot-test-basic-completions)
	(eglot-test-non-unique-completions, eglot-test-basic-xref)
	(eglot-test-snippet-completions)
	(eglot-test-snippet-completions-with-company)
	(eglot-test-eldoc-after-completions, eglot-test-multiline-eldoc):
	Use clangd, not pylsp.
	(eglot-test-formatting): Renamed from
	eglot-test-python-autopep-formatting.
	(eglot-test-python-yapf-formatting): Remove.

	(cherry picked from commit fc8230f3362b12955152f48565a6c670b4c4cc88)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix 'C-h k' for "Paste from Kill Menu" in context menus

	* lisp/mouse.el (context-menu-region): Make the entries be
	symbols, not just integers, to prevent "C-h c" from interpreting
	them as character keys.  (Bug#62626)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve the documentation of the XDS support

	* doc/lispref/frames.texi (Drag and Drop): Rephrase and rearrange
	the documentation of XDS support.  Add indexing.  Document
	'x-dnd-save-direct' and 'x-dnd-save-direct-immediately'.  Original
	patch from Po Lu <luangruo@yahoo.com>.

	* lisp/x-dnd.el (x-dnd-types-alist, x-dnd-test-function)
	(x-dnd-default-test-function, x-dnd-direct-save-function): Doc
	fixes.
	(x-dnd-save-direct, x-dnd-save-direct-immediately): Rename the
	second argument to FILENAME.  Doc fix.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Allow reindentation of images inserted by 'mm-inline-image'

	* lisp/gnus/mm-view.el (mm-inline-image): Use "x" as text on which
	to put the image 'display' property, so that indentation commands
	don't destroy the image inadvertently.  (Bug#62637)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix "C-h k" and "C-h c" with Paste from Kill Menu

	* lisp/subr.el (event-basic-type, event-modifiers): Return nil if
	EVENT is a string.  (Bug#62626)

2023-04-15  Daniel Martín  <mardani29@yahoo.es>

	Change cursor color on NS port when it matches the face background

	* src/macfont.m (CG_SET_FILL_COLOR_WITH_FRAME_CURSOR): New macro.
	(CG_SET_FILL_COLOR_WITH_FRAME_BACKGROUND): New macro.
	(macfont_draw): When the cursor's color matches the face background,
	set the fill color of the cursor to the face foreground.
	* src/nsterm.m (ns_maybe_dumpglyphs_background): When dumping the
	background of a glyph string, apply the logic mentioned
	above.  (Bug#62573)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of image-related commands

	* lisp/image.el (image-map): Make it inherit from
	'image-slice-map' instead of repeating the bindings.

	* doc/emacs/files.texi (Image Mode): Document the key bindings set
	by 'insert-image'.  Add indexing.

	* doc/lispref/display.texi (Showing Images): Make the description
	of user commands more concise.  Add index entries and
	cross-reference to the Emacs manual.

	* etc/NEWS: Rearrange entries relevant to image commands.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix handling of sliced images

	* lisp/image.el (image-slice-map): New keymap, without some
	bindings that make no sense with sliced images.
	(insert-image, insert-sliced-image): Use it.
	(insert-sliced-image): Make the 'keymap' property rear-nonsticky,
	to prevent calling image commands when point is to the right of
	the slice.  (Bug#62679)

	* lisp/image/image-crop.el (image-cut, image-crop): Doc fixes.
	(image-crop): Don't try using stock MS-Widows convert.exe
	program.  Use 'image--get-image' to support sliced images.

2023-04-15  garid3000  <garidzorigoo@gmail.com>

	Add cyrillic-mongolian input method

	* lisp/leim/quail/cyrillic.el (cyrillic-mongolian): New input
	method.  (Bug#56617)

2023-04-15  João Távora  <joaotavora@gmail.com>

	Jsonrpc: don't bind inhibit-read-only to t so early

	Related to https://github.com/joaotavora/eglot/discussions/1202, where
	because of this very wide binding to inhibit-read-only to t, Eglot was
	managing to write into read-only buffers from the response handlers
	that ran from within the stack of the jsonrpc.el process filter.

	This is of course illegal and dangerous, but Eglot wasn't made aware
	because of the binding.

	* lisp/jsonrpc.el (jsonrpc--process-filter): Don't bind
	inhibit-read-only so early.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Allow active region when IM is used

	* lisp/international/quail.el (quail-minibuffer-message): Bind
	deactivate-mark to allow setting active region in the minibuffer
	when an input method is used.  (Bug#62709)

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Add emoji-zoom-reset

	* lisp/international/emoji.el (emoji-zoom-map): Add emoji-zoom-reset.
	(emoji-zoom-reset): New function, it resets the zoom level.
	* lisp/international/mule-cmds.el (ctl-x-map): Add emoji-zoom-reset.
	* etc/NEWS: Announce new command.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Make emoji-zoom-{increase,decrease} set text properties correctly

	* lisp/international/emoji.el (emoji-zoom-increase): Ensure that we're
	increasing the :height of the anonymous face at point, rather than
	having two :height properties, which appeared to work by
	accident, and don't error at eob.  (Bug#62675)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix transforming sliced images

	* lisp/image.el (image--get-image): Support sliced images
	(bug#62679).  Doc fix.
	(image-mouse-decrease-size, image-mouse-increase-size)
	(image-decrease-size, image-increase-size): Doc fixes.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Adapt EMBA scripts.

	* test/infra/Dockerfile.emba (emacs-gnustep): Add zlib1g-dev.
	Remove make instrumentation.

	* test/infra/gitlab-ci.yml (build-image-gnustep, test-gnustep): Uncomment.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Another terminology fix in ELisp reference manual

	* doc/lispref/frames.texi (Mouse Tracking):
	* doc/lispref/commands.texi (Motion Events, Event Examples):
	'track-mouse' is a macro, not a special form.

2023-04-15  Shynur  <one.last.kiss@outlook.com>  (tiny change)

	Correct terminology in Elisp Reference Manual

	* doc/lispref/functions.texi (Function Names): 'defun' is a macro, not
	a special form.  (Bug#62661)

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Comment out GNUSTEP jobs on EMBA (again)

	* test/infra/gitlab-ci.yml (build-image-gnustep, test-gnustep):
	Comment out jobs due to bug#62210.

2023-04-15  Mattias Engdegård  <mattiase@acm.org>

	Fix regexp string escaping mistake in vhdl-mode.el (bug#62508)

	* lisp/progmodes/vhdl-mode.el (vhdl-compiler-alist): Quote brackets
	correctly.

2023-04-15  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.3-2-gf2949d

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: don't watch directories that don't exist

	project-files isn't guaranteed to return existing files, so better
	check if they exist because placing a watcher on them.

	Originally reported at:
	https://github.com/joaotavora/eglot/issues/1198

	* lisp/progmodes/eglot.el (eglot-register-capability
	workspace/didChangeWatchedFiles): Check if directories exist.

2023-04-15  Eshel Yaron  <me@eshelyaron.com>

	Preserve peer information for web page in eww-readable

	The :peer property in eww-data affects the face of the page title
	in 'header-line-format' as set by 'eww-update-header-line-format'.
	Preserving this property in eww-readable avoids having the header
	line's appearance change when this command is called.
	* lisp/net/eww.el (eww-readable): Preserve eww-data's :peer
	property.  (Bug#62574)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	* lisp/subr.el (use-dialog-box-p): Fix conditions for GUI dialogs.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix ModelSim error regexp in vhdl-mode

	* lisp/progmodes/vhdl-mode.el (vhdl-compiler-alist): Fix ModelSim
	error regexp.  Suggested by Reto Zimmermann <reto@gnu.org>.
	(Bug#62508)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Document enhancements in handling of echo-area messages

	* etc/NEWS:
	* doc/lispref/display.texi (Displaying Messages):
	* lisp/minibuffer.el (inhibit-message-regexps)
	(set-message-functions, inhibit-message, set-multi-message):
	Improve the documentation of functions dealing with display of
	echo-area messages.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix new Eshell tests on MS-Windows

	* test/lisp/eshell/eshell-tests.el (eshell-test/eshell-command/background)
	(eshell-test/eshell-command/background-pipeline): Allow for ".exe"
	in the program's name.  This fixes these tests on MS-Windows.

2023-04-15  Jim Porter  <jporterbugs@gmail.com>

	Fix using background commands in 'eshell-command'

	Do not merge to master.

	This regressed due to the patch for bug#53715, which changed how
	Eshell pipelines return the processes in the pipeline (bug#62556).

	* lisp/eshell/esh-cmd.el (eshell-eval-command): Allow process-pairs.

	* test/lisp/eshell/eshell-tests.el (eshell-test/eshell-command/simple)
	(eshell-test/eshell-command/pipeline)
	(eshell-test/eshell-command/background)
	(eshell-test/eshell-command/background-pipeline): New tests.

2023-04-15  Shynur  <one.last.kiss@outlook.com>  (tiny change)

	Fix typo in section 14.1 of Emacs Manual

	* doc/emacs/display.texi (Scrolling): Fix typo.  (Bug#62569)

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: unbreak eglot-extend-to-xref on w32

	Because of a drive-letter casing mismatch between 'buffer-file-name'
	and the return value of 'url-generic-parse-url', the hash-table test
	'equal' in 'eglot-current-server' failed.

	This failed to recognize that the file xref landed us on really is
	managed by the language server that facilitated that jump.

	The function w32-long-file-name seems to convert "C:/Users/" to
	"c:/Users" consistently and so is a good addition to
	eglot--uri-to-path.

	* lisp/progmodes/eglot.el (eglot--uri-to-path): Use
	w32-long-file-name.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: ensure server shutdown turns off eglot-inlay-hints-mode

	* lisp/progmodes/eglot.el (eglot--managed-mode-off): Turn off
	eglot-inlay-hints-mode.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add two typescript-ts-mode faces (bug#62429)

	* lisp/progmodes/typescript-ts-mode.el:
	(typescript-ts-mode-jsx-tag-face)
	(typescript-ts-mode-jsx-attribute-face): New faces.
	(typescript-ts-mode--font-lock-settings): Use new faces.
	(tsx-ts-mode): Mention the new faces in the docstring.

2023-04-15  Shynur  <one.last.kiss@outlook.com>  (tiny change)

	Fix scrolling window when point moves up

	This fixes the case when both 'scroll-conservatively' and
	'scroll-step' are customized to non-default values.
	* src/xdisp.c (try_scrolling): Fix precedence between
	'scroll-step' and 'scroll-conservatively' when scrolling with
	'previous-line'.  (Bug#62530)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'defcustom's :set keyword

	* lisp/custom.el (defcustom):
	* doc/lispref/customize.texi (Variable Definitions): Improve the
	documentation of the :set keyword in 'defcustom'.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	Comp fix calls to redefined primtives with op-bytecode (bug#61917)

		* test/src/comp-tests.el (61917-1): New test.
		* src/comp.c (syms_of_comp): New variable.
		* lisp/loadup.el: Store primitive arities before dumping.
		* lisp/emacs-lisp/comp.el (comp--func-arity): New function.
		(comp-emit-set-call-subr): Make use of `comp--func-arity'.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix duplicate defcustom in eww.el

	* lisp/net/eww.el (eww-default-download-directory): Renamed back
	from 'eww-download-directory'; all users changed.  Doc fix.
	(Bug#62531)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix indentation regression in 'C-h l'

	* lisp/help.el (view-lossage): Fix indentation of commands
	when the key sequence includes a semicolon.  (Bug#62453)

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	* doc/misc/tramp.texi (Remote shell setup): Clarify use of ssh RemoteCommand.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'read-choice' and related symbols

	* doc/lispref/commands.texi (Reading One Event):
	* lisp/subr.el (read-char-choice-use-read-key, read-char-choice)
	(read-char-choice-with-read-key, y-or-n-p-use-read-key): Improve
	documentation of these functions and variables.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	Revert "Comp fix calls to redefined primtives with op-bytecode (bug#61917)"

	This reverts commit 263d6c38539691c954f4c3057cbe8d5468499b91.

	These patch series caused a number of regression and more analysis is
	required.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	Revert "* lisp/emacs-lisp/comp.el (comp-emit-set-call-subr): Improve..."

	This reverts commit 4a7a0c9a9f521b04b23580901e9c0a662b504e32.

	These patch series caused a number of regression and more analysis is
	required.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Skip ruby-ts-imenu-index test if needed

	* test/lisp/progmodes/ruby-ts-mode-tests.el (ruby-ts-imenu-index):
	Add check for treesitter.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Fix Eglot Tramp tests on EMBA

	* test/lisp/progmodes/eglot-tests.el (eglot--call-with-tramp-test):
	Bind `tramp-allow-unsafe-temporary-files' with t.  (Bug#62289)

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	* test/infra/Dockerfile.emba (emacs-gnustep): Instrument "make V=1 ...".

2023-04-15  João Távora  <joaotavora@gmail.com>

	Fix accidental backward-incompatible change (bug#62417)

	This code used to work, but with the change of 59ecf25fc860 it stopped
	working:

	   (defun foop (buffer-name _alist) (string-match "foop" buffer-name))
	   (add-to-list 'display-buffer-alist '(foop . display-buffer-other-frame))

	This change makes it work again, restoring compatibility.

	* lisp/subr.el (buffer-match-p): Fix and adjust docstring.
	* lisp/window.el (display-buffer-alist): Adjust docstring.
	(display-buffer-assq-regexp): Make good on promise of display-buffer-alist.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Fix/simplify Imenu index generation

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--full-name): Drop '#'
	from the end of resulting string when the node is not a method.
	Support 'singleton_method' nodes.
	(ruby-ts--imenu-helper): Simplify, to create a "flat" list of
	entries, rather than a nested one.  The previous implementation
	had problems (like producing a nested structure of full-qualified
	names, thus creating a lot of textual repetition), seems easier to
	just follow ruby-mode's example here, at least for Emacs 29's
	release.

	* test/lisp/progmodes/ruby-ts-mode-tests.el (ruby-ts-imenu-index):
	New test.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(ruby-ts--align-chain): Use 'equal' to check for an exact match

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--align-chain): Use
	'equal' to check for an exact match rather than substring.

2023-04-15  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.3.7-218-g3dbb22a

2023-04-15  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.2

2023-04-15  Ken Brown  <kbrown@cornell.edu>

	Skip failing tests on Cygwin with native compilation (bug#62450)

	* test/Makefile.in (TEST_NATIVE_COMP): New variable, used to
	determine whether to run tests tagged with :nativecomp.  Set it to
	"no" on Cygwin and to $(HAVE_NATIVE_COMP) otherwise.

	* test/lisp/emacs-lisp/benchmark-tests.el (benchmark-tests): Skip
	on Cygwin with native-compilation.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Fix GNUSTEP tests on EMBA

	* configure.ac (LIBS_GNUSTEP): Adapt CPPFLAGS and CFLAGS.  (Bug#62210)
	Proposed by Po Lu <luangruo@yahoo.com>.

	* test/infra/gitlab-ci.yml (build-image-gnustep)
	(test-gnustep): Uncomment jobs.

2023-04-15  Phil Sainty  <psainty@orcon.net.nz>

	Fix primary selection modification during `term-mouse-paste' (bug#58608)

	* lisp/term.el (term-mouse-paste): Prevent the primary selection from
	being changed in the process of sending it to the inferior process.

2023-04-15  Xi Lu  <lx@shellcodes.org>

	Add 'eww-default-download-directory'.

	* lisp/net/eww.el (eww-default-download-directory): New defcustom.
	(eww--download-directory): Use it.  (Bug#62435)

2023-04-15  Phil Sainty  <psainty@orcon.net.nz>

	* doc/lispref/modes.texi: Improve docs for obsolete '%m' construct

	Bug #57080.

2023-04-15  Phil Sainty  <psainty@orcon.net.nz>

	Improve docs for global-mode-string / %M construct

	* src/xdisp.c (global-mode-string): Update docstring.
	* doc/lispref/modes.texi: Update manual.

2023-04-15  Phil Sainty  <psainty@orcon.net.nz>

	* src/buffer.c (mode-line-format): Document %o and %q constructs

	Missed from commit b0b02ca7f3e06d0f092df6f81babd1277bf93b0f.

2023-04-15  Phil Sainty  <psainty@orcon.net.nz>

	* src/buffer.c (mode-line-format): Remove docs for obsolete %t construct

	This documentation had been previously removed in 1999 in [1]
	but was subsequently restored again in a different form in 2006
	in [2] as the construct was still supported on some systems.
	However it looks like it hasn't done what that documentation
	indicated since [3] in 2011, and the final remnant of this
	functionality was removed in [4] in 2013; so it seems clear that
	it's no longer supported and shouldn't be documented now.

	[1] commit 08de62001945d4dd32a3d6af44da05804cb296d5
	[2] commit dafbe726b89a36010f3f24bb1efe4ace0a5f7f0f
	[3] commit 05c652517317d10690aaf0a6aa0bc876382b9d82
	[4] commit 8549f9e89bd9288c4c709d183a5bf8f07dbeed3d

2023-04-15  kobarity  <kobarity@gmail.com>

	Improve indenting "case" in Python

	* lisp/progmodes/python.el (python-info-dedenter-statement-p): Do not
	consider the first "case" in the block as dedenter.
	* test/lisp/progmodes/python-tests.el
	(python-info-dedenter-opening-block-positions-7)
	(python-info-dedenter-statement-p-6): New tests. (Bug#62092)

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	* test/infra/Dockerfile.emba (emacs-native-comp): Add zlib1g-dev.

2023-04-15  Ken Brown  <kbrown@cornell.edu>

	Fix failure of fns-tests-collate-strings on Cygwin

	* test/src/fns-tests.el (fns-tests-collate-strings): Use
	en_XY.UTF-8 instead of en_DE.UTF-8 as an example of an invalid
	locale; en_DE.UTF-8 is actually a valid locale on Cygwin.
	Note: The test will still fail on Cygwin releases < 3.5
	because of a Cygwin bug.  (Bug#62420)

2023-04-15  Aaron L. Zeng  <azeng@janestreet.com>  (tiny change)

	* lisp/savehist.el (savehist-save): Preserve shared structure

	This avoids ballooning the size of variables that contain
	large text properties, such as the 'yank-handler' installed
	by 'evil-yank-rectangle', which contains a list of lines in
	the string.
	* lisp/savehist.el (savehist-save): Enable 'print-circle'.
	(Bug#62364)

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Adapt Tramp manual

	* doc/misc/tramp.texi (Default Method): OpenSSH for MS Windows can
	be used.
	(Ssh setup): Extend for MS Windows and ssh.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix system time sampling on MS-Windows

	* src/timefns.c (emacs_localtime_rz) [WINDOWSNT]: Unconditionally
	call tzset to make sure we pick up all the changes of time zone,
	working around the MS CRT caching.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix treesit_ensure_parsed (bug#62333)

	* src/treesit.c (treesit_ensure_parsed): Check for need_reparse after
	treesit_sync_visible_region runs, because as the comment says,
	treesit_sync_visible_region might modify need_reparse.

2023-04-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/help-fns.el (find-lisp-object-file-name): Fix bug#62376 part2

	Nowadays `loaddefs.el` are byte-compiled, so adjust pattern accordingly

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve "Bugs" in the Emacs manual

	* doc/emacs/trouble.texi (Bugs, Known Problems)
	(Understanding Bug Reporting, Checklist, Sending Patches)
	(Contributing, Coding Standards): Improve wording, structure,
	markup, and indexing.  (Bug#62320)

2023-04-15  João Távora  <joaotavora@gmail.com>

	Fix Eglot progress reporting

	When the server sends an "end" message, Emacs's progress reporters
	should also be updated.

	* lisp/progmodes/eglot.el (eglot-handle-notification $/progress): Rework.

2023-04-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	Fix :predicate handling in globalized minor modes

	* lisp/emacs-lisp/easy-mmode.el (define-globalized-minor-mode):
	Fix a thinko.  (Bug#62376)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Allow showing prefix commands in Help buffers

	* lisp/help.el (describe-bindings-show-prefix-commands): New user
	option.
	(describe-map): Use it to decide whether to output prefix
	commands.  Patch by Bob Rogers <rogers@rgrjr.com>.  (Bug#62279)

	* etc/NEWS: Document 'describe-bindings-show-prefix-commands'.

2023-04-15  Daniel Martín  <mardani29@yahoo.es>

	Fix toolbar item validation in the NS port

	* src/nsterm.m ([EmacsView validateToolbarItem:]): Implement this
	NSToolbarItemValidation method, which is called by AppKit when it
	needs to validate an image item in a toolbar.  This solves, in
	particular, the problem with having the "Save" icon on the tool
	bar enabled at Emacs startup.  (Bug#62234)

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Use libgccjit-10-dev on EMBA

	* test/infra/Dockerfile.emba (emacs-native-comp): Use
	libgccjit-10-dev.  (Bug#62211)

	* test/infra/gitlab-ci.yml (build-native-comp-speed2)
	(test-native-comp-speed2): Uncomment jobs.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/outline.el (outline--fix-buttons-after-change): Add save-match-data.

	It's important for a hook in after-change-functions not to change match-data.
	Otherwise it breaks functions that make changes in the buffer, such as
	for example, successive calls to delete-region in smerge-keep-n, etc.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Align concatenated strings to the first sibling in c-ts-mode

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Change rule.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Only fill the current paragraph in c-ts-common--fill-block-comment

	* lisp/progmodes/c-ts-common.el:
	(c-ts-common--fill-block-comment): Shrink the filled region to the
	paragraph at point.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add missing indent rule for c-ts-mode

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): New rule for case.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New test.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Improve docstring of treesit-parent-while (bug#62301)

	* doc/lispref/parsing.texi (Retrieving Nodes): Improve and fix
	docstring for treesit-parent-until and treesit-parent-while.
	* lisp/treesit.el (treesit-parent-while): Improve docstring.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: report window/workDoneProgress capability to language server

	In bug#59149, LSP progress reporting was implemented, but Eglot's
	'capabilities' statement to the server wasn't changed to include
	window/workDoneProgress.

	* lisp/progmodes/eglot.el (eglot-client-capabilities): Actually
	report workDoneProgress.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	* lisp/emacs-lisp/comp.el (comp-emit-set-call-subr): Improve 263d6c38539

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Expand defvar-keymap documentation

	* doc/lispref/keymaps.texi (Creating Keymaps): Describe the :repeat keyword.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	* lisp/treesit.el (treesit-end-of-defun): Guard arg against nil (bug#62158).

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	Comp fix calls to redefined primtives with op-bytecode (bug#61917)

	* lisp/emacs-lisp/comp.el (comp-emit-set-call-subr): Fix compilation
	of calls to redefined primtives with dedicated op-bytecode.
	* test/src/comp-tests.el (61917-1): New test.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Warn package authors away from keymap-unset with REMOVE

	* doc/lispref/keymaps.texi (Changing Key Bindings): Ask package
	authors to not use the REMOVE argument to `keymap-unset'.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Comment out jobs on EMBA

	* test/infra/gitlab-ci.yml: Comment out jobs due to bug#62210 and
	bug#62211.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Improve defvar-keymap docstring.

	* lisp/keymap.el (defvar-keymap): Improve description of ':enter' and
	':exit' usage for ':repeat' keyword.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Improve warning about changing the string returned by symbol-name

	* src/data.c (Fsymbol_name): Add warning.  See bug#62009.

	* doc/lispref/symbols.texi (Creating Symbols): Improve warning.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix visiting XBM/XPM files when 'c-ts-mode' is active

	* lisp/progmodes/c-ts-mode.el (treesit-ready-p): Fix association
	for XBM/XPM files in 'auto-mode-alist'.  (Bug#62276)

2023-04-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/mpc.el (mpc-format): Fix oversight in commit 48b6cec61cf

2023-04-15  João Távora  <joaotavora@gmail.com>

	Bail early from eglot--apply-text-edits if nothing to do

	* lisp/progmodes/eglot.el (eglot--apply-text-edits): Early return.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Improve ergonomics of Eglot's inlay hints

	Instead of deleting inlay hints instantly as soon as the affected
	changes, make hint overlays span one character (instead of being
	length 0).  Give the overlays an "evaporate" property.

	Given an inlay hints at position POS, its attached to [POS, POS+1] if
	it's kind=1 (usually type hints) and [POS-1, POS] otherwise.  For
	kind=1 hints, the 'cursor position of the first such overlay is also
	tweaked, so that's it's less akward to edit around it.

	* lisp/progmodes/eglot.el (eglot--before-change): Don't delete hints
	  here.
	  (eglot--update-hints-1): Rework.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Protect against too large size of 'recent-keys' vector

	* src/keyboard.c (MAX_NUM_RECENT_KEYS): New macro.
	(Flossage_size): Don't allow specifying too large lossage-size.
	Fix data types.  (Bug#62277)

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/net/tramp.el (tramp-yn-prompt-regexp): Fix regexp.

2023-04-15  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.1-48-g92471e

2023-04-15  João Távora  <joaotavora@gmail.com>

	Merge confusing duplicate sections on commands in Eglot manual

	Also describe eglot-diagnostics-map.

	* doc/misc/eglot.texi (Eglot Features): Don't describe commands here.
	(Eglot Commands): Describe commands here.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Don't take over mouse-1 binding on Eglot diagnostics (bug#62157)

	It's better to give the user a variable to allow the overlay keymap to
	be customized.

	* lisp/progmodes/eglot.el (eglot--mouse-call): Accept second arg.
	(eglot--mode-line-props): Adapt call to eglot--mouse-call
	(eglot-diagnostics-map): New variable.
	(eglot-code-actions-at-mouse): New command.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/progmodes/eglot.el (eglot--connect): Improve Tramp workaround.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Avoid slowdowns in xmltok-scan-attributes

	* lisp/nxml/xmltok.el (xmltok-scan-attributes): Limit the search
	to 10000 characters, to avoid slowdowns due to the quadratic
	complexity of the regexp.  Suggested by Stefan Monnier.

2023-04-15  Alan Mackenzie  <acm@muc.de>

	CC Mode: Eliminate duplicate function c-list-of-strings

	Replace it with the existing c-string-list-p.  Also put an autoload cookie in
	front of c-string-list-p so that it will not be signalled as undefined by
	loaddefs.el.

	lisp/progmodes/cc-vars.el (c-string-list-p): Make this autoload.
	(c-list-of-strings): Remove.
	(c-font-lock-extra-types, c++-font-lock-extra-types)
	(objc-font-lock-extra-types, java-font-lock-extra-types)
	(idl-font-lock-extra-types, pike-font-lock-extra-types): In the autoload
	cookies, replace c-list-of-strings with c-string-list-p.

2023-04-15  Alan Mackenzie  <acm@muc.de>

	CC Mode: Allow lists of strings as safe values for *-font-lock-extra-types

	* lisp/progmodes/cc-vars.el (c-list-of-strings): New function.
	(c-font-lock-extra-types, c++-font-lock-extra-types)
	(objc-font-lock-extra-types, java-font-lock-extra-types)
	(idl-font-lock-extra-types, pike-font-lock-extra-types): Add a :safe entry
	into each of thes defcustoms for c-list-of-string.
	(Top level): Add an autoload entry for each of the above.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Add tests for Bug#62207

	* test/src/keymap-tests.el (keymap-unset-test-remove-and-inheritance):
	New test.

2023-04-15  Manuel Giraud  <manuel@ledu-giraud.fr>

	Fix 'find-ls-option-default-ls' for BSD/MacOS (bug#62096)

	* lisp/find-dired.el (find-ls-option-default-ls): Adapt to
	a value that works with the default "find" on *BSD and
	Darwin/MacOS.  Tested on OpenBSD and MacOS.  Do not merge
	to master.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Enhance section about troubleshooting in Eglot manual.

	* doc/misc/eglot.texi (Troubleshooting Eglot): Parially rewrite.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Fix Eglot's snippet insertion to follow the manual

	The manual states that YASnippet must only be installed to be useful.
	Before this change, it would only work if the user happened to have
	manually activated it before with 'yas-global-mode' or somesuch.

	This makes Eglot's Yasnippet-activating behaviour similar to its
	Flymake-activating behaviour.

	* lisp/progmodes/eglot.el (eglot-client-capabilities): Consult
	eglot--stay-out-of.
	(eglot--snippet-expansion-fn): Turn on yas-minor-mod eon demand.
	(eglot-completion-at-point): Simplify.

2023-04-15  Filipp Gunbin  <fgunbin@fastmail.fm>

	Reset abbrevs-changed after saving abbrevs (bug#62208)

	* lisp/abbrev.el (abbrev--possibly-save): Reset abbrevs-changed after
	saving abbrevs.
	* test/lisp/abbrev-tests.el (abbrev--possibly-save-test): New test.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Document `keymap-unset' in lispref

	* doc/lispref/keymaps.texi (Changing Key Bindings): Document
	keymap-unset.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Don't add a key binding when REMOVE is non-nil

	* src/keymap.c (store_in_keymap): Don't add a nil keybinding if we've
	been asked to remove a non-existent binding.  (Bug#62207)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix the documentation of various aspects of adding Xref history

	* lisp/progmodes/xref.el (xref-marker-ring-length)
	(xref-set-marker-ring-length):
	* lisp/progmodes/etags.el (tags-location-ring-length)
	(find-tag-marker-ring): Add doc strings saying the variables are
	unused.

	* etc/NEWS: Enhance the description of the change which made Xref
	marker stack unlimited in its length.

	* doc/emacs/maintaining.texi (Looking Up Identifiers): Add back
	text lost when xref forward history was added in bug#38797.
	Explain the difference between 'C-M-,' and 'M-.'.  Improve
	wording (Bug#62229)

2023-04-15  kobarity  <kobarity@gmail.com>

	Fix python-fill-paragraph problems on filling strings (bug#62142)

	* lisp/progmodes/python.el (python-syntax--context-compiler-macro)
	(python-syntax-context): Add single-quoted-string and
	triple-quoted-string as TYPE argument.
	(python-info-triple-quoted-string-p): New helper function.
	(python-fill-paragraph)
	(python-fill-string): Use it.
	* test/lisp/progmodes/python-tests.el (python-syntax-context-1)
	(python-fill-paragraph-single-quoted-string-1)
	(python-fill-paragraph-single-quoted-string-2)
	(python-fill-paragraph-triple-quoted-string-1)
	(python-info-triple-quoted-string-p-1)
	(python-info-triple-quoted-string-p-2)
	(python-info-triple-quoted-string-p-3): New tests.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Also exempt eglot-inlay-hints-mode from desktop.el's fumblings

	Reported in https://github.com/joaotavora/eglot/discussions/1183.

	* lisp/progmodes/eglot.el (desktop): Also exempt
	eglot-inlay-hints-mode from desktop.el fumblings.

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	Refer to EWW instead of w3 and w3m

	* doc/misc/idlwave.texi (Help with HTML Documentation): Refer to EWW
	instead of w3 and w3m.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Fix Eglot's command generation for code actions

	The user command generated by eglot--code-action should always call
	eglot-code-actions with a INTERACTIVE set to t.

	Reported in https://github.com/joaotavora/eglot/issues/1132.

	* lisp/progmodes/eglot.el (eglot--code-action): Pass INTERACTIVE=t to
	eglot-code-action call.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Emphasize emacs-29-specificity in this version of lisp/progmodes/eglot.el

	Do not merge to master.

	Before working on bugfixes to Eglot in its non-ELPA form delivered
	with Emacs 29, it's important to distinguish between this emacs-29
	version and the one in master, which will also get the bugfixes (via
	routine gitmerge.el) but with a bumped version number.

	* lisp/progmodes/eglot.el (Version): Emphasize Emacs 29, but hint this
	is 1.12 + something.
	(Package-Requires): Remove.  Everything required is already in Emacs
	29.

2023-04-15  USAMI Kenta  <tadsan@zonu.me>

	Fix quoting of font-family in 'hfy-family'

	Running "M-x htmlfontify-buffer" in one buffer, the exported HTML contains
	lines like:

	  body, pre { text-decoration: none;  font-family: Migu 2M;  font-stretch:
	  normal;  font-weight: 500;  font-style: normal;  color: #ffffff;
	  background: #000000;  font-size: 15pt; }

	Standards-compliant web browsers should ignore this font-family.

	MDN Web Docs says:
	https://developer.mozilla.org/en-US/docs/Web/CSS/font-family

	  Valid family names
	  Font family names must either be given quoted as strings, or unquoted as
	  a sequence of one or more identifiers. This means that punctuation
	  characters and digits at the start of each token must be escaped in
	  unquoted font family names.

	  It is a good practice to quote font family names that contain white
	  space, digits, or punctuation characters other than hyphens.

	An unquoted font-family is valid as long as it doesn't start with a digit,
	but MDN Web Docs also says:

	  The following example is technically valid but is not recommended:
	  font-family: Gill Sans Extrabold, sans-serif;

	So it makes sense to quote all font-family.

	* lisp/htmlfontify.el (hfy-family): Quote 'font-family'.  (Bug#62054)

2023-04-15  Michael Eliachevitch  <m.eliachevitch@posteo.de>  (tiny change)

	Document how to construct JSONRPC arrays in Eglot manual

	Many language server configuration options are of the JSON array
	datatype, for example argument lists for executables, but there wasn't
	any example of that in the Eglot manual.

	* doc/misc/eglot.texi (User-specific configuration)
	(User-specific configuration): Tweaks.
	(JSONRPC objects in Elisp): Mention JSON arrays. Tweak example.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	* test/infra/Dockerfile.emba: Use debian:bullseye.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	* configure.ac: Fix native comp compatibility check (bug#61960)

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	* test/infra/Dockerfile.emba: Install clangd.

2023-04-15  Philip Kaludercic  <philipk@posteo.net>

	Remove 'package-vc--query-spec'

	* lisp/emacs-lisp/package-vc.el (require): Do not load `inline' during
	compilation.
	(package-vc--query-spec): Remove function.
	(package-vc--clone): Do not call 'package-vc--query-spec'.

2023-04-15  Philip Kaludercic  <philipk@posteo.net>

	Do not store :lisp-dir in package descriptors

	* lisp/emacs-lisp/package-vc.el (package-vc--main-file)
	(package-vc--unpack-1): Query 'pkg-spec' instead of
	'package-desc-extras'.
	(package-vc--unpack): Do not update 'package-desc-extras'.

	This simplification is possible due to the change in 2718bbb3bc, since
	we now ensure that package specifications are not lost.  They are
	either provided by a package archive or stored in
	'package-vc-selected-packages'.

2023-04-15  Philip Kaludercic  <philipk@posteo.net>

	Use 'package-vc-selected-packages' to store package specs

	* doc/emacs/package.texi (Fetching Package Sources): Do not promote
	the usage of 'package-vc-selected-packages' to install packages.
	* lisp/emacs-lisp/package-vc.el (package-vc-selected-packages): Remove
	custom setter and change docstring according to these changes.
	(package-vc--desc->spec): Consult 'package-vc-selected-packages' for
	package specifications.
	(package-vc--unpack): Add unknown package specifications to
	'package-vc-selected-packages'

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/progmodes/xref.el: Bump the version.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/progmodes/xref.el (xref--xref-buffer-mode): Split up 'setq-local'.

	xref.el needs to support 26.1, but an arbitrary number of variables
	in 'setq-local' was added in Emacs 27.1 (bug#62162).

2023-04-15  Filipp Gunbin  <fgunbin@fastmail.fm>

	Fix import of keys in buffer created by epa-search-keys

	* lisp/epa-ks.el (epa-ks--query-url): Add operation parameter.
	(epa-ks--fetch-key, epa-search-keys): Use it.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Fix connection-local variables settings


	* lisp/files-x.el (connection-local-set-profiles)
	(connection-local-set-profile-variables): Use NOW when calling
	`custom-set-variables'.

	* test/lisp/files-x-tests.el
	(files-x-test-connection-local-set-profile-variables)
	(files-x-test-connection-local-update-profile-variables)
	(files-x-test-connection-local-set-profiles)
	(files-x-test-hack-connection-local-variables-apply)
	(files-x-test-with-connection-local-variables)
	(files-x-test-setq-connection-local): Fix tests.

	* test/lisp/net/tramp-tests.el (tramp-test34-connection-local-variables)
	(tramp-test34-explicit-shell-file-name): Fix tests.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Bump Eglot version to 1.12

	* etc/EGLOT-NEWS: New file.

	* etc/NEWS: Briefly mention etc/EGLOT-NEWS.

	* lisp/progmodes/eglot.el: Bump versions.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Update Eglot's manual about eglot-workspace-configuration

	There is a possible use for a global setting
	eglot-workspace-configuration, which is to (ab)use it to set
	user-specific configuration when the server doesn't permit other
	methods.  Rearrange the "Advanced server configuration" section and
	describe that use in the manual.

	* doc/misc/eglot.texi (Project-specific configuration): Correct
	mistake about global usefulness of eglot-workspace-configuration.
	(Advanced server configuration): Swap order of sections.
	(User-specific configuration): Mention possibility of globally
	setting eglot-workspace-configuration.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Amend last Eglot commit (bug#62065)

	The fix contained a spurious check for this-command that shouldn't
	have made it in..

	* lisp/progmodes/eglot.el (eglot-ensure): Don't check this-command.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Make eglot-ensure's post-command-hook run a bit later (bug#62065)

	'eglot-ensure', typically used in the major-mode-hook, use
	'post-command-hook' to schedule an automated, non-interactive
	connection attempt to a server.  The goal is to connect when the
	buffer is ready, i.e. after the user command that found the file.

	However, if there are dir-local or buffer-local variables to confirm,
	finding the file will cause a minibuffer prompt to appear.

	In that case, 'eglot-ensure's addition to the global post-command-hook
	runs before it was intended too and a connection is started
	prematurely.

	In turn, this means that a call to 'hack-dir-local-variables' -- which
	is part of the connection process -- which also needs a minibuffer
	prompt, collides with the previous one.  This generates an error and
	confuses the user, who doesn't know if the directory-local variables
	have been applied or not.

	This commit fixes the clash by having 'eglot-ensure' set
	'post-command-hook' buffer-locally.  This causes the automated
	connection to take place, as intended, after the user's original
	file-finding command has ended.

	However, the problem reported in bug#62065 is not completely fixed.
	If the user answers "no" to the first "confirm local variables"
	"prompt, she will be prompted again in the second one.  A subsequent
	commit will address this separate problem.

	* lisp/progmodes/eglot.el (eglot-ensure): Use buffer-local post-command-hook.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix display of disabled-command help text

	* lisp/novice.el (disabled-command-function): Improve wording, and
	make sure the prompt doesn't exceed one screen line, so that the
	mini-window is not resized (which gets in the way of fitting the
	window to the size of the help text), and the help text is fully
	visible when Emacs prompts for input.  (Bug#62146)

2023-04-15  Mattias Engdegård  <mattiase@acm.org>

	Remove mention of old dotted-list reader quirk from manual

	* doc/lispref/objects.texi (Dotted Pair Notation):
	The (. X) reader peculiarity is no more (bug#62020).

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix value history shown for 'gc-cons-percentage'

	When Emacs is built, temacs is run in batch mode, so if we enlarge
	'gc-cons-percentage' in that case, the enlarged value will be
	"remembered" by the dumped Emacs, and will show confusing
	information in "C-h v", claiming that the original value was 1.0.
	Keeping the value at 0.1 during dumping avoids that.

	* src/emacs.c (main): Increase 'gc-cons-percentage' in batch mode
	only if we are not initializing (a.k.a. "dumping") Emacs.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	TRework fix for bug#62106

	* lisp/files-x.el (connection-local-set-profiles)
	(connection-local-set-profile-variables):
	Use `custom-set-variables'.  It serves the purpose to not keep
	unsaved user options, and it is less invasive than
	`customize-save-variable'.

2023-04-15  Randy Taylor  <dev@rjt.dev>

	Add missing indentation rule for rust-ts-mode (Bug#62109)

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--indent-rules): Add
	missing rule.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Fix bug#62106

	* lisp/files-x.el (connection-local-set-profiles)
	(connection-local-set-profile-variables):
	Use `customize-save-variable' instead of `customize-set-variable'.
	(Bug#62106)

2023-04-15  Randy Taylor  <dev@rjt.dev>

	Add missing rust-ts-mode highlight query for scoped_type_identifiers

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--font-lock-settings):
	Add missing query.

2023-04-15  kobarity  <kobarity@gmail.com>

	Make "case" keyword a dedenter in Python

	* lisp/progmodes/python.el (python-rx): Add "case" to dedenter.
	(python-info-dedenter-opening-block-positions): Add "case" to pairs.
	* test/lisp/progmodes/python-tests.el (python-indent-dedenters-9):
	New test.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix decoding non-ASCII file names in zip archives on MS-Windows

	* lisp/arc-mode.el (archive-zip-summarize): On MS-Windows,
	override archive-file-name-coding-system for files compressed
	on MS-Windows, and use the local console encoding instead.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix copying binary files from zip archives

	* lisp/arc-mode.el (archive-copy-file): Prevent any coding
	conversions when writing output files.  (Bug#62091)

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Skip ruby-ts-syntax-propertize-symbol unless treesitter is available

	 *
	 test/lisp/progmodes/ruby-ts-mode-tests.el (ruby-ts-syntax-propertize-symbol):
	 Add check for treesitter.

2023-04-15  Randy Taylor  <dev@rjt.dev>

	Fix enums and unions appearing as structs in c-ts-base-mode's imenu

	* lisp/progmodes/c-ts-mode.el (c-ts-base-mode): Separate enums and unions out
	from structs.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Fine-tune s-p-f on symbols (bug#62086)

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--s-p-query):
	Don't match ':' in symbol node text.  Or '_', I suppose.
	(ruby-ts--syntax-propertize): Make sure to only put the '_' syntax
	on punctuation syntax characters, and not on the whole symbol (to
	e.g. have symbols like :foo? include text recognized as word).

	* test/lisp/progmodes/ruby-ts-mode-tests.el
	(ruby-ts-syntax-propertize-symbol): New test.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	python-info-dedenter-opening-block-positions: Fix to support "bare" match

	* lisp/progmodes/python.el
	(python-info-dedenter-opening-block-positions): Make the check
	stricter.  Require that block starts only at indentation.

	* test/lisp/progmodes/python-tests.el
	(python-indent-after-bare-match): Another test (bug#62031).

2023-04-15  João Távora  <joaotavora@gmail.com>

	Autoload Eglot helper funtion eglot--debbugs-or-github-bug-uri

	This isn't a typical autoload: the progn block is plced in the
	autoloads file, but the eglot.el file itself isn't loaded as a result
	when the function inside the progn block is called.

	* lisp/progmodes/eglot.el (eglot--debbugs-or-github-bug-uri):
	autoload, but in progn.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Add chapter on advanced server configuration to Eglot manual

	* doc/misc/eglot.texi (Top): Add section "Advanced server configuration"
	(Setting Up LSP Servers): Rework.
	(Advanced server configuration): New chapter.

2023-04-15  Vincenzo Pupillo  <v.pupillo@gmail.com>  (tiny change)

	java-ts-mode: detect if text_block is supported.

	A recent commit in tree-sitter-java (issue #141) removed support for
	the text_block node type from the grammar. To support the old released
	version and the new one, a helper function was added on which the
	string syntax highlighting now depends. (bug#61913)

	* lisp/progmodes/java-ts-mode.el
	(java-ts-mode--string-highlight-helper): New helper function that
	return the right query string
	(java-ts-mode--font-lock-settings): Use it

2023-04-15  kobarity  <kobarity@gmail.com>

	Revert workaround introduced in Bug#56271

	* lisp/progmodes/python.el (python-nav-end-of-statement)
	(python-nav-end-of-block): Revert workaround introduced in Bug#56271
	as the bug is fixedin Bug#58780.

2023-04-15  kobarity  <kobarity@gmail.com>

	Fix searching for end of string in python-nav-end-of-statement

	* lisp/progmodes/python.el (python-nav-end-of-statement): Add
	searching for corresponding string-quote.
	* test/lisp/progmodes/python-tests.el (python-nav-end-of-statement-3)
	(python-nav-end-of-statement-4, python-info-current-defun-4): New
	tests. (Bug#58780)

2023-04-15  Po Lu  <luangruo@yahoo.com>

	Fix libwebp check for some webp installations

	* configure.ac: Look for WebPGetInfo; if it is not there, look
	for libwebpdecoder as well.  (bug#61988)

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Avoid potential infloop

	* lisp/progmodes/python.el
	(python-info-dedenter-opening-block-positions):
	Avoid potential infloop (bug#62031).

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>
	    Lele Gaifax  <lele@metapensiero.it>

	Don't misindent 'else:' after 'if re.match:' in Python

	* lisp/progmodes/python.el
	(python-info-dedenter-opening-block-positions): Check that the
	supposed block start is not a method call (bug#62031).

	* test/lisp/progmodes/python-tests.el (python-indent-after-re-match):
	New test.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	* Make sure `default-directory' exists before spawning processes (bug#62004)

	* lisp/emacs-lisp/comp.el (comp-final, comp-run-async-workers): Bind
	`default-directory' to `invocation-directory'.

2023-04-15  Ulrich Müller  <ulm@gentoo.org>

	Fix sed expression in install-etc make target

	* Makefile.in (install-etc): Fix sed expression for emacsclient
	desktop files.  (Bug#62045)

2023-04-15  Ulrich Müller  <ulm@gentoo.org>

	Avoid using bash in the emacsclient desktop file

	* etc/emacsclient-mail.desktop (Exec): Use sh and sed instead
	of bash, because the latter may not be available everywhere.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of the 'line-height' text property

	* doc/lispref/display.texi (Line Height): More accurate
	documentation of the value t of 'line-height' text property.
	(Bug#62048)

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Add 'declare' specs to with- and without-restriction

	* lisp/subr.el (with-restriction):
	(without-restriction): Add 'declare' specs.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix empty line indentation in c-ts-mode (bug#61997)

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--indent-styles): Handle the empty line case.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New test.

	* doc/lispref/modes.texi (Parser-based Indentation): Update manual.
	* lisp/treesit.el (treesit-simple-indent-presets): Support null as
	a value for NODE-TYPE in the 'match' matcher.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix tree-sitter indent preset prev-line (bug#61998)

	* lisp/treesit.el (treesit-simple-indent-presets): Fix return value.

2023-04-15  Manuel Giraud  <manuel@ledu-giraud.fr>

	Revert 'forward-sentence-default-function' to return point (bug#62027)

	* lisp/textmodes/paragraphs.el
	(forward-sentence-default-function): Revert to return the
	position of point.
	(count-sentences): Adapt to this change.

2023-04-15  Ulrich Müller  <ulm@gentoo.org>

	Fix Elisp code injection vulnerability in emacsclient-mail.desktop

	A crafted mailto URI could contain unescaped double-quote
	characters, allowing injection of Elisp code.  Therefore, any
	'\' and '"' characters are replaced by '\\' and '\"', using Bash
	pattern substitution (which is not available in the POSIX shell).

	We want to pass literal 'u=${1//\\/\\\\}; u=${u//\"/\\\"};' in the
	bash -c command, but in the desktop entry '"', '$', and '\' must
	be escaped as '\\"', '\\$', and '\\\\', respectively (backslashes
	are expanded twice, see the Desktop Entry Specification).

	Reported by Gabriel Corona <gabriel.corona@free.fr>.

	* etc/emacsclient-mail.desktop (Exec): Escape backslash and
	double-quote characters.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix problem with debuginfod queries in "M-x gdb"

	* lisp/progmodes/gdb-mi.el (gdb-debuginfod-enable-setting): New
	defcustom.
	(gdb-debuginfod-message): New function.
	(gdb-init-1): Initialize gdb-debuginfod-enable.  Ask the user
	about debuginfod queries and display any error messages.
	(Bug#61973)

	* etc/NEWS: Announce the change.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Fix regression in Fido mode (bug#62015)

	To understand the regression consider this recipe where the 'fo'
	pattern is typed by the user in the last step.

	   emacs -Q
	   C-x b foo RET
	   C-x b afoo RET
	   C-x b *scratch* RET
	   M-x fido-mode RET
	   C-x b fo

	This used to offer both 'foo' and 'afoo' as candidates but now only
	offered 'foo'.  This is because the pattern 'fo' matches 'foo', but
	not 'afoo' with 'basic' completion style.

	Fido mode, however, prioritizes 'flex' completion style, and that is
	not happening here as it used to.

	This was introduced in this commit

	     commit bf81df86e52fdc995bec8d9646f84d114cb896d1
	     Author: João Távora <joaotavora@gmail.com>
	     Date:   Wed Dec 7 10:43:59 2022 +0000

	         Don't override completion-category-defaults in fido-mode

	I took away the nil setting of 'completion-category-defaults; in Fido
	mode's minibuffer. It seemed generally the correct thing to do, and
	was done mainly because Eglot added its style preferences to that
	variable instead of completion-category-overrides directly, which is a
	nono.  So, to be able use the Fido UI with Eglot successfully,
	'completion-category-defaults' should stay untouched.  Or so I
	thought.

	However, I failed to notice that, for most categories, the default
	value of 'completion-category-defaults' prioritizes the 'basic'
	completion style.

	For example, in the 'buffer' category, the default value has the
	styles list '(basic substring)'.  This means that if a pattern matches
	accoring to the 'basic' style, 'substring' will not be tried.  And
	neither will 'completion-styles' which in Fido mode's case happens to
	be 'flex'.

	The solution in this commit is to craft a value for completion
	category defaults that is just like the default one, but prioritizes
	'flex' completion for every category.

	* lisp/icomplete.el (icomplete--fido-ccd): New helper.
	(icomplete--fido-mode-setup): Use it.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	* Fix `emacs-lisp-native-compile-and-load' for (bug#61917)

	* lisp/progmodes/elisp-mode.el (emacs-lisp-native-compile-and-load):
	Don't load if no compialtion happened.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	* lisp/emacs-lisp/comp.el (comp-prettyformat-insn): Fix (bug#61917)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Revert "Fix configuration of webp libraries"

	This reverts commit de4277af009115ceba7fe920163c05c608ea9524.
	It breaks WebP support at least on my system.
	There's no reason to require libwebpdecoder library to be
	installed, since we don't use the functions from it, at least
	not in libwebp 1.2.1.

2023-04-15  Po Lu  <luangruo@yahoo.com>

	Fix configuration of webp libraries

	* configure.ac: Link with libwebpdecoder along with
	libwebpdemux.  (bug#61988)

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation

	Mentioned in bug#61893.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--anchor-prev-sibling): Handle
	"#elif" and "#else".
	* test/lisp/progmodes/c-ts-mode-resources/indent-preproc.erts: Add an
	"#elif" to the test.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation

	Mentioned in bug#61893, although not the subject of it.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--anchor-prev-sibling): Fix the child index for preproc_else
	and preproc_elif case.
	* test/lisp/progmodes/c-ts-mode-resources/indent-preproc.erts:
	New test.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation

	Not the subject of it, but mentioned in bug#61893.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--anchor-prev-sibling): Skip
	the sibling if it doesn't start on it's own line.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New test.

2023-04-15  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.1-40-g3d817c

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add string-interpolation feature to bash-ts-mode

	* lisp/progmodes/sh-script.el:
	(bash-ts-mode): Add string-interpolation feature.
	(sh-mode--treesit-settings): Add rule for string-interpolation feature.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Fix tramp-sh-handle-insert-directory

	* lisp/net/tramp-sh.el (tramp-sh-handle-insert-directory): Remove also
	//DIRED-OPTIONS// line when there is no //DIRED// line.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	* Warn when certain primitives are redefined (bug#61880)

		* lisp/emacs-lisp/comp.el (comp-warn-primitives): New constant.
		(comp-subr-trampoline-install): Warn when a sensitive primitive is
		being redefined.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode preproc directive indentation

	Mentioned in bug#61893, although not the subject of that report.  This
	change fixes indentation for nested directives.  For example, when the
	directive involves elif and the like, the elif is nested in the if
	directive, so simply using grand-parent and great-grand-parent for
	anchor is insufficient, because the nesting can grow arbitrarily.

	The test added also covers the last preproc fix.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--standalone-parent-skip-preproc): New function.
	(c-ts-mode--indent-styles): New rules.
	* test/lisp/progmodes/c-ts-mode-resources/indent-preproc.erts: New test.

2023-04-15  João Távora  <joaotavora@gmail.com>

	More robustly unspoof HOME in Eglot tests (bug#61637)

	A fair number of LSP servers allow user-local installations instead of
	system wide installations.  Emacs's technique of spoofing the HOME env
	var to some non-existent or non-home directory during 'make check'
	breaks these tests.  That's because the executables are still found by
	executable-find, but their invocation will rarely be successful as
	HOME isn't what they expect it to be.

	Eglot tests already had a technique for dealing with this,
	"unspoffing" HOME just for the invocations of LSP server but it
	stopped working a while back.  So make it more robust.

	Eventually, we'll want to decide wether these local servers should be
	considered in 'make check' runs at all, or whether there is a way to
	use them with a spoofed HOME.

	* test/lisp/progmodes/eglot-tests.el (eglot--call-with-fixture):
	More robustly unspoof HOME.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Turn on Eglot inlay hints by default

	This is like any other server-provided feature, and may be turned off
	client-side by setting eglot-ignored-server-capabilities like

	   (add-to-list 'eglot-ignored-server-capabilities :inlayHintProvider)

	* lisp/progmodes/eglot.el (eglot--maybe-activate-editing-mode):
	Activate eglot-inlay-hints-mode.
	(eglot-inlay-hints-mode): Instead of warning about missing
	:inlayHintProvider, turn off eglot-inlay-hints-mode.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Update ts modes missed in 4c16fd3a512 to use column-0

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--indent-rules):
	* lisp/progmodes/go-ts-mode.el (go-ts-mode--indent-rules):
	Change point-min anchor to column-0.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Robustify Eglot for "transient" projects

	When Eglot needs to synthesize a "transient" project for
	default-directory sometimes the value of that variable is set to an
	unexpanded value, sometimes not.  This can cause simple invocations
	like.

	   Emacs -Q ~/path/to-some-python-file.py -f eglot

	to fail, because eglot--current-server will be looking for a project
	in the registry called

	    (transient . "~/path")

	where in reality it is stored there as

	    (transient . "/home/someuser/path")

	The fix is to always expand default-directory in eglot--current-project.

	* lisp/progmodes/eglot.el (eglot--current-project): Use
	expand-file-name.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of 'normal-mode' in buffers that don't visit files

	* lisp/files.el (normal-mode):
	* lisp/subr.el (run-mode-hooks):
	* doc/emacs/modes.texi (Choosing Modes): Mention the caveat with
	'normal-mode' in buffers not visiting files.  (Bug#61925)
	* lisp/files.el (hack-local-variables): Doc fix.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Change tree-sitter indent anchor 'point-min' to 'column-0'

	Point-min isn't necessarily at column 0, using line-beginning-position
	is better. column-0 is also more intuitive.

	* doc/lispref/modes.texi (Parser-based Indentation): Update manual.
	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles):
	* lisp/progmodes/java-ts-mode.el (java-ts-mode--indent-rules):
	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--indent-rules):
	* lisp/progmodes/typescript-ts-mode.el:
	(typescript-ts-mode--indent-rules): Change point-min to column-0.
	* lisp/treesit.el (treesit-simple-indent-presets): Change point-min to
	column-0.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix go-ts-mode multi-line string indentation (bug#61923)

	* lisp/progmodes/go-ts-mode.el:
	(go-ts-mode--indent-rules): Add indent rule for multi-line sting.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Remove Eglot activation check from find-file-hook

	Adding eglot--maybe-activate-editing-mode to find-file-hook isn't
	really necessary, since it is already in
	'after-change-major-mode-hook', and that also runs every time we find
	a file.

	This reduces the number of project.el logic that runs every time the
	user visits a file.

	* lisp/progmodes/eglot.el (find-file-hook): No need to add
	eglot--maybe-activate-editing-mode here.

2023-04-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* src/intervals.c (set_intervals_multibyte_1): Fix bug#61887

	When `total_length` is 0 there should be no subtree at all, but
	`delete_interval` only deletes one interval, so make sure we don't end
	up with some stale child of `i`.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Revert inadvertent change to lisp/icomplete.el in previous commit

	The change

	   commit 3a651773d29afb48ac4229cd19e532bd57a4ee2d
	   Author: João Távora <joaotavora@gmail.com>
	   Date:   Fri Mar 3 13:13:35 2023 +0000

	       Eglot: pay better attention to hints' paddingLeft/Right (bug#61924)

	Inadvertently added a line to this file, which shouldn't (yet) bet
	added.

	* lisp/icomplete.el (icomplete--vertical-minibuffer-setup): Remove
	truncate-lines.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Revert previous change in go-ts-mode.el

	Reverts 59365f928565f1be551b1697b9246b00cb87a9b7 and
	56cd810b9d1a4d537bee5a2fd954d6e0d346631a.

	Reverting because the use of treesit-ready-p is very much intentional.

	* lisp/progmodes/go-ts-mode.el (treesit-ready-p): Revert change.

2023-04-15  F. Jason Park  <jp@neverwas.me>

	Release ERC 5.5

	* doc/misc/erc.texi: Update ERCVER to 5.5.
	* lisp/erc/erc.el: Increment main version header to 5.5.  Update
	Compat version in package-requires header to 29.1.3.4.  Update
	`customize-package-emacs-version-alist' entry by mapping ERC 5.5 to
	Emacs 29.1.
	(erc-version): Update value to 5.5.

2023-04-15  Jim Porter  <jporterbugs@gmail.com>

	Don't create GUI frames in batch sessions

	This resolves an issue with running test/lisp/server-tests.el when
	'DISPLAY' is set: the tests would start the Emacs server in a batch
	session, and then request a new GUI frame.  However, that caused the
	tests to terminate with SIGIO, since a batch Emacs doesn't set a SIGIO
	handler.

	Ref: <https://lists.gnu.org/archive/html/emacs-devel/2023-02/msg00879.html>

	* lisp/frame.el (make-frame): Always create a terminal frame in batch
	sessions.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Minor copyedits of documentation of OClosures

	* doc/lispref/functions.texi (OClosures): Improve wording,
	indexing, and markup; add details.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: pay better attention to hints' paddingLeft/Right (bug#61924)

	* lisp/progmodes/eglot.el (eglot--update-hints-1): Consider
	:json-false, which is a non-nil value.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation for statement after preproc (bug#61893)

	Originally our c-ts-mode--anchor-prev-sibling only specially handled
	labeled_statements, now we add special case for preproc in the similar
	fasion: instead of using the preproc directive as anchor, use the last
	statement in that preproc as the anchor. Thus effectively ignore the
	preproc.

	There should be an accompanying test, but there are some problem in
	the elif preproc directive indent so it would pass, we'll add the test
	when that is fixed.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--anchor-prev-sibling): Add special case for preproc
	directives.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix c/c++-ts-mode's mode lighter

	* lisp/progmodes/c-ts-mode.el (c-ts-mode-set-modeline): Remove
	trailing blank from comment-start when indicating the comment
	style on the mode line.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: use shell-file-name in eglot--cmd (bug#61748)

	* lisp/progmodes/eglot.el (eglot--cmd): Use shell-file-name.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Avoid signaling errors in url-basic-auth when password is nil

	* lisp/url/url-auth.el (url-basic-auth): Handle nil PASS.
	Suggested by Ellis Kenyo <me@elken.dev>.  (Bug#61411)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix wdired-tests on MS-Windows

	* test/lisp/wdired-tests.el (wdired-test-bug32173-01)
	(wdired-test-bug32173-02, wdired-test-unfinished-edit-01)
	(wdired-test-bug39280): Run test-dir through file-truename, to
	avoid failures due to MS-Windows "numeric tails" (mis)feature and
	similar issues, which make file names fail to compare 'equal'.
	(wdired-test-bug34915, wdired-test-bug61510): Skip if symlinks
	fail.

2023-04-15  Andrew De Angelis  <bobodeangelis@gmail.com>

	Improvements to xwidget on macOS (bug#60703)

	* src/nsxwidget.m ()
	([XwWebView initWithFrame:configuration:xwidget:])
	(nsxwidget_init):  Fixed memory leaks: when sending an alloc
	message to an object, send an autorelease message to any objects
	we won't explictly release.
	([XwWebView webView:didFinishNavigation:]): Second string to
	store in 'store_xwidget_event_string' is "load finished" rather
	than empty string.
	([XwWebView webView:didStartProvisionalNavigation:])
	([XwWebView webView:didReceiveServerRedirectForProvisionalNavigation:])
	([XwWebView webView:didCommitNavigation:]): New functions.
	(nsxwidget_webkit_estimated_load_progress): New function.
	(nsxwidget_webkit_stop_loading): New function.
	* src/xwidget.c (Fxwidget_webkit_estimated_load_progress): Call
	'nsxwidget_webkit_estimated_load_progress' if we're on MacOS.
	(Fxwidget_webkit_stop_loading): Call 'nsxwidget_webkit_stop_loading'
	if we're on MacOS.
	(syms_of_xwidget): Define symbol for function.
	'xwidget_webkit_estimated_load_progress' if we're on MacOS.
	* src/nsxwidget.h: Signature for functions
	'nsxwidget_webkit_estimated_load_progress' and
	'nsxwidget_webkit_stop_loading'.
	* lisp/xwidget.el (xwidget-webkit-current-url): Message URL rather
	than return value of 'kill-new' (which is always nil).

2023-04-15  Yuan Fu  <casouri@gmail.com>

	* lisp/progmodes/go-ts-mode.el: Use treesit-language-available-p.

	treesit-ready-p does more checks than language grammar availability.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Don’t signal warning when loading go-ts-mode.el without grammar

	* lisp/progmodes/go-ts-mode.el: Add a QUIET flag to the call of
	treesit-ready-p, so that it doesn't signal a warning if
	go-mod (tree-sitter grammar) is not available.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode empty line indentation (bug#61893)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Make the
	"rest sibling" matchers catch the case where NODE is nil, when
	indenting an empty line.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New test.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Improve tree-sitter's prev-sibling indent anchor

	Now it handles the case where NODE is nil when indenting an empty
	line: it tries to get the previous sibling nonetheless.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--anchor-prev-sibling):
	* lisp/treesit.el (treesit-simple-indent-presets): Add an or form to
	handle more cases.

2023-04-15  João Távora  <joaotavora@gmail.com>

	* lisp/icomplete.el (fido-mode): Enable in-buffer completion (bug#45763).

	Backport:
	(cherry picked from commit b5c13032538377b0037c745715613693a1580f81)

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/icomplete.el: Fix in-buffer completion.

	(icomplete-force-complete-and-exit, icomplete-force-complete): Use
	'icomplete--field-beg/end' when not in the minibuffer to not erase
	the current buffer.  Also disable 'completion-in-region-mode' instead
	of calling 'exit-minibuffer' (bug#45764, bug#51575, bug#61479).

	Backport:
	(cherry picked from commit a7a984c0ebebb891e2052d8416544f0bd7002007)

2023-04-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* src/profiler.c (malloc_probe): Make it safe for GC (bug#60237)

2023-04-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/emacs-lisp/debug-early.el (debug-early-backtrace): Fix bug#61847

	The `noerror` arg of `require` doesn't do what Stefan naively thought
	when he wrote this code, so use `condition-case` instead.
	Also check for `cl-defmethod` since `cl-prin1` can't be loaded before
	that anyway.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Revert "Don't disable eldoc when doing edebug"

	This reverts commit 6fd1fb8a6837acde8e1c9ab26618ec0f36121c72.
	It turns out ElDoc does show messages inside Edebug, if you
	are (un)lucky enough to have point where ElDoc has something
	to show.  Bug#56459 needs to be fixed in some more complex
	way.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: work around Tramp instability bug#61350

	Unconditionally disable ControlMaster for the Eglot's Tramp
	connection.

	* lisp/progmodes/eglot.el (tramp-ssh-controlmaster-options)
	(use-tramp-ssh-controlmaster-options): Forward declare
	(eglot--connect): Set variables to unconditionally disable ControlMaster.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix treesit-indent-region

	Fix it for the case where there is no suitable rule for the line.
	Right now treesit-indent-region would indent the line to column 0.
	After the change the indentation is not altered.

	* lisp/treesit.el (treesit-indent-region): Handle the case where
	ANCHOR or OFFSET is nil specially.

2023-04-15  Po Lu  <luangruo@yahoo.com>

	Replace C++ comments with C style equivalents

	* src/alloc.c (Fmake_byte_code, purecopy):
	* src/bytecode.c (exec_byte_code):
	* src/xdisp.c (face_at_pos): Do not use C++-style comments!

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: fix M-x eglot-show-workspace-configuration (bug#61866)

	Now consult .dir-locals.el every time the workspace configuration is
	needed:

	- workspace/configuration server request
	- workspace/didChangeConfiguration signal
	- M-x eglot-show-workspace-configuration

	The major-mode/hack-dir-local-variables-non-file-buffer trick is used.
	When there is more than one, the server connection's "main" major mode
	is used to find the relevant .dir-locals.el section.

	* lisp/progmodes/eglot.el (eglot--lookup-mode): Fix docstring.
	(eglot--connect): Simplify.
	(eglot-show-workspace-configuration): Fix.
	(eglot--workspace-configuration): Remove.
	(eglot--workspace-configuration-plist): Rework.
	(eglot-handle-request): Simplify.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-mode: Fix method call indentation in rhs of multiple assignment

	* lisp/progmodes/ruby-mode.el (ruby-smie-rules): Special-case
	assignment that follows a comma-separated list (bug#61871).

	* test/lisp/progmodes/ruby-mode-resources/ruby.rb: Add case.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/net/tramp.el (tramp-remote-path): Improve docstring.

2023-04-15  Felix  <felix.dick@web.de>  (tiny change)

	Minor change in 'dired--find-possibly-alternative-file'

	* lisp/dired.el (dired--find-possibly-alternative-file): Don't
	kill the buffer if the directory is shown in other windows.

2023-04-15  Felix  <felix.dick@web.de>  (tiny change)

	Implement prefix arg for 'c-ts-mode-toggle-comment-style'

	* lisp/progmodes/c-ts-mode.el (c-ts-mode-toggle-comment-style):
	Actually implement the optional numeric arg mentioned in the
	docstring.

2023-04-15  Manuel Giraud  <manuel@ledu-giraud.fr>

	Defaults to zero for image-dired--number-of-thumbnails

	* lisp/image/image-dired.el (image-dired--number-of-thumbnails):
	Defaults zero to avoid wrong type argument error.  (Bug#61734)

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Rename the newly added -ref- faces to -use-

	* lisp/font-lock.el (font-lock-variable-use-face)
	(font-lock-property-use-face): Rename from font-lock-variable-ref-face
	and font-lock-property-ref-face.  Update all references (bug#61655).

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: support multiple labels in same inlay hint

	Mainly the rust-analyzer LSP server uses this.  There are still more
	things we could support, like tooltips and stuff.

	* lisp/progmodes/eglot.el (lsp-interface-alist): Add
	InlayHintLabelPart.
	(eglot--update-hints-1): Support multiple labels for same hint.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: don't paint hints outside requested region (bug#61812)

	* lisp/progmodes/eglot.el (eglot--lambda): Add cl-block.
	(eglot--update-hints-1): Return early if hint is outside the
	requested inlay hint range.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: protect against unintended field text motion (bug#61726)

	Suggested-by: Augusto Stoffel <arstoffel@gmail.com>

	* lisp/progmodes/eglot.el (eglot--bol): New helper.
	(eglot-utf-8-linepos, eglot-utf-16-linepos)
	(eglot-utf-32-linepos, eglot-move-to-utf-8-linepos)
	(eglot-move-to-utf-16-linepos, eglot-move-to-utf-32-linepos)
	(eglot-handle-notification, eglot--xref-make-match)
	(eglot-completion-at-point): Use it.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix description of 'desktop-save-mode'

	* doc/emacs/misc.texi (Saving Emacs Sessions): Adjust to changes
	in 'desktop-path'.  Reported by Petteri Hintsanen <petterih@iki.fi>.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Adjust tree-sitter defun navigation (bug#61617)

	Before this change, when you use a tree-sitter navigation function to
	move to the next beginning of a thing, it jumps over the immediate
	next thing and lands you at the beginning of the next-next thing.

	Eg, when point is at the "|", and we evaluate
	(treesit--navigate-thing pos 1 'beg), we go from

	|  (thing) (thing)

	to

	   (thing) |(thing)

	But some might expect point to go to

	   |(thing) (thing)

	instead, which makes sense.  Also, that's how Emacs expect defun
	navigation functions to work.  The discrepancy in expectation causes
	bug#61617.

	In this change I made tree-sitter navigation functions to work as what
	Emacs expects.  And what I described for moving to the next beginning
	of thing is similarly applicable to moving to the end of previous end
	of thing.

	* lisp/treesit.el (treesit-beginning-of-defun)
	(treesit-end-of-defun): Handle the case where defun-skipper moves
	point back to where we started, by adding a retry.

	(treesit--navigate-thing): Add a single condition checking for
	progress to the condition form responsible for checking whether to
	skip the next defun.  Namely (eq pos (funcall advance next)))).

	* test/src/treesit-tests.el:
	(treesit--ert-defun-navigation-nested-master)
	(treesit--ert-defun-navigation-top-level-master): Change tests to
	reflect the new expectation.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Simplify c-ts-mode--top-level-label-matcher

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--top-level-label-matcher): Make more assumptions and remove
	the loop, so it's faster in large files.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	New tree-sitter indent anchor standalone-parent used by c-ts-mode

	When writing c-ts-mode Theo used parent-bol which works well except
	one case:

	1 for (int i=0;
	2      i < 5;
	3      i++) {
	4   func(i);
	5 }

	In this case, when indenting "func(i)", parent-bol returns the start
	of "i++" on line 3, instead of the "correct" anchor, the start of
	"for" on line 1.  parent-bol would have worked if the "for (...) {"
	part is in one line.

	To support this case I tried numerous things and added a bunch of
	stuff, culminating in c-ts-common-statement-offset.  It's complicated,
	requires extra setup, and slow.

	Not anymore! I think the new anchor standalone-parent really captures
	the logic behind how people expect indentation to work. It's simple
	and fast, and requires no setup.

	* doc/lispref/modes.texi (Parser-based Indentation): Update manual.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--standalone-grandparent): New anchor.
	(c-ts-mode--indent-styles): Replace c-ts-common-statement-offset with
	standalone-parent.
	(c-ts-base-mode): Add comment.

	* lisp/treesit.el:
	(treesit-simple-indent-presets): New anchor standalone-parent.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-smie-rules: Fix misindentation of a method call after assignment

	* lisp/progmodes/ruby-mode.el (ruby-smie-rules): Fix indentation of a
	method call after assignment with ruby-after-operator-indent=nil
	(bug#61822).

	* test/lisp/progmodes/ruby-mode-resources/ruby-after-operator-indent.rb:
	Add corresponding example.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	* lib-src/etags.c (process_file_name): Free malloc'ed vars (bug#61819).

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: rename and redocument encoding-related functions (bug#61726)

	* lisp/progmodes/eglot.el (eglot-current-column): Obsolete.
	(eglot-lsp-abiding-column): Obsolete.
	(eglot-current-column-function): Obsolete.
	(eglot-current-linepos-function): Rename from eglot-current-column-function.
	(eglot-utf-8-linepos): Rename from eglot-bytewise-column.
	(eglot-utf-16-linepos): Rename from eglot-lsp-abiding-column.
	(eglot-utf-32-linepos): Rename from eglot-current-column.
	(eglot-move-to-current-column): Obsolete.
	(eglot-move-to-lsp-abiding-column): Obsolete.
	(eglot-move-to-column-function): Obsolete.
	(eglot-move-to-linepos-function): Rename from eglot-move-to-column-function.
	(eglot-move-to-utf-8-linepos): Rename from eglot-move-to-bytewise-column.
	(eglot-move-to-utf-16-linepos): Rename from eglot-move-to-lsp-abiding-column.
	(eglot-move-to-utf-32-linepos): Rename from eglot-move-to-current-column.
	(eglot--managed-mode): Adjust.
	(eglot-client-capabilities): Trim whitespace.

	* test/lisp/progmodes/eglot-tests.el (eglot-test-lsp-abiding-column)
	(eglot-test-lsp-abiding-column-1): Use new function/variable names.

2023-04-15  Augusto Stoffel  <arstoffel@gmail.com>

	Eglot: support positionEncoding LSP capability (bug#61726)

	* lisp/progmodes/eglot.el(eglot-client-capabilities):  Announce the
	new capability.
	(eglot-bytewise-column, eglot-move-to-bytewise-column): New functions.
	(eglot--managed-mode): Set 'eglot-current-column-function' and
	'eglot-move-to-bytewise-column' appropriately.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>
	    Augusto Stoffel  <arstoffel@gmail.com>

	Eglot: use faster strategy for moving to LSP positions (bug#61726)

	Turns out we don't need encode-coding-region after all.

	* lisp/progmodes/eglot.el (eglot-move-to-lsp-abiding-column): Rewrite.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix mule-tests in UTF-8 locales

	* test/lisp/international/mule-tests.el
	(sgml-html-meta-no-post-less-than-10lines): Fix test condition.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix 'vertical-motion' when display strings are around

	* src/indent.c (Fvertical_motion): Correct bidi-related condition
	for character position, when we didn't move vertically.  (Bug#61636)

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	python-ts-mode: Fix single-quote string fontification

	* lisp/progmodes/python.el (python--treesit-fontify-string):
	Look for ', not just ", as opening delimiter (bug#61796).

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix infloop in bidi.c

	* src/bidi.c (bidi_set_paragraph_end): Reset the isolate_level to
	zero.  Whenever stack_idx is reset to zero, the isolate_level must
	also be reset, since there cannot be any isolate status outside of
	embeddings.  Failure to reset isolate_level will cause us infloop
	when we see a PDI.  Reported by Matt Beshara <m@mfa.pw>.

2023-04-15  Daniel Martín  <mardani29@yahoo.es>

	Check the anchor along with the offset in treesit-indent-region

	* lisp/treesit.el (treesit-indent-region): To compute a valid column,
	having a non-nil offset is not enough, we need a non-nil anchor as
	well.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Align to prev sibling for c-ts-mode indentation

	As requested by a discussion on emacs-devel.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--anchor-prev-sibling): New function.
	(c-ts-mode--indent-styles): Indent first child as before, indent the
	rest to their previous sibling.  Remove bracketless statement rules
	that I forgot to remove previously.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-common-statement-offset and c-ts-common--node-is

	* lisp/progmodes/c-ts-common.el:
	(c-ts-common--node-is): Guard against case where the node has no field
	name.
	(c-ts-common-statement-offset): Do indent a level if the "if" in the
	"else if" is on an independent line.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	typescript-ts-mode: Highlight non-shorthand destructuring bindings

	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--font-lock-settings): Highlight non-shorthand
	variable bindings in object destructuring.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Add more/finer faces for tree-sitter

	* doc/lispref/modes.texi (Faces for Font Lock):
	Update the list of faces (bug#61655).

	* etc/NEWS: Update the list of new faces.

	* lisp/cus-theme.el (custom-theme--listed-faces): Update.

	* lisp/font-lock.el (font-lock-function-call-face)
	(font-lock-variable-ref-face, font-lock-property-ref-face):
	New faces.
	(font-lock-property-name-face):
	Rename from 'font-lock-property-face'.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--font-lock-settings):
	Use new faces.  More 'enumerator' query to 'definition' feature.
	(c-ts-mode--fontify-declarator, c-ts-mode--fontify-variable):
	Use new faces.

	* lisp/progmodes/cmake-ts-mode.el
	(cmake-ts-mode--font-lock-settings): Use new faces.

	* lisp/progmodes/csharp-mode.el
	(csharp-ts-mode--font-lock-settings): Use new faces.

	* lisp/progmodes/go-ts-mode.el (go-ts-mode--font-lock-settings):
	Use new faces.

	* lisp/progmodes/java-ts-mode.el
	(java-ts-mode--font-lock-settings): Use new faces.

	* lisp/progmodes/js.el (js--treesit-fontify-assignment-lhs)
	(js--treesit-font-lock-settings): Use new faces.  Highlight
	variable definitions inside array and object destructuring
	patterns.

	* lisp/progmodes/python.el (python--treesit-variable-p):
	Exclude identifiers in parameters.
	(python--treesit-settings): Use new faces.  Highlight function
	parameters.  Move 'keyword' up to still highlight 'self' as
	keyword.

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--font-lock-settings):
	Use new faces.

	* lisp/progmodes/rust-ts-mode.el
	(rust-ts-mode--font-lock-settings): Use new faces.

	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--font-lock-settings): Use new faces.

	* lisp/textmodes/css-mode.el (css--treesit-settings):
	Use font-lock-property-ref-face.

	* lisp/textmodes/toml-ts-mode.el
	(toml-ts-mode--font-lock-settings):
	Use font-lock-property-ref-face.

	* lisp/textmodes/yaml-ts-mode.el
	(yaml-ts-mode--font-lock-settings): Same.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Avoid crashes in batch mode due to lack of frame face cache

	* src/xfaces.c (Finternal_merge_in_global_face): Handle frames
	with no face cache.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Add Tramp version integrated in Emacs 28.3

	* lisp/net/trampver.el (customize-package-emacs-version-alist):
	Add Tramp version integrated in Emacs 28.3.

2023-04-15  Philip Kaludercic  <philipk@posteo.net>

	Avoid reusing :lisp-dir twice in 'package-vc--main-file'

	* lisp/emacs-lisp/package-vc.el (package-vc--main-file): Just use
	:lisp-dir from 'package-desc-extras', not 'pkg-spec'.

	This avoid appending the contents of :lisp-dir twice, in case it is
	specified both in pkg-spec and pkg-desc.

2023-04-15  Philip Kaludercic  <philipk@posteo.net>

	Ensure right package-desc-type before installing package

	* lisp/emacs-lisp/package-vc.el (package-vc--unpack): Move copying
	code from 'package-vc-install'.
	(package-vc-install): Remove copying.  (Bug#61669)

2023-04-15  Stephen Berman  <stephen.berman@gmx.net>

	Restore invisibility of symlink target on exiting wdired-mode

	* lisp/wdired.el (wdired-change-to-dired-mode): Invoke
	dired-hide-details-update-invisibility-spec (bug#61510).

	* test/lisp/wdired-tests.el (wdired-test-bug61510): New test.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: fix jit-lock inlay hint bugs

	One of the bugs was straightforward.  The timer function of
	eglot--update-hints must set the correct buffer.

	The other is much more odd.  When using Eglot on Emacs's own
	src/coding.c, the jit-lock code starts calling its jit-functions over
	and over again with the same sequence of arguments, like so:

	======================================================================
	1 -> (eglot--update-hints 63551 65051)
	1 <- eglot--update-hints: [nil 25592 52026 4
	======================================================================
	1 -> (eglot--update-hints 65051 66551)
	1 <- eglot--update-hints: [nil 25592 52026 4
	======================================================================
	1 -> (eglot--update-hints-1 63551 66551)
	1 <- eglot--update-hints-1: nil
	======================================================================
	1 -> (eglot--update-hints 63551 65051)
	1 <- eglot--update-hints: [nil 25592 52026 4
	======================================================================
	1 -> (eglot--update-hints 65051 66551)
	1 <- eglot--update-hints: [nil 25592 52026 5
	======================================================================
	1 -> (eglot--update-hints-1 63551 66551)
	1 <- eglot--update-hints-1: nil

	This continues forever at a very fast rate and saturates the LSP
	channel.

	At first I thought that it was because eglot--update-hints-1 is
	actually causing the buffer to be modified with overlays sometime in
	the future, but it is not so!  It seems that merely calling

	   (goto-char (eglot--lsp-position-to-point position))

	(from the LSP request handler in eglot--update-hints-1) will cause
	this bug.

	* lisp/progmodes/eglot.el (eglot--update-hints): Fix bugs.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: fix inlay hint with label collection instead of string

	Reported by Chinmay Dalal <dalal.chinmay.0101@gmail.com>

	* lisp/progmodes/eglot.el (eglot--update-hints-1): Fix bug when
	inlay hint contains collection of labels.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Fix insertion of keyboard macro containing named keys

	* lisp/kmacro.el: Autoload `macro--string-to-vector'.
	(kmacro-ring-head): Convert `last-kbd-macro' to a vector if it's a
	string, since `kmacro' uses `key-parse' on it.
	(kmacro-lambda-form): Remove require for 'macros
	* test/lisp/kmacro-tests.el
	(kmacro-tests-name-last-macro-key-parse-syntax):
	Test that insertion of macros that contain strings that look
	like named keys works correctly.

	(Bug#61700)

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: simplify inlay hints implementation with jit-lock

	This implementation is much simpler than the one based on
	windows-scroll-functions.  It's also supposedly safer, as long as
	jit-lock guarantees refontification of affected regions.

	It's not _trivially_ simple though, as simply adding
	'eglot--update-hints-1' to jit-lock-functions, while possible, is
	going to request inlay hints from the LSP server for many small
	regions of the buffer, depending on what jit-lock thinks is best.  So
	we keep coalescing these into a larger region until the time is
	suitable for a more bandwidth-efficient request.

	To do this, we use a jit-lock implementation detail,
	jit-lock-context-unfontify-pos, which is a proxy for knowing that the
	jit-lock-context-timer has run.  Not sure how brittle it is, but it
	seems to work reasonably.

	We also get rid of the previous "get hints for entire buffer"
	implementation.

	* doc/misc/eglot.texi (Eglot Variables): Remove mention
	to deleted eglot-lazy-inlay-hints.

	* lisp/progmodes/eglot.el (eglot-lazy-inlay-hints)
	(eglot--inlay-hints-after-scroll)
	(eglot--inlay-hints-fully)
	(eglot--inlay-hints-lazily): Remove.
	(eglot--update-hints): Add function.
	(eglot-inlay-hints-mode): Simplify.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: update inlay hints on window configuration changes

	* lisp/progmodes/eglot.el
	(eglot--inlay-hints-after-window-config-change): New helper.
	(eglot-inlay-hints-mode): Use it.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: display completion label when safe

	Originally reported in
	https://github.com/joaotavora/eglot/discussions/1141 by "Mintsoup".

	Eglot doesn't always show the LSP :label property of a CompletionItem
	in the completion candidates.  That is because label is sometimes not
	what should be inserted in the buffer in the end, the :insertText
	property supercedes it.

	But the label is usually more suitable for display nevertheless and if
	the LSP CompletionItem contains either a snippet or a textEdit, it's
	safe to display the label, since :exit-function will guarantee that a
	suitable buffer insertion is performed.

	This change reflects that awareness that when a textEdit is available,
	it's acceptable to show the label.

	* lisp/progmodes/eglot.el (eglot-completion-at-point): Adjust.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of VC commands, including in Dired

	* doc/emacs/dired.texi (Operating on Files):
	* doc/emacs/maintaining.texi (VC Change Log, VC Directory Mode)
	(Version Control, Basic VC Editing): Document VC command
	invocation from Dired buffers.  Improve documentation of vc-log
	commands.

	* lisp/dired-aux.el (dired-vc-next-action):
	* lisp/vc/vc.el (vc-print-log, vc-log-search, vc-log-mergebase)
	(vc-log-view-type, vc-print-root-log, vc-next-action): Doc fixes.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* doc/emacs/maintaining.texi: More mentions of marked files in Dired.

	(Basic VC Editing, Old Revisions, VC Change Log): Add more mentions of
	ability to include the marked files to the VC fileset in Dired (bug#61712).

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: implement inlay hints (bug#61412, bug#61066)

	Inlay hints are small text annotations to specific parts of the whole
	buffer, not unlike diagnostics, but designed to help readability
	instead of indicating problems.  For example, a C++ LSP server can
	serve hints about positional parameter names in function calls and a
	variable's automatically deduced type.  Emacs can display these hints
	in many little 0-length overlays with an 'before-string property, thus
	helping the user remember those types and parameter names.

	Since inlay hints are potentially a large amount of data to request
	from the LSP server, the implementation strives to be as parsimonious
	as possible with these requests.

	So, by default, inlay hints are only requested for the visible
	portions of the buffer across windows showing this buffer.  This is
	done by leveraging the 'window-scroll-functions' variable, making for
	a reasonably complex implementation involving per-window timers.  When
	scrolling a window, it may take a short amount of time for inlay hints
	to "pop in".  The new user variable 'eglot-lazy-inlay-hints' can be
	used to exert some control over this.

	Specifically, if the variable's value is set to 'nil', then inlay
	hints are greedily fetched for the whole buffer every time a change
	occurs.  This is a much simpler mode of operation which may avoid
	problems, but is also likely much slower in large buffers.

	Also, because the inlay feature is probably visually suprising to
	some, it is turned OFF by default, which is not the usual practice of
	Eglot (at least not when the necessary infrastructure is present).
	This decision may be changed soon.  Here's a good one-liner for
	enabling it by default in every Eglot-managed buffer:

	   (add-hook 'eglot-managed-mode-hook #'eglot-inlay-hints-mode)

	I haven't tested inlay hints extensively across many LSP servers, so I
	would appreciate any testing, both for functional edge cases and
	regarding performance.  There are possibly more optimization
	oportunities in the "lazy" mode of operation, like more aggressively
	deleting buffer overlays that are not in visible parts of the buffer.

	Though I ended up writing this one from scratch, I want to thank
	Dimitry Bolopopsky <dimitri@belopopsky.com> and Chinmay Dala
	<dalal.chinmay.0101@gmail.com> for suggestions and early patches.

	* lisp/progmodes/eglot.el (eglot--lsp-interface-alist): Define
	InlayHint.
	(eglot-client-capabilities): Announce 'inlayHint' capability.
	(eglot-ignored-server-capabilities): Add :inlayHintProvider.
	(eglot--document-changed-hook): New helper hook.
	(eglot--after-change): Use it.
	(eglot-inlay-hint-face, eglot-type-hint-face)
	(eglot-parameter-hint-face): New faces.
	(eglot--update-hints-1, eglot--inlay-hints-after-scroll)
	(eglot--inlay-hints-fully, eglot--inlay-hints-lazily): New helpers.
	(eglot-lazy-inlay-hints): New user variable.
	(eglot-inlay-hints-mode): New minor mode.
	(eglot--maybe-activate-editing-mode): Try to activate
	eglot-inlay-hints-mode.
	(eglot--before-change): Remove overlays immediately in the
	area being changed.
	(eglot--managed-mode-off): Remove overlays.

	* doc/misc/eglot.texi (Eglot Features): Mention inlay hints.
	(Eglot Variables): Mention eglot-lazy-inlay-hints.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: run eglot-managed-mode-hook after LSP didOpen

	This allows using the hook for interacting with the LSP server using
	the current buffer as the subject of that interaction ("document" in
	LSP parlance).

	* lisp/progmodes/eglot.el (eglot--maybe-activate-editing-mode):
	Run eglot-managed-mode-hook here.
	(eglot--managed-mode): Not here.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: restore eldoc-documentation-functions on shutdown

	* lisp/progmodes/eglot.el (eglot--managed-mode): Restore
	eldoc-documentation-functions when shutting down eglot.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: simplify capability-checking code

	* lisp/progmodes/eglot.el (eglot--server-capable-or-lose): New helper.
	(eglot--signal-textDocument/willSave)
	(eglot--signal-textDocument/didSave): Tweak docstring.
	(eglot--workspace-symbols, xref-backend-identifier-at-point)
	(eglot-format, eglot-completion-at-point, eglot-rename)
	(eglot-code-actions): Use new eglot--server-capable-or-lose.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: go back to setting eldoc-documentation-strategy again

	This commits reverts part of

	   commit e83c78b8c7784254c2c6f043530ab325c2fa7f16
	   Author: João Távora <joaotavora@gmail.com>
	   Date:   Mon Feb 20 22:43:50 2023 +0000

	       Eglot: respect user's Eldoc configuration by default

	In that commit, I did what many longstanding issues and users were
	suggesting and removed Eglot's override of two Eldoc user
	configuration varibles.

	I verified that Eglot's behaviour would stay mostly unaltered but my
	tests were very incomplete.  In short there is no way that Eglot can
	work acceptably with the default setting of
	'eldoc-documentation-strategy', which is
	'eldoc-documentation-default'.  So it must be changed, either globally
	or locally in Eglot's minor mode.

	This is true for any situation where both synchronous and asynchronous
	documentation sources are present.  In Eglot's case there are two
	asynchronous sources which have more importance than the synchronous
	source.  So any other strategy except the
	'eldoc-documentation-default' makes sense.

	* lisp/progmodes/eglot.el (eglot--managed-mode): Set
	eldoc-documentation-strategy to eldoc-documentation-compose.

2023-04-15  F. Jason Park  <jp@neverwas.me>

	Yield to erc-move-to-prompt before unhiding prompt

	* lisp/erc/erc-backend.el (erc--hide-prompt): Change hook depth from 0
	to 91 to allow the `move-to-prompt' module to do its thing.  This
	feature was added by bug#54826 and first appeared in Emacs 29.
	* lisp/erc/erc-common.el (erc-server-user): Remove erroneous comment.
	The `buffers' field is a list of buffers.
	* test/lisp/erc/erc-tests.el (erc-hide-prompt): Use `erc--target'
	instead of `erc-default-recipients' because this is new code.

2023-04-15  Augusto Stoffel  <arstoffel@gmail.com>

	* lisp/progmodes/python.el (python--import-sources): Fix regexp (bug#61648)

2023-04-15  Manuel Giraud  <manuel@ledu-giraud.fr>

	Do not error out on non image file (bug#61639)

	* lisp/image/image-dired.el
	(image-dired-display-thumbs): Do not insert non image file and do not
	display image-dired buffer if it is empty.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Explain effect of variable-pitch fonts on fill-column

	* doc/emacs/text.texi (Fill Commands):
	* doc/emacs/display.texi (Displaying Boundaries):
	* lisp/display-fill-column-indicator.el
	(display-fill-column-indicator-mode): Document caveats of using
	variable-pitch fonts with 'fill-column' and its indicator.
	(Bug#61677)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Avoid division by zero in get_narrowed_* functions

	* src/xdisp.c (get_narrowed_width, get_narrowed_len): Return at
	least 1 as the value.  (Bug#61704)

2023-04-15  Martin Rudalics  <rudalics@gmx.at>

	* etc/NEWS: Mention new buffer display action alist entries

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix build --without-xdbe

	* src/xterm.c (x_end_cr_clip, handle_one_xevent): Condition
	double-buffering code on HAVE_XDBE.  (Bug#61667)

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Improve dnd-direct-save-remote-files docstring

	* lisp/dnd.el (dnd-direct-save-remote-files): Reword.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Add 'process-status' to process shortdoc

	* lisp/emacs-lisp/shortdoc.el (process): Add 'process-status'.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	* lisp/emacs-lisp/comp.el (comp--trampoline-abs-filename): Improve 5d0b45cd67b

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Improve text about deleting windows

	* doc/emacs/windows.texi (Change Window): Improve grammar around
	'delete-window-choose-selected'.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Make 'emacs-news-cycle-tag' work at all levels

	* lisp/textmodes/emacs-news-mode.el (emacs-news-cycle-tag): Search for
	a heading starting with 2 or more '*' rather than exactly 3.
	* test/lisp/textmodes/emacs-news-mode-resources/cycle-tag.erts
	(Point-Char): Add tests for 2 and 4 '*' levels.

2023-04-15  Mattias Engdegård  <mattiase@acm.org>

	Repair mistake in a previous edmacro-sanitize-string change

	* lisp/edmacro.el (edmacro-sanitize-for-string):
	This condition should not have been 'repaired' but removed altogether.
	Do so now, fixing bug#61647.

	Reported by Eduardo Ochs.

	(cherry picked from commit 4eefadad0670ad1c3da2505d734e528d54c76bef)

2023-04-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	regex-emacs.c: Reduce the use of backtracking a bit further

	bug#61514 exhibited some undesirable backtracking in a case where
	it's easy to avoid it by making `mutually_exclusive_p` just a bit
	more careful.

	* src/regex-emacs.c (mutually_exclusive_p): Handle `on_failure_jump`s.

	* test/src/regex-emacs-tests.el (regexp-tests-backtrack-optimization):
	Add a few tests.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Eglot: respect user's Eldoc configuration by default

	This change addresses the problems reported in many Elglot reports
	dating back to early 2021 at least:

	  https://github.com/joaotavora/eglot/issues/648
	  https://github.com/joaotavora/eglot/issues/894
	  https://github.com/joaotavora/eglot/issues/920
	  https://github.com/joaotavora/eglot/issues/1031
	  https://github.com/joaotavora/eglot/issues/1171

	In one form or another, the reports point out that the multiple pieces
	of information about the "thing at point" made available by the LSP
	server are not all being considered by the ElDoc system.

	The reason for this is Eglot setting/trampling the variables
	'eldoc-documentation-strategy' and 'eldoc-documentation-functions' in
	its minor more entry function.

	The reason it did that is historical and is partially described in the
	issues above.  But, evidently, it never made much sense, because so
	many people want to override it, which requires setting
	'eldoc-documentation-strategy' to the non-default value
	'eldoc-documentation-compose'.

	The problem was made worse by the fact that setting it as usual in
	either the Customize menu or their init file didn't work, requiring a
	fairly complex Elisp snippet.  That is now solved as of this commit.

	If the user does not do any setting, then Eglot works basically the
	same as before (i.e. shows only one piece of information).

	It is arguable that the default value for
	'eldoc-documentation-strategy' should change globally to
	'eldoc-documentation-compose', but that has other subtle implications
	and is not part of this commit.

	* lisp/progmodes/eglot.el (eglot--managed-mode): Don't set Eldoc
	variables greedily.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	Make the native compiler always use `make-temp-file' for temporary files

	* src/comp.c (CALL4I): Define macro.
	(Fcomp__compile_ctxt_to_file): Use `make-temp-file' instead of
	`make-temp-file-internal'.
	* lisp/emacs-lisp/comp.el (comp--trampoline-abs-filename): Likewise.

2023-04-15  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.3.7-216-gfe40342

2023-04-15  Daniel Martín  <mardani29@yahoo.es>

	Add declaration_list to c-ts-common-indent-type-regexp-alist

	* lisp/progmodes/c-ts-mode.el (c-ts-base-mode): Consider a
	"declaration_list" a block. (Bug#61635)
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts (Code): Add a
	test case.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Typescript-ts-mode: Add switch case handling

	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--indent-rules): New rules.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Fix object initializer for csharp-mode (bug#61541)

	* lisp/progmodes/csharp-mode.el (csharp-guess-basic-syntax): Make sure
	we check the openers as well as closers.

2023-04-15  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.1-34-geea8da

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Improve tree-sitter indent anchor prev-adaptive-prefix (bug#61314)

	Now prev-adaptive-prefix looks at the current line and checks if it
	begins with a prefix itself.  If it does, prev-adaptive-prefix tries
	to place the anchor before the prefix on the previous line, rather
	than after it.

	 - prev line
	 - this line -> This line starts with a "-", i.e., begins with a
	                prefix, so we place the anchor at the beginning of the
	                 "-" of the previous line, rather than after it

	 - prev line
	   this line -> This line doesn't start with a prefix, so the anchor
	                is placed after the previous line's "-".

	* doc/lispref/modes.texi (Parser-based Indentation): Update manual.
	* lisp/treesit.el:
	(treesit-simple-indent-presets): Add local variable
	this-line-has-prefix, base what anchor to return on the value of
	this-line-has-prefix and whether the prev line has a prefix.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Adjust jsx indentation

	We can use the fact that 'treesit-indent-1' uses 'treesit-node-on'
	when on a whitespace to set the actual current node as parent.  Now we
	can correctly indent the 'jsx_text' nodes.  We also add some more
	electric-indent-chars so that auto-indenting of jsx behaves a little
	more fluently.

	* lisp/progmodes/js.el (js--treesit-indent-rules): Add new rules.
	(js-ts-mode): Add more indent-chars.
	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--indent-rules): Add new rules.
	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-base-mode): Add more indent-chars and layout rules.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Cleanup preproc indent for c-ts-mode (bug#61558)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Make sure we
	indent to great-grand-parent if inside an #ifdef...#endif block.  If
	grand-parent is root node, then don't indent one step.
	(c-ts-mode--preproc-offset): New helper anchor function to calculate
	indent offset.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Add comment style toggle for c-ts-mode (bug#61550)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode-toggle-comment-style): New
	command.
	(c-ts-base-mode-map): Add binding.
	(c-ts-mode-set-modeline): New function.
	(c-ts-mode): Set modeline.
	(c++-ts-mode): Set modeline.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/simple.el (choose-completion): Check for completion-in-region-mode.

	Don't use base-affixes when completion-use-base-affixes is non-nil
	in completion-in-region-mode (bug#61535).

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	rust-ts-mode--font-lock-settings: Avoid the explicit 'default' face

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--fontify-scope)
	(rust-ts-mode--fontify-tail): New functions.
	(rust-ts-mode--font-lock-settings): Use them instead of a lot of
	more complex queries (bug#61302).  Thus avoid having to create
	block fontification by other features using the 'default' face.
	Replace the catch-all query for 'variable' with an enumeration of
	possible parent nodes.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	* lisp/progmodes/xref.el: Bump the version.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	xref--insert-xrefs: Use 'shadow' for the line number colon

	* lisp/progmodes/xref.el (xref--insert-xrefs): Use face 'shadow' for
	the line number colon instead of continuing it face (bug#61340).

	(cherry picked from commit d6d25a3c221e566de4df5319181e9ba9a8df285e)

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/progmodes/xref.el (xref--insert-xrefs): Remove extra space (bug#61340).

	(cherry picked from commit 643a11c6e5defc0a34da1a53b64aa1e097298923)

2023-04-15  Mattias Engdegård  <mattiase@acm.org>

	Backport: Fix xref-clear-marker-stack refactoring mistake

	* lisp/progmodes/xref.el (xref-clear-marker-stack):
	Clear the history correctly.  Changing a lexical variable has no effect.

	(cherry picked from commit dfdc0f5fb7b10e737c3c8e2bdb1eb873a1e91bd7)

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	Merge from origin/emacs-28

	f5a99945b6f ; Update ChangeLog for Emacs 28.3
	f7bd5ac5521 Update HISTORY for Emacs 28.3

	# Conflicts:
	#	etc/NEWS

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	Merge from origin/emacs-28

	4a77fcb1478 Update ChangeLog and AUTHORS for Emacs 28.3

2023-04-15  Manuel Giraud  <manuel@ledu-giraud.fr>

	More doc on image-dired-dired-* (bug#61624)

	* doc/emacs/dired.texi (Image-Dired): Some fixes and more
	documentation about image-dired-dired-* commands.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Eglot: improve treatment of completion items without :sortText (bug#61532)

	Previously, defaulting to the empty string put candidates without
	:sortText to the top of the list.  since string-lessp is safe with nil
	arguments, this makes them sort to the end instead.

	* lisp/progmodes/eglot.el (eglot-completion-at-point): Simplify.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix invocation of File->Close from the menu bar

	* lisp/simple.el (kill-buffer--possibly-save): Don't request
	LONG-FORM from 'read-multiple-choice' if GUI dialog should be
	used.
	* lisp/emacs-lisp/rmc.el (read-multiple-choice): Doc fix.
	(read-multiple-choice--short-answers): Don't append "?" to
	CHOICES and don't display the prompt in the echo area if GUI
	dialog is used.  Use 'use-dialog-box-p'.  (Bug#61553)

2023-04-15  Manuel Giraud  <manuel@ledu-giraud.fr>

	Update thumbnail buffer's header more

	* lisp/image/image-dired.el (image-dired-display-thumbs): Call
	image-dired--update-header-line.  (Bug#61508)

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(treesit-query-validate): Fix reusing the output buffer

	* lisp/treesit.el (treesit-query-validate): Fix the "Buffer is
	read-only" error when an output buffer already exists.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(rust-ts-mode--font-lock-settings): Highlight closure parameters

	* lisp/progmodes/rust-ts-mode.el
	(rust-ts-mode--font-lock-settings): Highlight closure parameters.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	* Fix `native-comp-enable-subr-trampolines' semantic

	* lisp/emacs-lisp/comp.el (comp--trampoline-abs-filename): Interpret
	`native-comp-enable-subr-trampolines' relative to
	`invocation-directory'.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix documentation of 'just-one-space' and 'delete-horizontal-space'

	* lisp/simple.el (just-one-space, delete-horizontal-space):
	Mention the effect of prefix argument.  (Bug#61609)

2023-04-15  martin rudalics  <rudalics@gmx.at>

	Fix 'display-buffer-use-least-recent-window'

	* src/window.c (Fwindow_use_time): Doc fix.
	(Fwindow_bump_use_time): Bump use time of the seleceted window as
	well.  Doc fix.

	* lisp/window.el (display-buffer-avoid-small-windows): Remove.
	All users changed.
	(window--display-buffer): Bump window use time when requested.
	(display-buffer--lru-window): New function.
	(display-buffer-use-some-window): Use it.
	(display-buffer-use-least-recent-window): Rewrite and enhance doc
	string.

	* doc/lispref/windows.texi (Selecting Windows)
	(Buffer Display Action Functions, Buffer Display Action Alists)
	(The Zen of Buffer Display): Improve and update documentation of
	window selection and display facilities.

2023-04-15  kobarity  <kobarity@gmail.com>

	Fix point moving when calling python-shell-send-region

	* lisp/progmodes/python.el (python-shell-buffer-substring): Add
	`save-excursion' to prevent the point from moving.
	* test/lisp/progmodes/python-tests.el (python-tests-should-not-move):
	New helper function to assert that point does not move while calling a
	function.
	(python-shell-buffer-substring-*): Use
	`python-tests-should-not-move'. (Bug#61463)

2023-04-15  Omar Polo  <op@omarpolo.com>

	(project-try-vc): Remove unused defvar/require

	* lisp/progmodes/project.el (project-try-vc):
	Remove unused defvar/require (bug#61577).

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	Delete redundant question from Gnus FAQ

	* doc/misc/gnus-faq.texi (FAQ 1-2): Delete redundant question.
	(FAQ 1-1, FAQ 1-3): Adjust accordingly.

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	Slightly improve hashcash documentation

	* lisp/mail/hashcash.el: Improve Commentary.
	(hashcash-program):
	* lisp/gnus/message.el (message-generate-hashcash): Improve
	docstring.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix cursor motion when there's line-prefix and display string at BOL

	* src/xdisp.c (move_it_in_display_line_to): Handle 'line-prefix' and
	'wrap-prefix' when the screen line has a display string at its
	beginning.  (Bug#61580)

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix comment in treesit_record_change (bug#61369)

	Turns out the previous commit message and comment is not entirely
	correct: the old behavior is in fact wrong, not just "correct but has
	problems".

	Here is why the old code is wrong:

	|visible range|     -> markup for visible range

	updated range       -> markup for updated range
	-------------

	First we have some text

	|aaaaaa|

	Now we insert something at the beginning, because we clip
	new_end_offset to visible_end, out of eight b's inserted, only the
	first six are known to tree-sitter.

	|bbbbbbbbaaaa|aa  start: 0, old_end: 0, new_end: 6
	 ------

	In treesit_sync_visible_region, we sync up visible region, but the two
	missing b's are not in the updated range.

	|bbbbbbbbaaaaaa|  start: 12, old_end: 12, new_end: 14
	             --

	The old behavior not only is wrong, but also doesn't make much sense.

	* src/treesit.c (treesit_record_change): Update comment.

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	Spell out RPN abbreviation in Calc manual intro

	* doc/misc/calc.texi (What is Calc, Demonstration of Calc)
	(RPN Tutorial): Spell out "Reverse Polish notation" abbreviation.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix some uses of 'use-dialog-box'

	* lisp/frame.el (display-mouse-p): Fix return value on MS-Windows
	in batch invocations.
	* lisp/hi-lock.el (hi-lock-unface-buffer): Don't consider
	'last-nonmenu-event' being nil as a mouse event, for the purpose
	of using dialog boxes.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix hi-lock-tests when 'use-dialog-box' is non-nil

	* test/lisp/hi-lock-tests.el (hi-lock-case-fold)
	(hi-lock-unhighlight): Bind 'use-dialog-box' to nil.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix regression due to change in face sort order by 'face-list'

	* lisp/faces.el (x-create-frame-with-faces): Undo reversing of
	the face list, which is no longer necessary, since 'face-list's
	sorting order has been reversed recently.  (Bug#61521)

2023-04-15  Po Lu  <luangruo@yahoo.com>

	* lisp/files.el (file-equal-p): Work around Haiku stat bug.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(project-vc-backend-markers-alist): Add entry for vc-got

	* lisp/progmodes/project.el (project-vc-backend-markers-alist):
	Add entry for vc-got (bug#61577).  Bump the version.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	project.el: Extract backend->marker association for a defvar

	* lisp/progmodes/project.el (project-vc-backend-markers-alist):
	Extract from 'project-try-vc'.
	(project-try-vc): Update accordingly (bug#61577).

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Don't completely clip into visible range in treesit_record_change

	(Bug#61369)

	From
	    min (visible_end, max (visible_beg, new_end_byte)) - visible_beg
	to
	    max (visible_beg, new_end_byte) - visible_beg

	* src/treesit.c (treesit_record_change): We don't clip the new end
	into the visible range anymore.  If you think of it, when inserting in
	a narrowed region, the visible region is always extended to
	accommodate more text, rather than pushing text at the end to keep the
	size of the visible region.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	* lisp/treesit.el (treesit-node-at): Update docstring (bug#61529).

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	* lisp/calc/calc.el (calc-mode): Improve docstring.

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	Bump Emacs version to 28.3

	* README:
	* configure.ac:
	* msdos/sed2v2.inp:
	* nt/README.W32: Bump Emacs version to 28.3.

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	Update ChangeLog and AUTHORS for Emacs 28.3

	* ChangeLog.3:
	* etc/AUTHORS: Update for Emacs 28.3.

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	Update HISTORY for Emacs 28.3

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	Update NEWS for Emacs 28.3

	* etc/NEWS: Update for Emacs 28.3.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	Merge 'emacs-29' into 'feature/inhibit-native-comp-cleanup'

2023-04-15  Eli Zaretskii  <eliz@gnu.org>  (tiny change)

	Fix order of faces in 'face-list'

	* lisp/faces.el (frame-face-alist, face-list): Sort faces in
	decreasing order of face IDs.  Patch by Brennan Vincent
	<brennan@umanwizard.com>.  (Bug#61521)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Allow 'icon-title-format' to have the value t

	* src/xdisp.c (gui_consider_frame_title, syms_of_xdisp): If the
	value of 'icon-title-format' is t, use 'frame-title-format'
	instead.  (Bug#61496)

	* etc/NEWS:
	* doc/lispref/frames.texi (Frame Titles): Document the new
	handling of the value t.
	(Basic Parameters): Fix the documentation of the 'title' and
	'name' frame parameters.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Add electric indent for preproc directives

	It looks like there are few if no other cases where we get this
	particular error in the AST than with insertion of '#'.

	Consider:

	```
	int
	main()
	{
	  |
	}
	```

	If we only add '#' the AST yields (ERROR (ERROR)), which we can
	exploit to hook onto electric indent.  The end result should be the
	hashtag anchored to column 0.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): New rule.
	(c-ts-base-mode): Add # to electric-indent-chars.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Rename 'emacs-news-toggle-tag' to 'emacs-news-cycle-tag'

	* lisp/textmodes/emacs-news-mode.el (emacs-news-cycle-tag): Renamed
	from 'emacs-news-toggle-tag'.
	(emacs-news-mode-map, emacs-news-mode-menu): Use new name.
	* test/lisp/textmodes/emacs-news-mode-resources/cycle-tag.erts:
	Renamed from "toggle-tag.erts".
	* test/lisp/textmodes/emacs-news-mode-tests.el (emacs-news-cycle-tag):
	Rename test from 'emacs-news-toggle-tag', and call
	'emacs-news-cycle-tag' with new resource file name.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Add menu to news-mode

	* lisp/textmodes/emacs-news-mode.el (emacs-news-mode-map): Add binding
	for 'emacs-news-delete-temporary-markers'.
	(emacs-news-mode-menu): Add menu for common actions.

2023-04-15  Philip Kaludercic  <philipk@posteo.net>

	Attempt to recognise if a VC package has no Elisp files

	* lisp/emacs-lisp/package-vc.el (package-vc-non-code-file-names): Add
	new variable used to avoid false-positives.
	(package-vc--unpack): Recursively search for .el files excluding the
	ones listed in 'package-vc-non-code-file-names', offering to abort the
	installation if none are found.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix mule-tests under en_US.UTF-8 locale

	* test/lisp/international/mule-tests.el (sgml-html-meta-utf-8):
	Accept also utf-8-unix/dos/whatever.  (Bug#61534)

	* lisp/international/mule.el
	(sgml-html-meta-auto-coding-function): Fix comparison when
	buffer-file-coding-system is of type 'charset'.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Move block closer above declaration_list rule (bug#61531)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Move rule
	above the previous rule.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Minor improvements in c-ts-mode and docs

	* lisp/progmodes/c-ts-mode.el (c-ts-base-mode-map): Add a binding
	for comment-region.

	* doc/emacs/programs.texi (C Indent): Mention "C-u TAB".

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Add super node as a keyword

	* lisp/progmodes/java-ts-mode.el
	(java-ts-mode--font-lock-settings): Add new node.

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	Delete perplexing paragraph from Gnus manual

	* doc/misc/gnus.texi (Exiting Gnus): Delete a confusing paragraph,
	that may or may not have been intended as a joke.  (Bug#61325)

2023-04-15  ~kby  <kby@tilde.team>  (tiny change)

	Eglot: check server capability before sending didSave (bug#61478)

	* lisp/progmodes/eglot.el (eglot--signal-textDocument/didSave): check
	server capability.

2023-04-15  Randy Taylor  <dev@rjt.dev>

	Fix rust-ts-mode type and module highlighting (Bug#61302)

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--font-lock-settings):
	Specify import queries to avoid clashing with scoped identifiers in
	the code.  Highlight attributes with font-lock-preprocessor-face.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	rust-ts-mode: Highlight variable reassignments

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode):
	New treesit font-lock feature: 'assignment' (bug#61302).
	(rust-ts-mode--fontify-pattern): Remove the node lookup step.
	(rust-ts-mode--font-lock-settings): Update variable declaration
	queries to match the 'pattern' child node right away.  Add
	highlights for 'assignment.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Improve backward compatibility of save-restriction

	* src/editfns.c (save_restriction_save_1): Renamed from
	'save_restrictions_save'.  Make it static.
	(save_restriction_restore_1): Renamed from
	'save_restriction_restore'.  Make it static.
	(save_restriction_restore): New function, combining
	'save_restriction_save_1' and 'narrowing_locks_save'.
	(save_restriction_save): New function, combining
	'save_restriction_restore_1' and 'narrowing_locks_restore'.
	(Fsave_restriction): Restore the previous code.
	(narrowing_locks_save, narrowing_locks_restore): Make them static.

	* src/lisp.h: Remove two functions that are not externally visible
	anymore.

	* src/comp.c (helper_save_restriction): Restore the previous code.

	* src/bytecode.c (exec_byte_code): Restore the previous code.

	* lisp/emacs-lisp/bytecomp.el (byte-compile-save-restriction):
	Decrement unbinding count.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Don't indent template_string contents (bug#61503)

	* lisp/progmodes/js.el (js--treesit-indent-rules): Add new rule.
	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--indent-rules): Add new rule.

2023-04-15  Jostein Kjønigsen  <jostein@kjonigsen.net>

	csharp-ts-mode: fontify compiler directives (bug#61512)

	lisp/progmodes/csharp-mode.el: Add tree-sitter-queries for known C#
	compiler-directives.

2023-04-15  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.3.7-209-gdab1dfa

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	* Generate trampolines in a temporary directory if no other option is viable

	* lisp/emacs-lisp/comp.el (comp--trampoline-abs-filename): Use
	temporary file if no other option is viable.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Rename with/without-narrowing to with/without-restriction

	* doc/lispref/commands.texi:
	* doc/lispref/display.texi:
	* doc/lispref/positions.texi:
	* etc/NEWS:
	* lisp/subr.el:
	* src/buffer.c:
	* src/editfns.c:
	* src/keyboard.c:
	* src/xdisp.c:
	* test/src/buffer-tests.el: Rename with-narrowing and
	without-narrowing to with-restriction and without-restriction.
	Likewise with internal--with-narrowing and
	internal--without-narrowing.  All callers and documentation
	changed.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/repeat.el: Rename internal function and variable (bug#60980)

	(repeat--transient-exitfun): Rename internal variable from
	'repeat-exit-function'.
	(repeat--clear-prev): Rename internal function from
	'repeat--exit'.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	* Fix previous change

	* lisp/emacs-lisp/generate-lisp-file.el (generate-lisp-file-trailer):
	Fix previous change b6e2799aa1c.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	Rename native-comp-deferred-compilation-deny-list

		* lisp/emacs-lisp/comp.el (native-comp-jit-compilation-deny-list)
		(native-compile-async-skip-p): Rename
		native-comp-deferred-compilation-deny-list into
		native-comp-jit-compilation-deny-list.
		(native-comp-deferred-compilation-deny-list): Mark it obsolete.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	Rename native-comp-deferred-compilation into native-comp-jit-compilation

		* src/comp.c (maybe_defer_native_compilation, syms_of_comp):
		Rename native-comp-deferred-compilation into
		native-comp-jit-compilation.

		* lisp/subr.el (native-comp-deferred-compilation): Mark
		native-comp-deferred-compilation as obsolete.

		* lisp/startup.el (native-comp-deferred-compilation)
		(normal-top-level): Rename native-comp-deferred-compilation into
		native-comp-jit-compilation.

		* lisp/progmodes/elisp-mode.el
		(emacs-lisp-native-compile-and-load): Likewise.

		* lisp/emacs-lisp/generate-lisp-file.el
		(generate-lisp-file-trailer): Likewise.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	Rename comp-enable-subr-trampolines into native-comp-enable-subr-trampolines

		* src/data.c (Ffset): Rename comp-enable-subr-trampolines into
		native-comp-enable-subr-trampolines.

		* src/comp.c (syms_of_comp): Likewise.

		* lisp/subr.el (comp-enable-subr-trampolines): Make
		comp-enable-subr-trampolines obsolete.

		* lisp/startup.el (native-comp-enable-subr-trampolines)
		(normal-top-level): Rename comp-enable-subr-trampolines into
		native-comp-enable-subr-trampolines.

		* lisp/loadup.el (dump-mode): Likewise.

		* lisp/emacs-lisp/comp.el (comp-subr-trampoline-install)
		(comp--trampoline-abs-filename): Likewise.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	* lisp/emacs-lisp/comp.el (native-comp-never-optimize-functions): Improve doc

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	Support `comp-enable-subr-trampolines' as string value

	* src/comp.c (syms_of_comp): Update `comp-enable-subr-trampolines'.

	* lisp/emacs-lisp/comp.el (native-comp-never-optimize-functions)
	(comp--trampoline-abs-filename): Support
	`comp-enable-subr-trampolines' string value.

	* src/data.c (Ffset): Use Vcomp_enable_subr_trampolines now.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Merge branch 'scratch/fix-locked-narrowing'

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	* Some more `inhibit-native-compile' clean-up

	* lisp/emacs-lisp/generate-lisp-file.el (generate-lisp-file-trailer):
	Use `native-comp-deferred-compilation'.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Minor improvements to labeled narrowing

	* lisp/subr.el (internal--with-narrowing):
	(internal--without-narrowing): Remove unnecessary 'progn'.

	* etc/NEWS: Mention 'with-narrowing' in the entry about long
	lines.

	* doc/lispref/positions.texi (Narrowing): Fix typo.

	* doc/lispref/display.texi (Auto Faces): Use @pxref.

	* doc/lispref/commands.texi (Command Overview): Use @pxref.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	Revert "Add new variable 'inhibit-native-compilation'"

	This reverts commit 5fec9182dbeffa88cef6651d8c798ef9665d6681.

2023-04-15  Andrea Corallo  <akrl@sdf.org>

	Revert "Rename to inhibit-automatic-native-compilation"

	This reverts commit f97993ee667f9be7589825f3a4fbc095d6944ec6.

2023-04-15  Ulrich Müller  <ulm@gentoo.org>

	Fix spurious display of eclipses in Calendar

	* lisp/calendar/lunar.el (eclipse-check): Don't show an eclipse
	unless the phase is new moon or full moon. (bug#61460)
	* test/lisp/calendar/lunar-tests.el (lunar-test-eclipse-check)
	(lunar-test-phase-list): Update tests.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix indentation for closing bracket in c-ts-mode (bug#61398)

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--indent-styles): Move the rule earlier.
	(c-ts-base-mode): Add move block type.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New tests.

2023-04-15  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.1-31-gaf1bb1

2023-04-15  Alan Mackenzie  <acm@muc.de>

	* src/.gdbinit (nextcons): Amend $.u.cdr to $.u.s.u.cdr (bug#61453).

	(cherry picked from commit dde023b63ab82c38d33815409de5552f5bf349d1)

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Add lambda_expression to c-ts-common-indent-type-regexp-alist

	* lisp/progmodes/java-ts-mode.el (java-ts-mode): Tweak regexp.

2023-04-15  Philip Kaludercic  <philipk@posteo.net>

	Tolerate missing elpa-packages.eld files

	* lisp/emacs-lisp/package-vc.el
	(package-vc--download-and-read-archives): Replace
	'condition-case-unless-debug' with a regular 'condition-case'.

	It appears a few people using third-party archives that don't serve
	package specifications have been having issues with package-vc, when
	toggle-on-error is enabled.  In their case, package-vc would raise an
	error in its first invocation, but it would go on working normally
	afterwards.  As this behaviour is confusing and the user can't do much
	about a missing elpa-packages.eld to begin with, we satisfy ourselves
	with printing out a message and continuing on.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Avoid warning about 'load-path' in non-interactive sessions

	* lisp/startup.el (command-line): Emit the warning about
	'user-emacs-directory' in 'load-path' only in interactive
	sessions.  (Bug#61014)

2023-04-15  Ulrich Müller  <ulm@gentoo.org>

	Support webkit2gtk-4.1

	* configure.ac: Check for webkit2gtk API version 4.1 first, then
	fall back to 4.0.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Save and restore the absence of narrowing locks

	* src/editfns.c (narrowing_locks_save): Return the buffer with a
	empty locks list when the current buffer has no narrowing locks.
	(narrowing_locks_restore): Remove the narrowing locks if the
	buffer had no narrowing locks.

2023-04-15  Tassilo Horn  <tsdh@gnu.org>

	bug-reference: prevent match-data clobbering (bug#61395)

	* lisp/progmodes/bug-reference.el (bug-reference-fontify): Wrap call
	to syntax-ppss in save-match-data since it can clobber our
	match-data (bug#61395).

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Rename LIMIT to DEPTH in tree-sitter functions (bug#61231)

	I only changed the Lisp functions, internal functions are left
	unchanged.

	* doc/lispref/parsing.texi (Retrieving Nodes): Update manual.
	* src/treesit.c (Ftreesit_search_subtree)
	(Ftreesit_induce_sparse_tree): Change LIMIT to DEPTH.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add 'live' property to treesit-node-check (bug#61235)

	* doc/lispref/parsing.texi (Accessing Node Information): Document.
	* src/treesit.c (treesit_parser_live_p): New function.
	(Ftreesit_node_check): Add 'live' property.
	* test/src/treesit-tests.el (treesit-node-api): Add tests.

2023-04-15  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.3.7-205-gb8ad0da

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix 'rmail-summary-output'

	* lisp/mail/rmailsum.el (rmail-summary-output): Fix deletion of
	messages when 'rmail-output-reset-deleted-flag' is non-nil.
	(Bug#61380)

2023-04-15  Nicolas Martyanoff  <nicolas@n16f.net>

	lisp-mode: add docstring recognition for more common lisp symbols

	* lisp/emacs-lisp/lisp-mode.el (define-compiler-macro)
	(define-setf-expander, deftype): Add the 'doc-string-elt'
	property for proper docstring highlighting in Common Lisp.

2023-04-15  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.3.7-204-gecff8c2

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix Scala entry in Eglot's DB of LSP servers

	* lisp/progmodes/eglot.el (eglot-server-programs): Support Scala
	LSP named "metals", in addition to "metals-emacs".  (Bug#61312)

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Also don't reindent 'identifier' when inside ERROR

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--indent-rules):
	Also don't reindent 'identifier' when inside ERROR.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Fix indentation inside empty if/unless/case/def

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--indent-rules):
	Add new rule.

	* test/lisp/progmodes/ruby-ts-mode-tests.el
	(ruby-ts-indent-empty-if-else): New test.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Add an extensive test for labeled (locked) narrowing

	* test/src/buffer-tests.el (test-labeled-narrowing): New test.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Update the documentation about labeled (locked) narrowing

	* src/xdisp.c (syms_of_xdisp) <fontification-functions>: Update
	docstring.

	* src/keyboard.c (syms_of_keyboard) <pre-command-hook>:
	(syms_of_keyboard) <post-command-hook>: Update docstring.

	* src/editfns.c:
	(narrowing_locks): Explain why an alist is used instead of a
	buffer-local variable.
	(reset_outermost_narrowings): Point to recipes that demonstrate
	why it is necessary to restore the user narrowing bounds when
	redisplay starts.
	(Fwiden): Update docstring.
	(Fnarrow_to_region): Update docstring.
	(Finternal__lock_narrowing): Update docstring.
	(Finternal__unlock_narrowing): Update docstring.
	(Fsave_restriction): Update docstring.

	* src/buffer.c (syms_of_buffer)
	<long-line-optimizations-region-size>: Update docstring.
	(syms_of_buffer) <long-line-optimizations-bol-search-limit>:
	Update docstring.

	* lisp/subr.el (with-narrowing): Update docstring.
	(without-narrowing): Update docstring.

	* etc/NEWS: Mention the 'long-line-optimizations-region-size' and
	'long-line-optimizations-bol-search-limit' options.
	Announce the 'with-narrowing' and 'without-narrowing' forms.

	* doc/lispref/positions.texi (Narrowing): Update the documentation
	of 'narrow-to-region', 'widen' and 'save-restriction'.  Document
	the 'with-narrowing' and 'without-narrowing' special forms.

	* doc/lispref/display.texi (Auto Faces): Update the documentation.

	* doc/lispref/commands.texi (Command Overview): Document the fact
	that the buffer is narrowed around 'pre-command-hook' and
	'post-command-hook' when the buffer text includes very long lines.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Rename two long line optimizations variables

	* src/buffer.c (syms_of_buffer): Rename two variables.

	* src/xdisp.c (get_locked_narrowing_begv):
	(get_locked_narrowing_zv):
	(handle_fontified_prop): Use the new names.

	* src/keyboard.c (safe_run_hooks_maybe_narrowed): Use the new
	names.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Add specific symbols for narrowings

	* src/xdisp.c (syms_of_xdisp): Define symbol.
	(handle_fontified_prop): Use it.

	* src/keyboard.c (syms_of_keyboard): Define symbol.
	(safe_run_hooks_maybe_narrowed): Use it.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Add 'without-narrowing' macro

	* lisp/subr.el (without-narrowing): New macro, companion (and
	almost identical) to 'with-narrowing'.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Make 'narrowing-lock' and 'narrowing-unlock' internal

	* src/editfns.c (Finternal__lock_narrowing): Renamed from
	'narrowing-lock'.
	(Finternal__unlock_narrowing): Renamed from 'narrowing-unlock'.
	(unwind_narrow_to_region_locked):
	(narrow_to_region_locked):
	(syms_of_editfns): Use the new names.

	* lisp/subr.el (internal--with-narrowing): Use the new name.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Fix 'save-restriction' for narrowing locks

	* src/editfns.c (narrowing_locks_save):
	(narrowing_locks_restore): Make them non-static.

	* src/lisp.h: Make them externally visible.

	* src/bytecode.c (exec_byte_code): Save and restore narrowing
	locks.

	* lisp/emacs-lisp/bytecomp.el (byte-compile-save-restriction):
	Increment unbinding count.

	* src/comp.c (helper_save_restriction): Save and restore narrowing
	locks.

2023-04-15  LensPlaysGames  <lensplaysgames@gmail.com>  (tiny change)

	* lisp/iimage.el (iimage-mode-buffer): Handle multiple regexps.

	Go to the beginning of the buffer before searching every regexp in
	iimage-mode-image-regex-alist.

2023-04-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/edmacro.el (edit-kbd-macro): Fix thinko (bug#61333)

	Backported from commit 2273cdb40e1939f7c29a669f6a64e6a27738c1a5.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix crashes inside 'xfree' called from treesit.c

	* src/treesit.c (treesit_load_language): Always xstrdup 'c_name',
	to avoid crashes inside xfree.  (Bug#61351)

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Make java-ts-mode use the c-ts-common-indent-type-regexp-alist

	* lisp/progmodes/java-ts-mode.el:
	(java-ts-mode): Setup c-ts-common-indent-type-regexp-alist.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation

	Sign, ok, there's another edge case: else if statements.  Because
	"else if" is usually implemented as just another if statement nested
	in the else branch, this creates additional levels that indentation
	needs to ignore.

	I converted c-ts-common-indent-block-type-regexp +
	c-ts-common-indent-bracketless-type-regexp into a new, more flexible
	variable, c-ts-common-indent-type-regexp-alist, to avoid adding yet
	more variables in order to recognize else and if statements.

	* lisp/progmodes/c-ts-common.el:
	(c-ts-common-indent-type-regexp-alist): New variable.
	(c-ts-common-indent-block-type-regexp)
	(c-ts-common-indent-bracketless-type-regexp): Remove variables.
	(c-ts-common--node-is): New function.
	(c-ts-common-statement-offset): Use the new variable, and add the
	"else if" special case.  Also merge the code of
	c-ts-mode--fix-bracketless-indent, because now the code is much more
	succinct.
	(c-ts-mode--fix-bracketless-indent): Merge into
	c-ts-common-statement-offset.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-base-mode): Setup c-ts-common-indent-type-regexp-alist.

	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New test.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation

	Turns out I shouldn't have removed the explicit rules.  Anyway, now it
	indents properly.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Add rules.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: Add tests

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation (bug#61291)

	Fix indentation for the semicolon in

	while (str_a[i++] == str_b[j++])
	  ;

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): New rule.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New test.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(eglot-completion-at-point): Return correct values in :company-kind

	* lisp/progmodes/eglot.el (eglot-completion-at-point): Return the
	correct values in :company-kind for "EnumMember" and "TypeParameter".
	The convention is to use kebab case rather than plain downcasing.
	Reported in https://github.com/company-mode/company-mode/issues/1370.

2023-04-15  Mattias Engdegård  <mattiase@acm.org>

	Tighten and simplify typescript compilation-mode regexps (bug#61104)

	* lisp/progmodes/compile.el (compilation-error-regexp-alist-alist):
	Tighten regexps and simplify.  Translate to rx.
	* etc/compilation.txt: Add examples.

	In collaboration with Jostein Kjønigsen.

2023-04-15  Tassilo Horn  <tsdh@gnu.org>

	Clarify bug-reference-auto-setup-functions docstring.

	* lisp/progmodes/bug-reference.el (bug-reference-auto-setup-functions):
	Add clarification to docstring that this variable is for packages, not
	for users.

2023-04-15  Aleksandr Vityazev  <avityazev@posteo.org>

	* lisp/treesit.el (treesit): Fix shortdoc example form (bug#61318).

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Use c-ts-common-statement-offset in java-ts-mode (bug#61142)

	* lisp/progmodes/java-ts-mode.el (java-ts-mode--indent-rules): Add new
	matchers to enable c-ts-common machinery.
	(java-ts-mode): Add regexps.
	* lisp/progmodes/c-ts-common.el (c-ts-common-statement-offset): Fix
	typo in documentation and use the new if statement helpers.
	(c-ts-common-if-statement-regexp): New defvar.
	(c-ts-common-nestable-if-statement-p): New defvar.
	(c-ts-common--fix-nestable-if-statement): New helper.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: Add test for
	complicated bracket matching indentation.
	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Add indent
	rules for bracketless statements.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Add array_initializer to java-ts-mode

	Indent strings inside arrray_initializer one step:

	public class Java {
	    void foo() {
	        return new String[]{
	            "foo", // These
	            "bar"
	        }
	    }
	}

	* lisp/progmodes/java-ts-mode.el (java-ts-mode--indent-rules): New
	matcher.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	go-ts-mode: Highlight variable declarations

	* lisp/progmodes/go-ts-mode.el (go-ts-mode--font-lock-settings):
	Highlight variable declarations in 'definition' feature.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	go-ts-mode: Fix highlighting of function name in call_expression

	* lisp/progmodes/go-ts-mode.el (go-ts-mode--font-lock-settings):
	Remove :override from the 'property' rules and move them above
	'variable' (bug#61302).  Just like in rust-ts-mode.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	c-ts-mode: Highlight "property functions" as functions

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--font-lock-settings):
	Highlight "property functions" as functions (bug#61302).

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	rust-ts-mode: Fix highlighting of function name in call_expression

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--font-lock-settings):
	Remove :override from the 'property' rules and move them above
	'variable' (bug#61302).

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	rust-ts-mode--font-lock-settings: Improve consistency

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--font-lock-settings):
	Remove the rule that highlighted scope identifier in a function call
	as type.  The existing rules will handle it when it does look like a
	type (capitalized).

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Make sure 'M-x show-paren-local-mode' turns on right away

	* lisp/paren.el (show-paren--enabled-p): Extract from
	'show-paren-function'.
	(show-paren-local-mode): Use it in the :variable getter (bug#61098).

2023-04-15  Tassilo Horn  <tsdh@gnu.org>

	Add to bug-reference-auto-setup-functions after its declaring defvar

	If it's the init-value of the defvar, add-hook from a third-party
	package will suppress the default functions if it takes place before
	bug-reference is loaded.

	* lisp/progmodes/bug-reference.el (bug-reference-auto-setup-functions):
	Add to bug-reference-auto-setup-functions after its declaring defvar.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/vc/vc.el (vc-find-revision-no-save): Fix parens (bug#61256).

	Move '(setq failed nil)' from UNWINDFORMS of 'unwind-protect' to BODYFORM.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Fix inability to turn show-paren-local-mode on manually (bug#61098)

	* lisp/paren.el (show-paren-local-mode): Don't kill the local
	value when both local and global are t.  Because the
	show-paren-predicate check in show-paren-function also checks
	whether a local (non-nil) value of this variable exists.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	rust-ts-mode: Highlight variable declarations

	(rust-ts-mode--font-lock-settings): Change scoped_type_identifier
	highlight to match similar cases.  Highlight variable declarations
	inside all kinds of destructuring patterns, not just function
	definitions.
	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--fontify-pattern):
	Rename from 'rust-ts-mode--fontify-parameter'.  Check the id node's
	parent to avoid touching type identifiers.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	rust-ts-mode--indent-rules: Indent to 0 at top level

2023-04-15  Alan Mackenzie  <acm@muc.de>

	Ensure upper bound of font-lock region is less than point-max

	This fixes bug #61298.  The new long-lines code may have narrowed a buffer
	before font-lock-default-fontify-region gets called.

	* lisp/font-lock.el (font-lock-default-fontify-region): Set `end' to point-max
	if it is greater that it.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Highlight more complex function parameters

	* lisp/progmodes/rust-ts-mode.el
	(rust-ts-mode--fontify-parameter): New function.
	(rust-ts-mode--font-lock-settings): Use it.

2023-04-15  Jonas Bernoulli  <jonas@bernoul.li>

	No longer use transient in isearch-emoji-by-name

	* lisp/isearch.el (isearch-emoji-by-name): Use 'emoji--read-emoji'
	and if that returns derivations, 'completing-read' to select one
	of them.  This fixes bug#60740.
	* lisp/international/emoji.el (emoji--init): Autoload.
	(emoji--read-emoji): New function, which doesn't use transient
	and returns a list of the glyph and all derivations, if any.
	(emoji--choose-emoji): Use 'emoji--read-emoji'.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Make highlighting more regular across TS modes (bug#61205)

	* doc/emacs/display.texi (Parser-based Font Lock):
	Update description of treesit-font-lock-level, moving 'property' to
	level 4.

	* lisp/treesit.el (treesit-font-lock-level): Likewise, in docstring.

	* lisp/progmodes/c-ts-mode.el (c-ts-base-mode): Do that here.

	* lisp/progmodes/cmake-ts-mode.el (cmake-ts-mode): Add a comment.

	* lisp/progmodes/go-ts-mode.el (go-ts-mode): Add 'definition' to
	level 1.  Move 'function', 'property' and 'variable' to level 4.
	(go-ts-mode--font-lock-settings): Move a bunch of existing rules
	to 'definition'.  Add highlighting of function parameters.

	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode)
	(rust-ts-mode--font-lock-settings): Same.  And also change "scoped
	identifiers" highlights to only match capitalized names.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Document 'plistp'

	* doc/lispref/lists.texi (Property Lists): Document 'plistp'.
	(Bug#61293)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix display of raised/lowered composed text

	* src/xdisp.c (fill_gstring_glyph_string): Adjust the base line of
	the glyph string due to subscript/superscript.  (Bug#61290)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix installation of tree-sitter grammar on MS-Windows

	* lisp/treesit.el (treesit--install-language-grammar-1): Fix a
	failure on MS-Windows when the old DLL is still being used.
	(Bug#61289)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Update the Emacs FAQ for Emacs 29

	* doc/misc/efaq.texi (New in Emacs 29, History of Emacs): Add new
	section about Emacs 29.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix byte-compilation of *-ts-mode.el files

	* lisp/treesit.el (treesit-font-lock-settings): Move to before
	use, to prevent failure in byte-compiling modes which require this
	file.  (Bug#61282)

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Make c-ts-mode-set-style's effect local (bug#61245)

	Now c-ts-mode-set-style's effect is local, and there is a new function
	c-ts-mode-set-global-style that changes the global setting.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--indent-style-setter): Use c-ts-mode-set-style.
	(c-ts-mode-indent-style)
	(c-ts-mode--prompt-for-style): Minor change in docstring.
	(c-ts-mode-set-global-style): New function (from c-ts-mode-set-style).
	(c-ts-mode-set-local-style): Remove function (became c-ts-mode-set-style).
	(c-ts-mode-set-style): Renamed from c-ts-mode-set-local-style.
	* test/lisp/progmodes/c-ts-mode-resources/indent-bsd.erts:
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: Use
	c-ts-mode-set-style.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	c-ts-mode: Highlight name in parameter declarations

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--font-lock-settings):
	Uncomment parameter declaration highlighting (bug#61275).
	(c-ts-mode--fontify-declarator): Check that identifier was found.
	Some declarations can miss identifier name.

2023-04-15  Davide Masserut  <dm@mssdvd.com>

	Fix switch statement indentation for go-ts-mode (bug#61238)

	* lisp/progmodes/go-ts-mode.el (go-ts-mode--indent-rules): Add
	indentation for type switch and select case blocks
	* test/lisp/progmodes/go-ts-mode-resources/indent.erts: New .erts file
	to test indentation of Go constructs and prevent regression of bug
	fixes.
	* test/lisp/progmodes/go-ts-mode-tests.el: New file with go-ts-mode
	tests.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix bidi reordering of sequence of whitespace characters before a TAB

	* src/bidi.c (bidi_level_of_next_char): Test the current level
	only for characters whose original type is BN.  (Bug#61269)

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Add tests for compilation support for TypeScript (bug#61104)

	* test/lisp/progmodes/compile-tests.el
	(compile-tests--test-regexps-data): Add new test-cases.
	(compile-test-error-regexps): Increase expected errors

2023-04-15  Jostein Kjønigsen  <jostein@kjonigsen.net>

	Add support for TypeScript compilation to compile.el (bug#61104)

	* lisp/progmodes/compile.el (compilation-error-regexp-alist-alist):
	Add regexps.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Don't clobber match data in 'y-or-n-p'

	* lisp/subr.el (y-or-n-p): Avoid clobbering caller's match data.
	(Bug#61091)

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Refine the previous change

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--s-p-query): Fix a typo.
	(ruby-ts--syntax-propertize): Use pcase-exhaustive to avoid typos.
	Put the last s-t property after heredoc's end (apparently
	parse-partial-sexp likes that more).  Move first s-t property on
	percent literals to the very beginning (to be refined later).
	Differentiate the %r{} literals from /.../ ones -- tree-sitter
	parses them exactly the same.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Add syntax-propertize-function to ruby-ts-mode

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--s-p-query):
	New variable.
	(ruby-ts--syntax-propertize): New function.
	(ruby-ts--parser-after-change): New function.
	(ruby-ts-mode): Use both of them.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'header-line-indent-mode'

	* doc/lispref/modes.texi (Header Lines): Rewrite the documentation
	of 'header-line-indent-mode' and its two variables.  Fix the
	example.
	* doc/lispref/display.texi (Pixel Specification): More accurate
	description of what happens with :align-to in header-lines.
	Improve indexing.  (Bug#61239)

	* src/buffer.c (syms_of_buffer) <header-line-format>:
	* lisp/display-line-numbers.el (header-line-indent)
	(header-line-indent-width, header-line-indent-mode): Doc fixes.

	* etc/NEWS: Enhance the announcement of 'header-line-indent-mode'.

2023-04-15  F. Jason Park  <jp@neverwas.me>

	Don't casemap erc-sasl-user when set to :nick

	* lisp/erc/erc-sasl.el (erc-sasl-user): Fix doc string.
	(erc-sasl--get-user): Don't apply casemapping when the option
	`erc-sasl-user' is set to `:nick'.  While many servers and
	auth-services providers perform case-folding when comparing SASL
	usernames, only some recognize RFC1459 mappings, which ERC previously
	applied blindly.  Instead, ERC now behaves like other clients in
	leaving such preparation in the hands of the server.  This bug was
	introduced with changes new to ERC 5.5 and Emacs 29 (bug#29108).

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Improve keymap-global-set and keymap-local-set interactive use fix

	* lisp/keymap.el (keymap-global-set, keymap-local-set): Add optional
	`interactive' arg and use it to decide when to convert the key
	specification to a string.  Add `advertised-calling-convention'
	declarations.  (Bug#61149)

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Make c-ts-mode indent tests side-effect-free

	Running indent tests changes the global value of
	c-ts-mode-indent-style.  That's not good.  This change fixes that.

	I also refactored the indent style functions a bit.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--prompt-for-style): New function.
	(c-ts-mode-set-local-style): New function.
	(c-ts-mode-set-style): Use c-ts-mode--prompt-for-style.  Use
	derived-mode-p when testing for major mode.  Remove check of current
	buffer's major mode since it doesn't matter.

	* test/lisp/progmodes/c-ts-mode-resources/indent-bsd.erts:
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: Use
	c-ts-mode-set-local-style to set the indent style locally.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Call treesit_record_change in insert_from_gap_1

	Before this change, insert_from_gap calls treesit_record_change but
	insert_from_gap_1 doesn't.  However, insert_from_gap_1 is a public
	function and is called in many other places outside of insdel.c.  This
	could lead to tree-sitter's parse tree becoming out-of-sync with the
	buffer content.

	This change might fix bug#60650.

	* src/insdel.c (insert_from_gap_1): Call treesit_record_change.
	(insert_from_gap): Remove call to treesit_record_change.

	* admin/notes/tree-sitter/treesit_record_change: New file.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Use c-ts-common-statement-offset for closing brackets too

	Merge c-ts-mode--close-bracket-offset into
	c-ts-common-statement-offset.

	* lisp/progmodes/c-ts-common.el:
	(c-ts-common-statement-offset): Handle closing brackets too.
	(c-ts-mode--close-bracket-offset): Remove function.
	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Use
	c-ts-common-statement-offset for closing brackets.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Minor improvements in sqlite.c

	* src/sqlite.c (Fsqlite_next): Doc fix.  Return nil if SQLITE_DONE
	was once seen for this statement.  (Bug#61151)
	(row_to_value): Cons the value in reverse, to avoid the Fnreverse
	call.  Patch by Helmut Eller <eller.helmut@gmail.com>.
	(Bug#61165)

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(treesit_predicate_match): Match node text against regexp without consing

	* src/treesit.c (treesit_predicate_match): Match node text against
	regexp without creating a new string object (bug#60953).

	* src/search.c (search_buffer): Make not static.
	Delete declaration near the beginning of the file.

	* src/lisp.h: Declare it here.

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--builtin-method-p):
	Remove function.
	(ruby-ts--font-lock-settings): Use the regexp with :match directly.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of gdb-mi's dedicated windows

	* doc/emacs/building.texi (Other GDB Buffers): Describe the I/O
	buffer and commands to show individual specialized windows.
	Improve indexing.

2023-04-15  Kévin Le Gouguec  <kevin.legouguec@gmail.com>

	Avoid spurious pause in kill-ring-save (Bug#60841)

	'indicate-copied-region' checks whether the region is "highlighted"
	and if not, briefly moves point to mark to give a visual cue of the
	extent of text that was saved to the kill ring.

	The region is considered "highlighted" if (a) it is active and (b) its
	face specifies a :background.  That latter condition does not account
	for the multiple ways in which the face can make the region "visually
	distinct" from the default face, so switch to the more extensive
	predicate face-differs-from-default-p.

	The patch also fixes a couple of issues with the predicate's
	implementation, and introduces a new user option in case anyone
	happened to enjoy unconditional blinking.

	* lisp/faces.el (face-differs-from-default-p): Filter out :extend; add
	rationale for the attributes we ignore.
	* lisp/simple.el (copy-region-blink-predicate): Add option to let
	users explicitly opt into or out of blinking point and mark.
	(region-indistinguishable-p): New function to detect
	"if there is currently no active region highlighting", leveraging
	face-differs-from-default-p.
	(indicate-copied-region): Use it.
	* src/xfaces.c (merge_face_ref): Allow :stipple to be nil, since it is
	a documented valid value for that attribute.
	* etc/NEWS: Announce user option.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Change the default of 'treesit-defun-tactic' for 'c-ts-mode'

	* lisp/progmodes/c-ts-mode.el (c-ts-mode): Set
	'treesit-defun-tactic' as appropriate for C.  (Bug#61208)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>  (tiny change)

	Fix docstring fontification of CL's 'defstruct'

	* lisp/emacs-lisp/lisp-mode.el (defstruct): Set 'doc-string'
	property.  Patch by Nicolas Martyanoff <nicolas@n16f.net>.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Teach 'hs-minor-mode' about tree-sitter based modes

	* lisp/progmodes/hideshow.el (hs-special-modes-alist): Teach
	'hs-minor-mode' about tree-sitter based modes.  (Bug#61232)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'repeat-mode' and related variables

	* lisp/bindings.el (next-error-repeat-map)
	(page-navigation-repeat-map, undo-repeat-map):
	* lisp/tab-bar.el (tab-bar-switch-repeat-map)
	(tab-bar-move-repeat-map):
	* lisp/window.el (other-window-repeat-map)
	(resize-window-repeat-map): Mention repeatable commands in the doc
	strings.
	* lisp/repeat.el (repeat-exit-timeout, repeat-check-key)
	(repeat-echo-function, repeat-mode, repeat-check-key)
	(repeat-check-map, repeat-echo-message-string)
	(repeat-echo-message, repeat-echo-mode-line)
	(describe-repeat-maps): Improve wording of doc strings.
	(describe-repeat-maps): Improve wording of the heading line.
	(Bug#61183)

	* doc/emacs/basic.texi (Repeating): Clarify and improve wording of
	'repeat-mode' documentation.

2023-04-15  Nicolas Martyanoff  <nicolas@n16f.net>

	(eshell--complete-commands-list): Fix regression in fix to bug#48995

	Copyright-Paperwork-Exempt: Yes

	* lisp/eshell/em-cmpl.el (eshell--complete-commands-list):
	Fix misuse of `completion-table-dynamic` when completing a file name.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* doc/emacs/basic.texi (Repeating): Mention describe-repeat-maps (bug#61183).

	* lisp/repeat.el (describe-repeat-maps): Add more explanation to
	the docstring.  Suggested by Robert Pluim <rpluim@gmail.com>.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Unbreak the MS-Windows build

	* src/treesit.c (ts_query_pattern_count) [WINDOWSNT]: Load from
	the library and define as macro.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(Ftreesit_query_capture): Cache list of predicates for given pattern index

	* src/treesit.c (Ftreesit_query_capture):
	Cache list of predicates for given pattern index (bug#60953).

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	* lisp/keymap.el (keymap-global-unset): Correct prompt

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix cursor-in-echo-area on TTY frames

	* src/dispnew.c (update_frame_1): Fix off-by-one error when
	positioning the cursor in the echo-area.  (Bug#61184)

2023-04-15  Jonas Bernoulli  <jonas@bernoul.li>

	Update to Transient v0.3.7-196-gb91f509

2023-04-15  Alan Mackenzie  <acm@muc.de>

	CC Mode: Fix a coding bug in c-make-keywords-re.  This should fix bug #61135

	* lisp/progmodes/cc-defs.el (c-make-keywords-re): Generate "\>" components in
	result regexp when argument ADORN is `appendable'.  This fully fixes a bug
	which was half-fixed on 2019-01-22.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/isearch.el (isearch-emoji-by-name): Disable derived emoji (bug#60740).

	Let-bind emoji--derived to nil to avoid the subsequent selection
	of derived emoji that fails in transient.el.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix keymap inheritance in descendants of 'c-ts-base-mode'

	* lisp/progmodes/c-ts-mode.el (c-ts-base-mode-map): Rename from
	'c-ts-mode-map'.
	(c-ts-base-mode): Adjust accordingly.  (Bug#60983)

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Fix interactive use of `keymap-local-set' and `keymap-global-set'

	* lisp/keymap.el (keymap-global-set, keymap-local-set): Convert the
	read key sequence to a string when called interactively.  Based on a
	patch from Stephen Berman <stephen.berman@gmx.net>.  (Bug#61149)

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Fix password prompt in Tramp (do not merge)

	* lisp/net/tramp.el (tramp-password-prompt-regexp):
	Allow alternative trailing colons.  (Bug#61168)

2023-04-15  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.1-23-gc45a05

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Document tree-sitter features in the user manual

	* lisp/progmodes/c-ts-mode.el (c-ts-mode-map): Bind "C-c .", for
	consistency with CC mode.
	* lisp/treesit.el (treesit-font-lock-level): Doc fix.

	* doc/emacs/programs.texi (C Indent, Custom C Indent): Document
	the indentation features of 'c-ts-mode'.
	(Moving by Defuns): Document 'treesit-defun-tactic'.
	* doc/emacs/files.texi (Visiting): Document
	'treesit-max-buffer-size'.
	* doc/emacs/display.texi (Traditional Font Lock)
	(Parser-based Font Lock): New subsections.
	* doc/emacs/emacs.texi (Top): Update top-level menu.

2023-04-15  Randy Taylor  <dev@rjt.dev>

	Fix dockerfile-ts-mode line continuation indentation (bug#61131)

	Without this rule, line continuations are only indented after entering
	the contents for the line and hitting TAB or RET.

	For example:
	```
	EXPOSE 1 \
	```

	After hitting RET to go to the next line, point would end up at BOL
	instead of lining up with the previous entry, like so:
	```
	EXPOSE 1 \
	2
	```

	The new rule will indent it as so:
	```
	EXPOSE 1 \
	       2
	```

	* lisp/progmodes/dockerfile-ts-mode.el:
	(dockerfile-ts-mode--indent-rules): New rule.
	(dockerfile-ts-mode--line-continuation-p)
	(dockerfile-ts-mode--line-continuation-anchor): New functions.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Use treesit-subtree-stat to determine treesit--font-lock-fast-mode

	* lisp/treesit.el:
	(treesit--children-covering-range-recurse): Return nil if LIMIT is
	exceeded.
	(treesit--font-lock-fast-mode): Change to a ternary value.
	(treesit-font-lock-fontify-region): Enable fast mode based on the
	result of treesit-subtree-stat.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add treesit-subtree-stat

	* src/treesit.c (Ftreesit_subtree_stat): New function.
	* lisp/treesit.el (treesit): Add to shortdoc.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Move c-ts-mode--statement-offset to c-ts-common.el

	Now it can be used by other C-like languages.

	* lisp/progmodes/c-ts-common.el (c-ts-common-indent-offset):
	(c-ts-common-indent-block-type-regexp):
	(c-ts-common-indent-bracketless-type-regexp): New variables.
	(c-ts-common-statement-offset):
	(c-ts-mode--fix-bracketless-indent):
	(c-ts-mode--close-bracket-offset): New functions.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Change
	c-ts-mode--statement-offset to c-ts-common-statement-offset.
	The (parent-is "if_statement") rules are now handled by (node-is
	"compound_statement").

	(c-ts-mode--statement-offset-post-processr):
	(c-ts-mode--statement-offset):
	(c-ts-mode--fix-bracketless-indent): Move to c-ts-common.el.

	(c-ts-base-mode): Setup c-ts-common stuff.

	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: Make the test
	more challenging.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix <> syntax in rust-ts-mode

	Similar to bug#60351, the angle brackets in rust-ts-mode are not
	recognized as pairs when they should be.  This change copies the
	function used by c++-ts-mode and adapts it to rust-ts-mode.

	* lisp/progmodes/rust-ts-mode.el:
	(rust-ts-mode--syntax-propertize): New function.
	(rust-ts-mode): Set up syntax-propertize-function.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix spurious errors on Windows when deleting temporary *.eln files

	* lisp/emacs-lisp/comp.el (comp--native-compile): On MS-Windows,
	ignore errors when deleting a temporary .eln file.  (Bug#60996)

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Fix java class member without access modifier (bug#61115)

	This

	```
	public class T {
	    @Autowired
	        String a;
	}
	```

	Should be indented as:

	```
	public class T {
	    @Autowired
	    String a;
	}
	````

	* lisp/progmodes/java-ts-mode.el (java-ts-mode--indent-rules): Add new
	rule to match edge case of field_declaration indentation.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Make treesit-font-lock-level a defcustom

	* lisp/treesit.el (treesit--font-lock-level-setter): Setter for the
	new defcustom.
	(treesit-font-lock-level): Turn it into a defcustom.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Add c-ts-mode-set-style and :set for c-ts-mode-indent-style

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-style-setter): New
	setter for the indent style defcustom.
	(c-ts-mode-indent-style): Don't quote the values and refer to the
	setter.
	(c-ts-mode-set-style): New command to interactively set the indent
	style.
	(c-ts-mode--get-indent-style): New function renamed from
	'c-ts-mode--set-indent-style'.

2023-04-15  Juri Linkov  <juri@linkov.net>

	Minor documentation improvements for outline-minor-mode (bug#61062)

	* doc/emacs/text.texi (Outline Minor Mode, Outline Minor Mode):
	Add pxrefs to "Icons" and "Outline Visibility".

	* etc/NEWS: Mention outline-minor-mode for two modes.

2023-04-15  Brian Leung  <leungbk@posteo.net>

	python.el: Use correct regexp when enabling python-ts-mode

	* lisp/progmodes/python.el: Use "python[0-9.]*" regexp for
	'interpreter-mode-alist', and not 'auto-mode-alist'.  (Bug#61090)

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Make project-current not error out inside non-existent dirs

	* lisp/progmodes/project.el (project-try-vc):
	Use condition-case to catch 'file-missing' (bug#61107).

	* test/lisp/progmodes/project-tests.el
	(project-vc-nonexistent-directory-no-error): New test.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'shell-command-dont-erase-buffer'

	* doc/emacs/misc.texi (Single Shell):
	* lisp/simple.el (shell-command, shell-command-on-region):
	Document that non-nil value of 'shell-command-dont-erase-buffer'
	affects what is displayed in the echo area after the command.
	(Bug#61100)

2023-04-15  Jostein Kjønigsen  <jostein@kjonigsen.net>

	Fix errors in fontification of JavaScript import-statements (bug#61083)

	Currently js-ts-mode handles imports with aliases incorrectly. To be
	consistent with how we otherwise do things, we should only highlight
	the variable which is new and/or introduced, in this case "someAlias".

	Attached is a patch which fontifies import-declarations somewhat more
	correctly.

	The following cases have been tested and all fontify properly:

	import gnu from "fsf";              // highlights gnu
	import { gnu2 } from "fsf2";        // highlights gnu2
	import { gnu as gnu3 } from "fsf3"; // highlights gnu3
	import * as gnu4 from "fsf4";       // highlights gnu4

	* lisp/progmodes/js.el (js--treesit-font-lock-settings): Add new
	import_clause rules that adhere to the comment above.

2023-04-15  Jostein Kjønigsen  <jostein@kjonigsen.net>

	Fix fontification TypeScript of import-statements (bug#61081)

	Currently typescript-ts-mode and tsx-ts-mode handles imports with
	aliases incorrectly.

	Consider the following case:

	import { someFunc as someAlias } from "module";

	In this case the entire import ("someFunc as someAlias") will be
	highlighted as a variable name. "as" is also highlighted as a
	variable, rather than a reserved keyword.

	To be consistent with how we otherwise do things, we should only
	highlight the variable which is new and/or introduced, in this case
	"someAlias".

	Attached is a patch which fontifies import-declarations somewhat more
	correctly.

	The following cases have been tested and all fontify properly:

	import gnu from "fsf";              // highlights gnu
	import { gnu2 } from "fsf2";        // highlights gnu2
	import { gnu as gnu3 } from "fsf3"; // highlights gnu3
	import * as gnu4 from "fsf4";       // highlights gnu4

	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--font-lock-settings): Tweak import_clause rules to
	adhere to the comment above.

2023-04-15  Basil L. Contovounesios  <contovob@tcd.ie>

	Work around package.el transitive dependency bug

	Eglot already depends transitively on Xref 1.4.0 via Project,
	but package.el doesn't pick up on this in Emacs 28
	(which has Xref 1.3.0).

	* lisp/progmodes/eglot.el (Version): Bump to 1.11.
	(Package-Requires): Explicitly require Xref 1.4.0, which is
	the version already required by Project, for the benefit of
	Emacs 28 (bug#61048).

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix xt-mouse on terminals that report UTF-8 encoded coordinates

	* lisp/xt-mouse.el (xterm-mouse--read-coordinate): Fix conversion
	of mouse coordinates in rxvt-unicode.  Patches by Vladimir
	Panteleev <git@cy.md> and Jared Finder <jared@finder.org>.
	(Bug#61022)

2023-04-15  Randy Taylor  <dev@rjt.dev>

	Fix go-ts-mode indentation and set indent offset to 8 (Bug#61006)

	* lisp/progmodes/go-ts-mode.el (go-ts-mode-indent-offset): Change
	default value to 8.
	(go-ts-mode--indent-rules): Add indentation for parameters and
	interfaces.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix doc strings of window-splitting commands

	* lisp/window.el (split-window-below, split-window-right): Doc
	fixes.  (Bug#60886)

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix indentation for c-ts-mode (bug#61026)

	Fix indentation for things like

	  while (true)
	    if (true)
	      {
	        puts ("Hello");
	      }

	Note that the outer while loop omits brackets.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--statement-offset-post-processr): New variable.
	(c-ts-mode--statement-offset): Use the new function.
	(c-ts-mode--fix-bracketless-indent): New function.
	(c-ts-base-mode): Use the new function.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New tests.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix call to treesit_record_change in insdel.c

	The start position of the change shouldn't be PT_BYTE, IIUC PT_BYTE is
	actually the end position.

	* src/insdel.c (insert_from_buffer): Move to here.
	(insert_from_buffer_1): Remove call to treesit_record_change.

2023-04-15  Randy Taylor  <dev@rjt.dev>

	Add support for building tree-sitter modules with MinGW

	* admin/notes/tree-sitter/build-module/build.sh: Add support for
	building tree-sitter modules with MinGW.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/net/tramp.el (tramp-wrong-passwd-regexp): Fix regexp.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* doc/emacs/text.texi (Outline Minor Mode): New node split from "Outline Mode"

	(Outline Mode): Move all outline-minor-mode related information to the
	new node "Outline Minor Mode" (bug#61062).

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Don't reindent when "class" or "def" is under "ERROR"

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--indent-rules):
	Don't reindent when "class" or "def" is under "ERROR" (bug#61017).

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	treesit-install-language-grammar: Provide default repo url

	* lisp/treesit.el (treesit--check-repo-url): New function.
	(treesit--install-language-grammar-build-recipe): Use it (bug#61051).

2023-04-15  Basil L. Contovounesios  <contovob@tcd.ie>

	Fix Dired face for directory symlinks

	* lisp/dired.el (dired-font-lock-keywords): Fontify directory
	symlinks with the value of dired-directory-face rather than its name
	as a (nonexistent) face (bug#60977).

2023-04-15  Basil L. Contovounesios  <contovob@tcd.ie>

	Pacify --without-x unused function warning

	* src/xfaces.c (font_maybe_unset_attribute): Move definition...
	[HAVE_WINDOW_SYSTEM] (font_maybe_unset_attribute): ...to here, since
	the function is used only when we HAVE_WINDOW_SYSTEM (bug#61049).

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Announce outline.el keymaps

	* etc/NEWS: Announce new keymaps.

2023-04-15  Jostein Kjønigsen  <jostein@kjonigsen.net>

	Fix fontification of function-valued variables (bug#61053)

	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--font-lock-settings): Remove overrides and reorder
	the variable_declarator rule.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Add new java indent rules

	* lisp/progmodes/java-ts-mode.el (java-ts-mode--indent-rules): Check
	for enum_body_declarations and switch_label.

2023-04-15  Juri Linkov  <juri@linkov.net>

	Handle relative file names in vc-resynch-window and vc-resynch-buffer

	* lisp/vc/vc-dispatcher.el (vc-resynch-window, vc-resynch-buffer):
	While comparing with `buffer-file-name' if `file' is not absolute
	use `expand-file-name' in `vc-root-dir'.  This fixes the case of
	refreshing the buffers after typing `C-x v = C-x v u' (bug#60897).

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Use named keymaps for outline buttons

	https://lists.gnu.org/archive/html/emacs-devel/2023-01/msg00334.html

	* lisp/outline.el (outline-button-icon-map)
	(outline-overlay-button-map, outline-inserted-button-map):
	Keymaps refactored from outline--create-button-icons and
	outline--insert-button.
	(outline--create-button-icons, outline--insert-button): Move
	keymaps to separate variables.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/vc/vc-bzr.el (vc-bzr--pushpull): Return buffer's process.

	* lisp/vc/vc-git.el (vc-git--pushpull): Add comment.

	* lisp/vc/vc.el (vc-pull-and-push): Expand docstring about
	prerequisites for backend to support this command (bug#60569).

2023-04-15  Alan Mackenzie  <acm@muc.de>

	CC Mode: Change the default value of objc-font-lock-extra-types to nil

	This fixes bug #59234, in which random identifiers in a .m file were getting
	fontified as types.

	* lisp/progmodes/cc-vars.el (objc-font-lock-extra-types): Change the default
	value to nil.

	* etc/NEWS: Mention the change in default value of objc-font-lock-extra-types,
	and how to get the old behavior back.

2023-04-15  Jim Porter  <jporterbugs@gmail.com>

	Don't try to make a pipe process for remote processes in Eshell

	Tramp currently isn't able to handle this, so the result will just
	produce an error (bug#61024).

	* lisp/eshell/esh-proc.el (eshell-gather-process-output): Check for a
	remote 'default-directory' before trying to make a pipe process.

	* test/lisp/eshell/esh-proc-tests.el
	(esh-var-test/output/remote-redirect): New test.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	* lisp/startup.el (command-line): Fix warning message.  (Bug#61014)

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/find-dired.el (find-dired): Fix bug where M-p skips first history item.

	Don't apply "skip first duplicate history item" trick when find-args
	used as initial input is nil.

2023-04-15  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.1-16-ge37e9b

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(ruby-ts--predefined-variables): Fix the $` and $' entries

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--predefined-variables):
	Fix the $` and $' entries, somehow replaced by curly quote.

	Reported by Mattias Engdegård.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/find-dired.el (find-dired-with-command): Quote find-command-history.

2023-04-15  Juri Linkov  <juri@linkov.net>

	Generalize vc-pull-and-push to support more backends (bug#60569)

	* lisp/vc/vc-git.el (vc-git-pull-and-push): Remove and move its logic to
	vc-pull-and-push.

	* lisp/vc/vc.el (vc-pull-and-push): Add code from vc-git-pull-and-push.

2023-04-15  Benjamin Riefenstahl  <b.riefenstahl@turtle-trading.net>

	Add test suite for sgml-html-meta-auto-coding-function

	* test/lisp/international/mule-tests.el (sgml-html-meta-pre)
	(sgml-html-meta-post, sgml-html-meta-run, sgml-html-meta-utf-8)
	(sgml-html-meta-windows-hebrew, sgml-html-meta-none)
	(sgml-html-meta-unknown-coding, sgml-html-meta-no-pre)
	(sgml-html-meta-no-post-less-than-10lines)
	(sgml-html-meta-no-post-10lines, sgml-html-meta-utf-8-with-bom): Add.

2023-04-15  Benjamin Riefenstahl  <b.riefenstahl@turtle-trading.net>

	Fix decoding HTML files from archives

	* lisp/international/mule.el (sgml-xml-auto-coding-function): Avoid
	signaling an error from coding-system-equal when the XML encoding tag
	specifies an encoding whose type is 'charset'.  (Bug#61005)

	This is the same fix as in #df7ed10e for
	sgml-xml-auto-coding-function.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Avoid crashes in batch Emacs sub-processes on MS-Windows

	* src/w32.c (shutdown_handler): When run in a separate thread,
	don't call functions that only the main (a.k.a. "Lisp") thread can
	call; instead, arrange for maybe_quit to kill Emacs.
	* src/w32fns.c (emacs_abort): Don't show GUI Abort dialogs in
	non-interactive sessions.  (Bug#60556)

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Tweak BSD style indentation (bug#60984)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Simplify
	rules.
	* test/lisp/progmodes/c-ts-mode-resources/indent-bsd.erts: New
	testfile with bsd style indentation examples.
	* test/lisp/progmodes/c-ts-mode-tests.el
	(c-ts-mode-test-indentation-bsd): Add a test for the new style.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Fix typo of exposed symbol name

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Remove
	double hyphen.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Fix typo after move to common lib (bug#61001)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Use correct
	preset.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Fix two additional cases with ruby-method-call-indent=nil

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--indent-rules):
	Fix two additional cases with ruby-method-call-indent=nil.

	* test/lisp/progmodes/ruby-mode-resources/ruby-method-call-indent.rb:
	Add examples.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-mode.el: Expand some docstrings with examples

	* lisp/progmodes/ruby-mode.el (ruby-align-chained-calls)
	(ruby-method-params-indent): Expand docstrings with examples.

2023-04-15  Po Lu  <luangruo@yahoo.com>

	Minor fixes for Haiku

	* lisp/frame.el (display-symbol-keys-p):
	* lisp/simple.el (normal-erase-is-backspace-setup-frame): Add
	support for Haiku.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Move c-like common utils into own library (bug#60961)

	* lisp/progmodes/c-ts-common.el: New file.
	* lisp/progmodes/c-ts-mode.el (treesit-induce-sparse-tree): Remove
	unused declaration.
	(c-ts-mode--indent-styles): Refer to the new library.
	(c-ts-mode--looking-at-star,
	c-ts-mode--comment-start-after-first-star,
	c-ts-mode--comment-2nd-line-matcher,
	c-ts-mode--comment-2nd-line-anchor, c-ts-mode--comment-regexp,
	c-ts-mode--fill-paragraph, c-ts-mode--fill-block-comment): Move to
	c-ts-common and expose as public.
	(c-ts-mode-comment-setup): Move to c-ts-common.
	* lisp/progmodes/csharp-mode.el (c-ts-common): Require new library.
	(csharp-ts-mode--indent-rules): Refer to the new symbols.
	(csharp-ts-mode): Use new function.
	* lisp/progmodes/java-ts-mode.el (c-ts-common): Require new library.
	(java-ts-mode--indent-rules): Refer to the new symbols.
	(java-ts-mode): Use new function.
	* lisp/progmodes/js.el (c-ts-common): Require new library.
	(js--treesit-indent-rules): Refer to the new symbols.
	(js-ts-mode): Use new function.
	* lisp/progmodes/rust-ts-mode.el (c-ts-common): Require new library.
	(rust-ts-mode--indent-rules): Refer to the new symbols.
	(rust-ts-mode): Use new function.
	* lisp/progmodes/typescript-ts-mode.el (c-ts-common): Require new
	library.
	(typescript-ts-mode--indent-rules): Refer to the new symbols.
	(typescript-ts-base-mode): Use new function.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Fix file-regular-p in Tramp

	* test/lisp/net/tramp-archive-tests.el
	(tramp-archive-test18-file-attributes)
	(tramp-archive-test21-file-links):
	* test/lisp/net/tramp-tests.el (tramp-test18-file-attributes)
	(tramp-test21-file-links): Adapt tests.

	* lisp/net/tramp.el (tramp-handle-file-regular-p): Fix symlink
	case.  (Bug#60943)

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Fix typo in c-ts-mode (bug#60932)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode-indent-block-type-regexp):
	enumerator, not enumeratior.

2023-04-15  Mike Kupfer  <kupfer@rawbw.com>

	MH-E: handle removal of mhparam libdir from nmh 1.8

	* lisp/mh-e/mh-e.el (mh-variant-nmh-info): If "libdir" doesn't
	work, try "libexecdir" (Bug#60952) (SF#491).

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Use point-min to anchor top-level constructs (bug#60602)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): New anchor.
	* lisp/progmodes/java-ts-mode.el (java-ts-mode--indent-rules): New
	anchor.
	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--indent-rules): New anchor.
	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--indent-rules): New anchor.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	* lisp/org/ob-ruby.el: Fix outdated comments.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(project-try-vc): Add string-start and string-end anchors to marker-re

	* lisp/progmodes/project.el (project-try-vc):
	Add string-start and string-end anchors to marker-re (bug#60956).

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Make `keymap-set-after' work for menus

	It still doesn't work for an AFTER that's a key, though, since
	`key-parse' produces vectors, and keymaps contain integers.

	* lisp/keymap.el (keymap-set-after): Only parse AFTER as a key if it's
	a string.  For consistency, use `key-parse' on the definition if it's
	a string, just like `keymap-set'.
	* test/src/keymap-tests.el (keymap-tests--command-3): New dummy command.
	(keymap-set-after-menus): New test.  Check that we can insert a menu
	item after a specific entry.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Use `key-parse' in `keymap-lookup'

	It's stricter than `kbd', and doesn't try to do anything with key
	sequences that look like macros.

	* lisp/keymap.el (keymap-lookup): Use `key-parse' instead of `kbd'.
	* test/src/keymap-tests.el (keymap-set-after-menus): Test the
	`keymap-set-after' API.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Improve `keymap-set-after' documentation

	* doc/lispref/keymaps.texi (Changing Key Bindings): Mention `key-valid-p'
	(Modifying Menus): Correct description of KEY arg.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Handle after arg correctly in `keymap-set-after'

	* lisp/keymap.el (keymap-set-after): AFTER: t means the same as nil,
	so just change it to nil.  (Bug#60867)

2023-04-15  F. Jason Park  <jp@neverwas.me>

	Don't load erc-goodies atop erc.el

	* lisp/erc/erc.el: Commit c2d657e7c4fd9685591f2120007eabf78745919d
	"Move ERC's core dependencies to a separate file" ironed out ERC's
	interwoven dependencies for the better but didn't cleanly sidestep the
	goodies interdependency, specifically with regard to custom options.
	This reverts the tiny portion impacting this aspect by once again
	requiring `erc-goodies' at the very end of ERC's main library. Special
	thanks to Libera.Chat user jrm for reporting this bug.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Make tree-sitter based modes optional

	* lisp/progmodes/c-ts-mode.el: Update Commentary.  Make
	'auto-mode-alist' update conditional on the tree-sitter and
	grammar libraries being available.
	* lisp/progmodes/cmake-ts-mode.el:
	* lisp/progmodes/csharp-mode.el:
	* lisp/progmodes/dockerfile-ts-mode.el:
	* lisp/progmodes/go-ts-mode.el:
	* lisp/progmodes/java-ts-mode.el:
	* lisp/progmodes/js.el:
	* lisp/progmodes/json-ts-mode.el:
	* lisp/progmodes/python.el:
	* lisp/progmodes/ruby-ts-mode.el:
	* lisp/progmodes/typescript-ts-mode.el:
	* lisp/textmodes/css-mode.el:
	* lisp/textmodes/toml-ts-mode.el:
	* lisp/textmodes/yaml-ts-mode.el: Make 'auto-mode-alist' update
	for tree-sitter based modes be conditional on the tree-sitter and
	grammar libraries being available.  (Bug#60559)

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Claw back half of the performance drop from last change

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--builtin-method-p):
	New function.
	(ruby-ts--font-lock-settings): Use it instead of :match.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(ruby-ts-mode): Rename 'builtin-functions' to 'builtin-function'

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--font-lock-settings)
	(ruby-ts-mode): Rename 'builtin-functions' to 'builtin-function',
	for consistency with similar features.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Highlight builtin methods

	* lisp/progmodes/ruby-mode.el (ruby-builtin-methods-with-reqs)
	(ruby-builtin-methods-no-reqs): New constants, extracted.
	(ruby-font-lock-keywords): Replace values with references.

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--builtin-methods): New
	variable.  Construct regexp from aforementioned constants' values.

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--font-lock-settings):
	Use it.

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts-mode):
	Add new font-lock feature: builtin-functions.

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--predefined-constants)
	(ruby-ts--predefined-variables): Unrelated to the rest of the
	patch, add string-start and string-end anchors.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indent (bug#60873)

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--statement-offset): Handle the edge case.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: Add a test.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix various problems in treesit-explore-mode (bug#60800)

	* lisp/treesit.el:
	(treesit--explorer-kill-explorer-buffer): New function.
	(treesit-explore-mode):
	1. Move prompt for language earlier, and terminate early if language
	not available.
	2. Make sure desktop-save doesn't save the explorer buffer.
	3. Kill the explorer buffer when the source buffer is killed.

2023-04-15  Michael Heerdegen  <michael_heerdegen@web.de>

	Fix an oversight in advice.el

	This fixes an oversight from 77c3c464a16: "* lisp/emacs-lisp/advice.el
	(ad-advised-functions): Make it a plain list" that caused an issue as
	reported in Bug#60893.
	* lisp/emacs-lisp/advice.el (ad-read-advised-function): Adjust to
	handle the new type of elements of `ad-advised-functions'.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(treesit-simple-indent-presets): Have n-p-gp check for grandparent's presence

	* lisp/treesit.el (treesit-simple-indent-presets): Have n-p-gp
	check for grandparent's presence before checking its type.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-toggle-block: Fix in ruby-ts-mode

	* lisp/progmodes/ruby-mode.el (ruby-toggle-block): Make it work
	with ruby-ts-mode.  ruby-forward-sexp checks ruby-use-smie.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(ruby-ts--indent-rules): Indent inside empty parens properly

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--indent-rules):
	Consider the case when there are no arguments inside the call yet.

	* test/lisp/progmodes/ruby-ts-mode-tests.el
	(ruby-ts-indent-call-no-args): Add test.

2023-04-15  Kai Tetzlaff  <emacs@tetzco.de>

	Fix bug in 'sieve-manage--append-to-log'

	* lisp/net/sieve-manage.el (sieve-manage--append-to-log): Fix
	log buffer creation.  (Bug#54154)  Do not merge to master.

2023-04-15  Alan Mackenzie  <acm@muc.de>

	CC Mode: Prevent two classes of "type" prematurely entering c-found-types

	This fixes bug #60769.  The two classes of "type" are foo and bar in
	"foo d(bar () ...)", where the d could be a mistyped C-M-d.

	* lisp/progmodes/cc-engine.el (c-forward-decl-or-cast-1): New local variable
	got-arglist.  Refactor a sequence of enclosed `if' forms into a `cond' form.
	Set got-arglist when needed.  In CASE 2, set unsafe-maybe to inhibit foo
	being entered into c-found-types.  In CASE 19, likewise set unsafe-maybe, to
	inhibit bar entering c-found-types.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Use font-lock-constant-face for true/false/nil

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--font-lock-settings):
	Use font-lock-constant-face for true/false/nil.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(ruby-ts--indent-rules): Add a rule for continuation of a hash pair

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--indent-rules):
	Add a rule for continuation of a hash pair.

	* test/lisp/progmodes/ruby-mode-resources/ruby-ts.rb: Add examples.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(ruby-ts--parent-call-or-bol): Handle more cases with nested literals

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--parent-call-or-bol):
	Handle more cases with nested literals.

	* test/lisp/progmodes/ruby-mode-resources/ruby-ts.rb: Add examples.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(ruby-ts--statement-container-regexp): Remove "parenthesized_statements"

	* lisp/progmodes/ruby-ts-mode.el
	(ruby-ts--statement-container-regexp): Remove
	"parenthesized_statements", it's not really a statement container,
	not one we'd use for indentation alignment anyway.

	* test/lisp/progmodes/ruby-mode-resources/ruby-ts.rb: Add examples.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Handle indent in parenless calls much closer to ruby-mode

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--parent-call-or-bol):
	New function.
	(ruby-ts--indent-rules): Use it for cases which need special
	anchoring logic when inside a parenless method call.
	Remove the ad-hoc handling of pair-hash-pair etc indentation,
	which was there only for the parenless cases, apparently.
	Have "No paren, ruby-parenless-call-arguments-indent is nil" case
	align to the statement, if only because ruby-mode does that.

	* test/lisp/progmodes/ruby-ts-mode-tests.el:
	Run indent test for ruby-parenless-call-arguments-indent.rb.

2023-04-15  Juri Linkov  <juri@linkov.net>

	Fix split-window-below for the case when split-window-keep-point is nil.

	* lisp/window.el (split-window-below): Don't try to move point when
	split-window-keep-point is nil and window-to-split is not the selected window
	or nil (that defaults to the selected window) because code makes sense
	only for the selected window.
	(split-window-below, split-window-right): Improve docstrings (bug#60886)

2023-04-15  Juri Linkov  <juri@linkov.net>

	Rebind in read-regexp-map ‘M-c’ to ‘M-s c’ compatible with search-map

	Also it's compatible with 'M-s c' (isearch-toggle-case-fold)
	used during Isearch.  Also makes possible to use the global keybinding
	'M-c' (capitalize-dwim) in the minibuffer.

	* doc/lispref/minibuf.texi (Text from Minibuffer): Rename ‘M-c’ to ‘M-s c’.

	* lisp/replace.el (read-regexp-map): Rebind ‘M-c’ to ‘M-s c’ (bug#60741).
	(read-regexp-toggle-case-fold): Rename from read-regexp-toggle-case-folding
	to more standard name.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/vc/vc-dir.el: Make keys ‘% m’ and ‘* %’ compatible with Dired

	(vc-dir-mode-map): Replace ‘%’ for vc-dir-mark-by-regexp
	with ‘% m’ in regexp-map and ‘* %’ in mark-map (bug#60887).

	* doc/emacs/maintaining.texi (VC Directory Commands): Replace ‘%’
	with ‘% m’ and ‘* %’.  Mention vc-dir-mark-registered-files.

2023-04-15  Jim Porter  <jporterbugs@gmail.com>

	Use proper types for Eshell warnings

	* lisp/eshell/esh-var.el (eshell-get-variable):
	* lisp/eshell/em-basic.el (eshell/echo): Don't use ':warning'; that's a
	warning level, not a warning type.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve the documentation of 'auto-mode-alist' search

	* doc/emacs/modes.texi (Choosing Modes): Expand the description of
	"recursive extension stripping" using 'auto-mode-alist'.
	(Bug#60930)

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Revert "Revert "Add c-or-c++-ts-mode (bug#59613)""

	This reverts commit d46f7f4edcce14e6cbd8e2d7091dbabbe08defc1.

	Aaaactually, we need this, otherwise we can't use tree-sitter based C
	mode for header files.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Make it harder to misactivate tree-sitter font-lock fast mode

	This has been brought up in bug#60691 and bug#60223.  I proposed a fix
	by testing the size of the tree rather than measuring the query time.
	But after some thought, I fear that just looking at the size will give
	us false-negatives.  So I kept the time-based activation, just added a
	grace count to reduce false-positives.

	* lisp/treesit.el:
	(treesit--font-lock-fast-mode-grace-count): New variable.
	(treesit--font-lock-notifier): Only activate fast mode after 5
	offenses.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Obey the option ruby-method-call-indent

	* lisp/progmodes/ruby-ts-mode.el
	(ruby-ts--method-call-indent-p): New function.
	(ruby-ts--indent-rules): Use it.

	* test/lisp/progmodes/ruby-ts-mode-tests.el:
	Run indent test for ruby-method-call-indent.rb.

	* test/lisp/progmodes/ruby-mode-resources/ruby-ts.rb:
	Add explicit value for ruby-method-call-indent.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Obey the option ruby-after-operator-indent

	* lisp/progmodes/ruby-ts-mode.el
	(ruby-ts--after-op-indent-p): New function.
	(ruby-ts--indent-rules): Use it.

	* test/lisp/progmodes/ruby-ts-mode-tests.el:
	Run indent test for ruby-after-operator-indent.rb.

	* test/lisp/progmodes/ruby-mode-resources/ruby-ts.rb:
	Make sure indentation vars are at their default values.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Fix indent after operator or conditional

	Make it match ruby-mode's indentation behavior.

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--binary-indent-anchor):
	New function.
	(ruby-ts--indent-rules): Use it instead of a composite matcher.
	Add a rule for 'conditional'.
	(ruby-ts--assignment-ancestor, ruby-ts--is-in-condition)
	(ruby-ts--endless-method): Remove.

	* test/lisp/progmodes/ruby-mode-resources/ruby-ts.rb:
	Add examples.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Fix/change indentation of a continuation method call

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--indent-rules):
	Fix/change indentation of a continuation method call.

	* test/lisp/progmodes/ruby-mode-resources/ruby-ts.rb:
	New examples.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Fix indent inside parenthesized_expr and else/end after unless

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--indent-rules):
	Fix indentation for parenthesized_expression and else/end after
	'unless'.

	* test/lisp/progmodes/ruby-mode-resources/ruby-ts.rb:
	New examples.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Fix the rules for hanging arrays and hashes

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--indent-rules):
	Fix the rules for hanging arrays and hashes (to line up to
	parent-bol instead of the opening brace).

	* test/lisp/progmodes/ruby-mode-resources/ruby-ts.rb:
	New file with examples.

	* test/lisp/progmodes/ruby-ts-mode-tests.el: Use it here.

2023-04-15  Jim Porter  <jporterbugs@gmail.com>

	Add more detail about how to invoke Eshell commands

	* doc/misc/eshell.texi (Variables): Move footnote explaining "REPL"
	from here...
	(Top): ... to its first use here.
	(Commands): Move explanation about kernel functions to here.
	(Invocation): Describe command form and Lisp form.  Fix documentation
	about priority of commands in command form.
	(Arguments): Add a cross reference to the Invocation node.

2023-04-15  Alan Mackenzie  <acm@muc.de>

	CC Mode: On removal of "typedef", remove pertinent types from c-found-types

	For this purpose, record the type names declared by typedef in a text
	property, c-typedef, on the typedef.  On any change to that "typedef" or a
	type, remove the old identifier(s) from c-found-types.

	This should fix bug #59671.

	* lisp/progmodes/cc-defs.el (c-search-forward-non-nil-char-property): New
	macro.

	* lisp/progmodes/cc-engine.el (c-forward-decl-or-cast-1): Move the scope of
	identifier-start from the "inner" let form to the outer one.  Amend the
	return value such that the middle element of the second element is now the
	position of the "typedef", not merely non-nil.

	* lisp/progmodes/cc-fonts.el (c-font-lock-declarators): Disregard the LIMIT
	parameter when fontifying the declarators of a typedef construct.  Also in
	this case, set the c-typedef text property on the "typedef" to the list of
	declared types.  Amend this list when these declared types change.
	(c-font-lock-single-decl): Massage the `types' argument given to
	c-font-lock-declarators.
	(c-font-lock-cut-off-declarators): Amend to work when the starting point of
	the fontification is inside a brace block.

	* lisp/progmodes/cc-mode.el (c-before-change-de-typedef)
	(c-after-change-de-typedef): New functions.
	(c-update-new-id): Replace the erroneous c-end-of-current-token with a clause
	containing c-forward-token-2.
	(c-before-change): Call c-before-change-de-typedef.
	(c-after-change): Call c-after-change-de-typedef.

2023-04-15  F. Jason Park  <jp@neverwas.me>

	Don't preserve non-module minor modes in erc-open

	* lisp/erc/erc-common.el (define-erc-module): Add symbol property
	`erc-module' to minor modes defined as part of a module.
	* lisp/erc/erc.el (erc--merge-local-modes): Be more conservative when
	persisting local minor-mode state across ERC sessions.  User and
	third-party modes that were not defined via `define-erc-modules'
	should be left alone.
	(erc-open): Run major-mode hooks and enable minor modes after prompt
	has been set up.  This ensures that module-setup code can access a
	fully initialized `erc-input-marker'.
	* test/lisp/erc/erc-tests.el (erc--merge-local-modes): Add mocks for
	`erc-module' symbol property and a test case covering some foreign ERC
	mode.
	(define-erc-module--global, define-erc-module--local): Expect the
	`erc-module' symbol property to be defined for mode symbols and
	aliases.  (Bug#60784.)

2023-04-15  F. Jason Park  <jp@neverwas.me>

	Use correct buffer for local-module vars in erc-open

	* lisp/erc/erc.el (erc--target-priors): New internal variable to do
	for target buffers what `erc--server-reconnecting' does for server
	buffers.
	(erc-open): Source the state of a local module's mode variable from
	its actual buffer rather than its server buffer.  Additionally, make
	all local variables from a prior session available to
	module-activation functions and `erc-mode' hooks, even when
	`erc-reuse-buffers' is nil.  This bug arrived with the introduction of
	"local-modules" (bug#57955).

	* test/lisp/erc/erc-scenarios-base-local-modules.el
	(erc-scenarios-base-local-modules--toggle-helpers): Remove useless
	`with-current-buffer'.
	(erc-scenarios-base-local-modules--local-var, erc--phony-sblm--enable,
	erc--phony-sblm--disable, erc--phony-sblm--mode): Add fake local
	module and data var for test scenario.
	(erc-scenarios-base-local-modules--var-persistence) Add slightly hacky
	test case with promise to improve later when splitting the file.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix display of warnings on w32 console

	* lisp/emacs-lisp/warnings.el (warnings-suppress): Use alternative
	symbol for TTY frames on MS-Windows.

2023-04-15  Basil L. Contovounesios  <contovob@tcd.ie>

	Fix buffer-list-update-hook for indirect buffers

	Fmake_indirect_buffer can be told whether to run buffer hooks since
	bug#49160, but until now it ran buffer-list-update-hook irrespective
	of this.

	* src/buffer.c (Fmake_indirect_buffer): Don't run
	buffer-list-update-hook when called with a non-nil
	INHIBIT-BUFFER-HOOKS argument.
	(run_buffer_list_update_hook): Don't special-case NULL argument, as
	no such callers remain.

	* test/src/buffer-tests.el
	(buffer-tests-inhibit-buffer-hooks-indirect): Test whether indirect
	buffer hooks are run regardless of whether base buffer hooks are
	inhibited.  Check that all three buffer hooks, not just
	kill-buffer-query-functions, are inhibited.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix treesit-node-first-child-for-pos (bug#60127)

	The problem is due to a bug in ts_node_first_child_for_pos, but
	tree-sitter is moving pretty slowly right now so I reimplemented a
	correct version of it in treesit.c.

	* src/treesit.c (treesit_cursor_first_child_for_byte): New function.
	(Ftreesit_node_first_child_for_pos): Use the new function.

2023-04-15  Mattias Engdegård  <mattiase@acm.org>

	Fix hfy-exclude-file-rules (bug#60562)

	* lisp/htmlfontify.el (hfy-exclude-file-rules):
	Fix broken defcustom type; no longer fails test-custom-opts.
	Fix regexps not to use newline-sensitive patterns like `.` and `$`
	which do not make sense when matching file names.
	Better doc string.
	* lisp/htmlfontify.el (hfy-list-files): Simplify regexp argument.

2023-04-15  Alan Mackenzie  <acm@muc.de>

	CC Mode: Prevent ids in temporary "declarators" getting into c-found-types

	This should fix bug #60765.  In the scenario type an identifier in front of
	foo (bar, baz), as when started a new statement.  This temporarily makes the
	function call a declarator, and bar and baz types.  Don't enter bar and baz
	into c-found-types.

	* lisp/progmodes/cc-engine.el (c-forward-decl-or-cast-1) (CASE 6): When a
	'maybe type triggers this case, set `unsafe-maybe' to non-nil.

2023-04-15  João Távora  <joaotavora@gmail.com>

	Fix M-x eglot prompt when connection already exists (bug#60557)

	Before this change, if a current connection existed at the time of M-x
	eglot, user would be first asked to enter into M-x eglot's interactive
	spec details about new command line arguments, and only afterwards be
	prompted about what to do with the current connection (which could be
	to reconnect to it using the same arguments, or tear it down and make
	a new one).

	This is very confusing, as users may not be fully aware of the
	distinction between "reconnect" vs "disconnect-and-connect".  They
	might not know if any new command line arguments provided are taking
	effect or not.

	This change simplifies this and removes the option to "reconnect
	instead" from M-x eglot (users can do that at any time via M-x
	eglot-reconnect).  It also ensures that users are informed about a
	current connection before asking to enter new command line arguments
	and not the other way round.

	* lisp/progmodes/eglot.el (eglot): Rework.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix tree-sitter indent preset function (bug#60270)

	* lisp/treesit.el (treesit-simple-indent-presets): Fix
	prev-adaptive-prefix so it doesn't return nil if the previous line has
	no prefix.
	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New test.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Support the option ruby-block-indent

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--block-indent-anchor):
	New function.
	(ruby-ts--indent-rules): Use it.

	* test/lisp/progmodes/ruby-ts-mode-tests.el:
	Run indent test for ruby-block-indent.rb.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Improve indentation for jsx

	* lisp/progmodes/js.el (js--treesit-indent-rules): Use more parent
	anchors and fix typo with wrong indent offset variable.
	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--indent-rules): Use more parent anchors.

2023-04-15  Sean Whitton  <spwhitton@spwhitton.name>

	* lisp/subr.el (while-let): Fix docs if-let->if-let* (bug#60758).

2023-04-15  Sean Whitton  <spwhitton@spwhitton.name>

	Revert "* lisp/subr.el (while-let): Use if-let, not if-let* (bug#60758)."

	This reverts commit 083badc9c122a802080552e7771e78ee47c01e3c.

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	Bump use-package version for Emacs 29.1

	* lisp/use-package/use-package.el: Bump version to 2.4.5.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve error message from sqlite-mode.el

	* lisp/sqlite-mode.el (sqlite-mode-open-file): Add error
	checking.  (Bug#60490)

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode block comment indentation (bug#60270)

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--comment-2nd-line-anchor): Handle another edge case.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode label indent

	Fix indentation of the statement right under a label.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Fix.
	(c-ts-mode--top-level-label-matcher): Fix.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix statement indent for c-ts-mode (bug#59686) (bug#60280)

	Instead of trying to figure out the correct anchor, now we just count
	the layers of {} blocks between the node and the root node.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--indent-styles): Use new offset functions
	c-ts-mode--close-bracket-offset and c-ts-mode--statement-offset.
	(c-ts-mode--bracket-children-anchor): Remove function.
	(c-ts-mode--top-level-label-matcher): New variable.
	(c-ts-mode--statement-offset)
	(c-ts-mode--close-bracket-offset): New offset functions.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Allow offset in tree-sitter indent rules to be functions

	This is needed for fixing C indentation.  See next comment.

	* doc/lispref/modes.texi (Parser-based Indentation): Update manual.
	* lisp/treesit.el (treesit-simple-indent): Try evaluating OFFSET as a
	function if it's not integer nor variable.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Support filling line comments in c-ts-mode

	Now we handle line comments separately because for line comments, each
	line is an individual node, unlike block comments, where the whole
	block comment is a single node.  fill-comment-paragraph turns out to
	do the job perfectly fine.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--fill-paragraph): Extract out most parts into
	c-ts-mode--fill-block-comment.
	(c-ts-mode--fill-block-comment): New extracted function.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix expansion of wildcards in ls-lisp.el

	* lisp/ls-lisp.el (ls-lisp--dired): Fix error message text.
	Handle the case of a wildcard specifying directories.  (Bug#60819)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix messages displayed when diary is shown

	* lisp/calendar/diary-lib.el (diary-list-entries): Display the
	"...done" message only if there's no important message in the
	echo-area.  (Bug#60795)

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Add constructor_declaration as java-ts-mode defun

	* lisp/progmodes/java-ts-mode.el (java-ts-mode): Extend
	treesit-defun-type-regexp.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Further improvement for non-string values in pcomplete

	* lisp/pcomplete.el (pcomplete-arg): Use the string representation
	of the argument value instead of the text representation of the
	argument.  Return the value, even when it is not a string, when
	index is 'last'.  Fixes bug#60464.

2023-04-15  Juri Linkov  <juri@linkov.net>

	Fix the case in first-completion revealed by minibuffer-tests

	* lisp/simple.el (first-completion): Add the text-property 'first-completion'
	when the first completion is at the beginning of the buffer.

	* test/lisp/minibuffer-tests.el (completions-header-format-test):
	Revert the recent change.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Fix indent and font-lock for annotation_type

	* lisp/progmodes/java-ts-mode.el (java-ts-mode--indent-rules): Indent
	inside body.
	(java-ts-mode--font-lock-settings): Add rule for name in
	annotation_type_element_declaration.

2023-04-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	apropos.el: Fix bug#60628

	* lisp/apropos.el (apropos--map-preloaded-atoms): New function.
	(apropos-documentation): Use it.
	(apropos-documentation-check-elc-file): Don't presume #@ is preceded by
	a newline (since that's not the case any more since commit
	900b09c0235d54d5), but be more careful not to burp on false positives.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Fix indentation of some declarations and statements

	* lisp/progmodes/java-ts-mode.el (java-ts-mode--indent-rules): Add new
	rules so that we don't anchor at col 0.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Fix indentation of object_expressions in csharp-ts-mode

	* lisp/progmodes/csharp-mode.el (csharp-ts-mode--indent-rules): Make
	sure the opening brace is indented at parent-bol, and everything else
	is indented.

2023-04-15  Xi Lu  <lx@shellcodes.org>

	Replace 'hfy-find-cmd' with 'directory-files-recursively'.

	This removes a potential vulnerability to maliciously
	named files.  (Bug#60562)
	* lisp/htmlfontify.el (hfy-exclude-file-rules): New defcustom.
	(hfy-list-files): Reimplement using 'directory-files-recursively'.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Disable and document 'doc-view-mupdf-use-svg' (bug#58041)

	* lisp/doc-view.el (doc-view-mupdf-use-svg): Disable by default.
	* etc/NEWS: Document.  Patch by Visuwesh <visuweshm@gmail.com>.
	Do not merge to master.

2023-04-15  Eshel Yaron  <me@eshelyaron.com>  (tiny change)

	Eglot: don't use "nil" as minibuffer initial input

	Doing M-x eglot in a buffer for which buffer-file-name is nil, prompts
	the user for a major mode to manage by invoking completing-read.  The
	way completing-read was called would end up with the string "nil" as
	the initial minibuffer input, which is not very useful nor is it a
	valid input.
	* lisp/progmodes/eglot.el (eglot--guess-contact): Tweak prompt for
	major mode.  (Bug#60379)

2023-04-15  Paul Eggert  <eggert@cs.ucla.edu>

	Fix dependency bug when building lwlib

	* lwlib/Makefile.in (DEPFLAGS): Use OBJS to calculate dependency
	file names, not ALLOBJS.  This fixes a typo introduced
	in 2015-05-15 "Replace AC_SUBST_FILE in configure with include in
	Makefiles" that caused lwlib/*.o to not be rebuilt sometimes
	when that was needed.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix use of build_pure_c_string in treesit.c

	This is brought up in bug#60691.  build_pure_c_string should only be
	used in places such as syms_of_treesit, which are called just once,
	during dumping.

	* src/treesit.c (Vtreesit_str_libtree_sitter):
	(Vtreesit_str_tree_sitter):
	(Vtreesit_str_dot):
	(Vtreesit_str_question_mark):
	(Vtreesit_str_star):
	(Vtreesit_str_plus):
	(Vtreesit_str_pound_equal):
	(Vtreesit_str_pound_match):
	(Vtreesit_str_pound_pred):
	(Vtreesit_str_open_bracket):
	(Vtreesit_str_close_bracket):
	(Vtreesit_str_open_paren):
	(Vtreesit_str_close_paren):
	(Vtreesit_str_space):
	(Vtreesit_str_equal):
	(Vtreesit_str_match):
	(Vtreesit_str_pred): New variables.

	(treesit_load_language):
	(Ftreesit_pattern_expand):
	(Ftreesit_query_expand):
	(treesit_eval_predicates): Use new varaibles.

	(treesit_check_buffer_size):
	(treesit_compose_query_signal_data):
	(treesit_check_range_argument):
	(Ftreesit_parser_set_included_ranges):
	(treesit_predicate_capture_name_to_node):
	(treesit_predicate_equal):
	(treesit_predicate_match):
	(treesit_predicate_pred): Use build_string for signal message.

	(syms_of_treesit): Initialize new variables.

2023-04-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* lisp/subr.el (combine-change-calls-1): Fix bug#60467

	Don't stop at timestamps.  Strip them for now, to be on the safe side.
	Don't merge into `master` where we'll use a better fix.

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Adapt tramp-tests.el  (do not merge with master)

	* test/lisp/net/tramp-tests.el (tramp--test-container-p):
	Rename from `tramp--test-docker-p'.  Handle also "podman" method.
	Adapt callees.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix minibuffer-completion tests

	* test/lisp/minibuffer-tests.el (completions-header-format-test):
	Fix the test which first fired, and then drew the target...

2023-04-15  Daniel Martín  <mardani29@yahoo.es>

	Add c-ts-mode tests

	* test/lisp/progmodes/c-ts-mode-resources/indent.erts: New .erts file
	to test indentation of typical C constructs and prevent regression of
	bug fixes.
	* test/lisp/progmodes/c-ts-mode-tests.el: New file with c-ts-mode
	tests.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode--fill-paragraph

	Example:

	       doc: /* Return non-nil if NODE1 and NODE2 are the same node.
	If any one of NODE1 and NODE2 is nil, return nil.
	This function uses the same equivalence metric as `equal'.  */

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--fill-paragraph): Fix the
	case where there are words before the /*, like the example above.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix minor issues with 'pp' and related commands

	* etc/NEWS:
	* lisp/emacs-lisp/pp.el (pp-use-max-width, pp-emacs-lisp-code):
	Mention in doc string that formatting via 'pp-emacs-lisp-code'
	could be slow.
	(pp-eval-expression, pp-macroexpand-expression): Honor
	'pp-use-max-width'.  (Bug#58687)

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Equal now recognizes tree-sitter nodes (bug#60659)

	Now equal uses ts_node_eq to check equality between nodes.

	* doc/lispref/parsing.texi:
	(Accessing Node Information): Update manual.
	* src/fns.c (internal_equal): Handle tree-sitter nodes.
	* src/treesit.c (treesit_node_eq): New function.
	(Ftreesit_node_eq): Factor out.  Update docstring.
	* src/treesit.h (treesit_node_eq): Declare new function.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode comment indentation (bug#60270)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Move the
	star rule up.

2023-04-15  Sean Whitton  <spwhitton@spwhitton.name>

	* lisp/subr.el (while-let): Use if-let, not if-let* (bug#60758).

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	* lisp/simple.el (next-completion): Handle first completion specially.

	When completions-header-format is nil and completion-show-help is nil,
	the first completion is at the beginning the buffer, so 'M-<down>'
	missed it and moved to the second completion.  Handle this case by
	setting/checking the special text-property 'first-completion' that
	is nil at the first call (bug#60411).

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix encoding with 'utf-8-auto'

	* src/coding.c (encode_coding_utf_8): Fix encoding with
	'utf-8-auto': it should produce BOM, per the documentation of
	the :bom attribute.  (Bug#60750)

	* lisp/international/mule.el (define-coding-system): Doc fix.

	* test/src/coding-tests.el (coding-tests): Use
	'with-coding-priority' instead of 'prefer-coding-system', as the
	latter has global persistent effect and affects further tests.

2023-04-15  Po Lu  <luangruo@yahoo.com>

	Report cursor correctly on PGTK when there is a margin

	* src/pgtkterm.c (pgtk_draw_window_cursor): Adjust frame_x by
	the margin width as well.

2023-04-15  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6.1

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Add support for annotation_type_declaration

	* lisp/progmodes/java-ts-mode.el (java-ts-mode--keywords): Add new
	keyword.
	(java-ts-mode--font-lock-settings): Add font-locking to the type
	feature.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* etc/NEWS: Mention incompatible changes in 'outline-minor-mode-cycle-map'.

	* lisp/outline.el (outline-minor-mode-cycle--bind):
	Add docstring (bug#60426).
	(outline-minor-mode-cycle--bind): Default 'map' to
	'outline-minor-mode-cycle-map'.
	(outline-minor-mode-cycle-map): Improve docstring.
	(outline-minor-mode): Move margin-cycling keys to
	'outline-minor-mode-cycle-map'.

2023-04-15  Philip Kaludercic  <philipk@posteo.net>

	Ensure VC package names are not empty

	* lisp/emacs-lisp/package-vc.el (package-vc--unpack): Raise an error
	if the package name is empty.
	(package-vc-install): Avoid generating an empty file name, if a URL
	ends with a slash, and raise an error if the package name is empty.

2023-04-15  Philip Kaludercic  <philipk@posteo.net>

	Handle missing package description when unpacking vc packages

	* lisp/emacs-lisp/package-vc.el (package-vc--unpack): Create a dummy
	descriptor if PKG-DESC is nil.

2023-04-15  Alan Mackenzie  <acm@muc.de>

	CC Mode: partially revert commit from 2022-10-04

	This reversion is of an ill-advised optimization, which resulted in non-type
	identifiers getting fontified as types.

	* lisp/progmodes/cc-fonts.el (c-fontify-new-found-type): Rather than writing
	the expected face directly to the text, instead remove the `fontified'
	property.  This allows the full font-lock mechanism to fontify the buffer
	correctly.

2023-04-15  Manuel Uberti  <manuel.uberti@inventati.org>

	Fix reftex-citation docstring (bug#60710)

	* lisp/textmodes/reftex-cite.el (reftex-citation): Fix spelling.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Improve 'describe-char-fold-equivalences' docstring

	* lisp/char-fold.el (describe-char-fold-equivalences): Explain what
	the output looks like.

2023-04-15  F. Jason Park  <jp@neverwas.me>

	Remove obsolete server buffers on MOTD in erc-track

	* lisp/erc/erc-networks.el
	(erc-networks--copy-server-buffer-functions): New internal hook
	through which modules can perform housekeeping when server buffers
	belonging to the same network context are merged.
	(erc-networks--copy-over-server-buffer-contents): Run new internal
	hook `erc-networks--copy-server-buffer-functions'.
	* lisp/erc/erc-track.el (erc-track-enable, erc-track-disable): Manage
	membership in `erc-networks--copy-server-buffer-functions' hook.
	(erc-track--replace-killed-buffer): New function to replace server
	buffer being killed in `erc-modified-channels-alist'.
	* test/lisp/erc/erc-scenarios-base-association.el
	(erc-scenarios-networks-merge-server-track): New test.
	* test/lisp/erc/resources/networks/merge-server/track.eld: New test
	data.  (Bug#60560.)

2023-04-15  Manuel Uberti  <manuel.uberti@inventati.org>

	Fix completion-auto-help docstring (bug#60709)

	* lisp/minibuffer.el (completion-auto-help): Remove extra period.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode comment indent

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--comment-2nd-line-matcher): Also make sure PARENT is a
	comment node.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Highlight identifier in import statements in js-ts-mode

	Follow-up on bug#60689.  This commit just copied the change in
	e385c099b8c to js-ts-mode.

	* lisp/progmodes/js.el:
	(js--treesit-font-lock-settings): Add import query.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Don't print named tree-sitter nodes with parenthesizes (bug#60696)

	* src/print.c (print_vectorlike): Use empty string as delimiters if
	the node is named.

2023-04-15  Jostein Kjønigsen  <jostein@kjonigsen.net>

	Improve fontification for import-statements in typescript-ts-mode

	(bug#60689)

	* lisp/progmodes/typescript-ts-mode.el:
	(typescript-ts-mode--font-lock-settings): Add rules to highlight the
	actual imports in import-statements.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode indentation for 2nd line in block comment (bug#60270)

	If the first line is "/*" or "/*   ", indent like this:

	/*
	   aaa

	If the first line is "/*   some text", indent like this:

	/*   some text
	     aaa

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles):
	(c-ts-mode--looking-at-star): Minor refactor.
	(c-ts-mode--comment-2nd-line-matcher)
	(c-ts-mode--comment-2nd-line-anchor): New functions.
	* lisp/treesit.el (treesit-simple-indent-presets):
	prev-adaptive-prefix doesn't handle the comment-start-skip case (i.e,
	2nd line) anymore.  (Handled by the new matcher.)

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/vc/diff-mode.el (diff-font-lock-keywords): Check for limit.

	This check is necessary since 'diff-beginning-of-hunk' can move
	not only backwards, but also forwards (bug#60660).

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Minor improvement for tree-sitter explorer

	If you open an empty python buffer and type

	1 + 2
	a
	b

	Currently the explorer only displays the top-level node at point, ie,
	only 1 + 2, only a, or only b. That's kind of awkward, so if the
	buffer is small, show the entire parse tree.

	* lisp/treesit.el (treesit--explorer-refresh): See above.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Make sure NODE is not the root node in tree-sitter indent (bug#60602)

	There are two possible ways to solve the problem raised in the bug
	report: either make sure NODE is never the root (so that parent is
	never nil), or allow parent to be nil.

	If we go with the latter, a lot of matcher and anchor functions need
	change (they need to guard against a null parent).  I tried it, and
	needing to check for null parent is pretty annoying.  In comparison,
	if NODE is never the root, it is very convenient for the user, and it
	doesn't complicate the rule that much (and it's rather intuitive,
	people usually don't think of the case where NODE is the root node).
	So that's what I choose.

	* doc/lispref/modes.texi (Parser-based Indentation): Update manual.
	* lisp/treesit.el (treesit-indent-function): Update docstring.
	(treesit--indent-1): Make sure NODE is not the root.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix label indent of GNU and Linux style in c-ts-mode (bug#60543)

	The previous fix isn't correct.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--indent-styles): New indent rule.  Fix the rule for Linux
	style.
	(c-ts-mode--top-level-label-matcher): New function.

2023-04-15  Evgeni Kolev  <evgenysw@gmail.com>

	Improve go-ts-mode Imenu, navigation and electric pair (bug#60407)

	The Imenu items are extended to support "Method", "Struct",
	"Interface", "Alias" and "Type".

	go-ts-mode is updated to use the Imenu facility added in commit
	b39dc7ab27a696a8607ab859aeff3c71509231f5.

	Variable electric-indent-chars is set in order to improve integration
	with Electric Pair mode.

	* lisp/progmodes/go-ts-mode.el (go-ts-mode--imenu-1) (go-ts-mode--imenu):
	Remove functions.
	(go-ts-mode--defun-name, go-ts-mode--interface-node-p)
	(go-ts-mode--struct-node-p, go-ts-mode--other-type-node-p)
	(go-ts-mode--alias-node-p): New functions.
	(go-ts-mode): Improve Imenu settings, navigation, add Electric Pair
	mode settings.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Revert "Add c-or-c++-ts-mode (bug#59613)"

	This reverts commit 1df2826639c912396fac0af108301533dac71406.

	I forgot about the feature freeze, sorry :-)

2023-04-15  Benson Chu  <bensonchu457@gmail.com>  (tiny change)

	Add back renamed function 'font-lock-fontify-syntactically-region'

	A more accurate replacement for font-lock-fontify-syntactically-region
	would be a function that funcalls the
	font-lock-fontify-syntactically-function variable. That way, callers
	of the function can inherit new behavior, if the value of that variable
	changes.

	* lisp/font-lock.el (font-lock-fontify-syntactically-region):
	Add function back, remove its obsolete alias.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve options and docs of M-x command completion

	* lisp/simple.el (read-extended-command-predicate): Expand the
	doc string.  Add 2 more selectable values.
	(command-completion-using-modes-and-keymaps-p): New function.
	(execute-extended-command): Mention
	'read-extended-command-predicate' in the doc string.  (Bug#60645)

2023-04-15  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6-90-ga6523f

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix string fontification on python-ts-mode (bug#60599)

	* lisp/progmodes/python.el:
	(python--treesit-fontify-string): Generalize and skip anything
	before the first quote character.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix string-interpolation feature of python-ts-mode (bug#60599)

	* lisp/progmodes/python.el:
	(python--treesit-fontify-string-interpolation): New function.
	(python--treesit-settings): Use the new function for
	string-interpolation.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Add indentation rule for concatenated_string (bug#60572)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Indent to
	parent-bol.

2023-04-15  Jostein Kjønigsen  <jostein@kjonigsen.net>

	Fix highlighting of variable-declarations in typescript-ts-mode

	(bug#60546)

	- Highlight variable declarations in catch-clauses.
	- Remove highlighting of variables where not declarations (improve
	  consistency with other *-ts-modes).

	* lisp/progmodes/typescript-ts-mode.el:
	(typescript-ts-mode--font-lock-settings): See above.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix label indentation for Linux style in c-ts-mode (bug#60543)

	Reference:
	1. https://www.gnu.org/software/indent/manual/indent/Common-styles.html
	2. https://www.gnu.org/software/indent/manual/indent/Option-Summary.html

	The GNU indent manual says Linux style should use -il1 flag, which
	means "indent labels to column 1".

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Indent label
	to column 1 in Linux style.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Remove duplicate entries in c-ts-mode's Imenu

	Right now the Class subindex includes top-level functions, which is
	wrong. This change ensures the Class subindex only contain classes and
	functions nested in those classes.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--defun-for-class-in-imenu-p): New function.
	* lisp/progmodes/c-ts-mode.el (c-ts-base-mode): Use the new function.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix use of treesit-ready-p in c/c++-ts-mode

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode)
	(c++-ts-mode): Put setup code in a when form.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add documentation for c/c++-ts-mode (bug#60443)

	Explain that tree-sitter c modes and cc-mode c modes don't share
	config variables.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode)
	(c++-ts-mode): Update docstring.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(ruby-ts--font-lock-settings): Improve highlighting in patterns

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--font-lock-settings):
	Improve highlighting in patterns: highlight values not keys as
	variable in the usual case; highlight keys when no value;
	highlight the "as pattern" variable.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Optionally include the namespace in c-ts-mode--declarator-identifier

	This is an additional fix for bug#60397.

	* lisp/progmodes/c-ts-mode.el:
	(c-ts-mode--declarator-identifier): New parameter QUALIFIED.
	(c-ts-mode--defun-name): Use qualified identifier.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Support namespaces in c++-ts-mode (bug#60397)

	Not a complete fix.  See the next commit.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Add rules.
	(c-ts-mode--defun-name): Add namespace_definition.
	(c-ts-base-mode): Add namespace_definition to
	treesit-defun-type-regexp.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode--looking-at-star

	Not the topic of bug#60270 but reported in one of the replies.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--looking-at-star): Check not
	the character after point but character after BOL. Otherwise
	indentation is wrong when point is not at BOL.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add c-or-c++-ts-mode (bug#59613)

	* lisp/progmodes/c-ts-mode.el
	(c-ts-mode--c-or-c++-regexp): New variable.
	(c-or-c++-ts-mode): New mode.
	* etc/NEWS: Mention c-or-c++-ts-mode.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Document the 'definition-name' property.

	* doc/lispref/symbols.texi (Standard Properties): Document
	'definition-name'.
	* doc/lispref/functions.texi (Defining Functions): Describe how to
	use 'definition-name' when generating function definitions at run
	time.  (Bug#60568)

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(treesit-simple-indent-presets): Do that for 'or' as well.

	* lisp/treesit.el
	(treesit-simple-indent-presets): Do that for 'or' as well.

2023-04-15  kobarity  <kobarity@gmail.com>

	Fix 'python-shell-buffer-substring' when START is in middle of 1st line

	* lisp/progmodes/python.el (python-shell-buffer-substring): Instead
	of checking whether START is point-min, check whether START is in
	the first line.  (Bug#60466)
	* test/lisp/progmodes/python-tests.el
	(python-shell-buffer-substring-18): New test.

2023-04-15  Manuel Giraud  <manuel@ledu-giraud.fr>

	Rearrange the "Saving Emacs Sessions" section of the user manual

	* doc/emacs/misc.texi (Saving Emacs Sessions): Organize this
	node more logically with main behavior and important features
	near the top.   (Bug#60600)

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(treesit-simple-indent-presets): Ensure 'and' works for anchors too

	* lisp/treesit.el (treesit-simple-indent-presets):
	Rewrite to return the last successful evaluation, not just t.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(treesit--indent-rules-optimize): Optimize 'and' and 'or' matcher forms

	* lisp/treesit.el (treesit--indent-rules-optimize):
	Optimize 'and' and 'or' matcher forms.  When 'and' has a 'query'
	matcher inside (as is the case in ruby-ts--indent-rules, many
	times over), this yields a significant performance boost.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(treesit-simple-indent-presets): Short-circuit 'and' and 'or'

	* lisp/treesit.el (treesit-simple-indent-presets):
	Short-circuit the 'and' and 'or' matchers.  To avoid calling all
	fns after one returned nil or truthy value, respectively.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(font-lock-regexp-face): New face

	* lisp/font-lock.el (font-lock-regexp-face): New face.

	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--font-lock-settings):
	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--font-lock-settings):
	* lisp/progmodes/js.el (js--treesit-font-lock-settings):
	Use it for regexps.

	* etc/NEWS: Mention the addition.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Unify the string interpolation delimiters face across ts modes

	* lisp/progmodes/js.el (js--treesit-font-lock-settings):
	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--font-lock-settings):
	* lisp/progmodes/typescript-ts-mode.el
	(typescript-ts-mode--font-lock-settings):
	Use font-lock-misc-punctuation-face for string interpolation
	delimiters.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Highlight more kinds of parameters

	* lisp/progmodes/ruby-ts-mode.el
	(ruby-ts--font-lock-settings): Highlight destructured parameters,
	lambda parameters, identifiers in pattern matching clauses
	(array/hash) and exception variables.
	Move the 'symbol' matchers lower to make 'hash_key_symbol' lower
	priority than hash keys in match patterns.

2023-04-15  Robert Pluim  <rpluim@gmail.com>

	Fix `pr-interface'

	`pr-interface' specifies `inline' for its menu items, which is not
	necessary, but it causes `widget-choice-value-create' to bug
	out.  (Bug#60501)

	* lisp/wid-edit.el (widget-choice-value-create): Allow the value to be
	a non-list.
	* test/lisp/wid-edit-tests.el (widget-test-handle-spurious-inline):
	Add test to ensure that unnecessary :inline is allowed.

2023-04-15  Jostein Kjønigsen  <jostein@kjonigsen.net>

	Further generic-related improvements in csharp-ts-mode (bug#60376)

	This is an additional patch for bug#60376.

	* lisp/progmodes/csharp-mode.el (csharp-ts-mode--font-lock-settings):
	New rules.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Highlight method and block parameters

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--font-lock-settings):
	Add rules for method and block parameters.
	(ruby-ts-mode): Add corresponding feature.

2023-04-15  Perry Smith  <pedz@easesoftware.com>

	ruby-ts-mode: Highlight variable assignments

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--font-lock-settings):
	Bring back the 'assignment' feature.
	(ruby-ts-mode): Replace the unused 'variable' with 'assignment'.  Use
	the level 3 for consistency with other ts modes.
	Update the Commentary as well.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Move 'self' and 'super' from constants to keywords

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--font-lock-settings):
	Move 'self' and 'super' from constants to keywords.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(ruby-ts-mode): Split font-lock feature 'builtin' into two

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts-mode):
	Split the 'builtin' feature in two: 'builtin-constant' and
	'builtin-variable'.
	(ruby-ts-highlight-predefined-constants):
	Drop the user option, the highlighting granularity can be chosen
	using treesit-font-lock-recompute-features.
	(ruby-ts--font-lock-settings): Update accordingly.
	(ruby-ts--predefined-constants, ruby-ts--predefined-variables):
	Fix docstrings.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Avoid assertion violation due to fill-column indicator face

	* src/xdisp.c (extend_face_to_end_of_line): Use the original
	iterator metrics for the stretch glyph, the one unaffected by the
	'fill-column-indicator' face.  (Bug#60580)

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/cedet/semantic/symref/grep.el: Support ts-modes (bug#60525)

	(semantic-symref-filepattern-alist): Duplicate entries
	c-mode -> c-ts-mode, c++-mode -> c++-ts-mode, ruby-mode -> ruby-ts-mode,
	python-mode -> python-ts-mode.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Make 'toml-ts-mode' optional

	* etc/NEWS: Reflect the fact that 'toml-ts-mode' is optional.

	* lisp/textmodes/toml-ts-mode.el (auto-mode-alist): Don't autoload
	the addition of 'toml-ts-mode'.  (Bug#60559)

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	Fix bug in Tramp multi-hop

	* lisp/net/tramp.el (tramp-compute-multi-hops): Make check for
	host name more robust.  (Bug#60499)

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	* lisp/files.el (find-sibling-rules): Fix docstring.

2023-04-15  Juri Linkov  <juri@linkov.net>

	Tree-sitter doc fixes (bug#60524)

	* doc/lispref/modes.texi (Parser-based Font Lock):
	Replace :lang with :language.

	* doc/lispref/parsing.texi (Language Grammar): Replace
	treesit-load-suffixes with dynamic-library-suffixes.
	(Retrieving Nodes): Fix function names.
	(Tree-sitter Major Modes): Fix treesit-ready-p args.
	Fix pxref to Parser-based Indentation.
	(Tree-sitter C API): Fix function names.

	* lisp/treesit.el (treesit--simple-indent-eval): Remove cond BODY
	duplicated from CONDITION.
	(treesit)<define-short-documentation-group>: Fix function names.

2023-04-15  Daniel Martín  <mardani29@yahoo.es>

	Fontify C++ function definitions in c-ts-mode (bug#60529)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--declarator-identifier):
	Teach the code how to extract the declarator of a node of type
	"qualified_identifier".
	(c-ts-mode--fontify-declarator): Consider the case where the
	identifier in a function declarator is buried inside
	"qualifier_identifier" nodes.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(ruby-ts-add-log-current-function): Fix when between two methods

	* lisp/progmodes/ruby-ts-mode.el
	(ruby-ts-add-log-current-function): Fix the case when point is
	between two methods.  'treesit-node-at' returs the 'def' node of
	the method after point in such case, so it behaved like point was
	inside the method below.

	* test/lisp/progmodes/ruby-ts-mode-tests.el
	(ruby-ts-add-log-current-method-outside-of-method):
	Update the test case.

	* test/lisp/progmodes/ruby-mode-tests.el
	(ruby-add-log-current-method-outside-of-method):
	Mirror that change.

2023-04-15  Sean Whitton  <spwhitton@spwhitton.name>

	* lisp/vc/vc-git.el (vc-git-checkin): Pass vc-git-diff-switches.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Extract common code into ruby-base-mode to derive from

	* lisp/progmodes/ruby-mode.el (ruby-base-mode):
	New major base mode, to set up common vars and hooks.
	(ruby-mode-variables): Delete.  Move most code to ruby-base-mode.
	And some -- to ruby-mode body.
	(ruby-mode): Derive from ruby-base-mode.  Also move some setup
	to there.

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts-mode):
	Derive from ruby-base-mode.  Remove duplicating settings.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Indentation fixes

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--align-keywords):
	Fix for 'def' (which was misread as 'method' in the check).
	(ruby-ts--indent-rules): Indent the curly block closer the same
	way as the 'do ... end' closer.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts--font-lock-settings: Use more standard faces

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--font-lock-settings):
	Use more standard faces for regexp literals and string
	interpolation delimiters (following js-ts-mode).

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Standardize the string literal highlights

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--font-lock-settings):
	Use font-lock-string-face for %w() and `...`.
	Use font-lock-constant-face (just like we do for symbol literals)
	for symbol array literals, %i().
	Combine the matchers for string content and heredocs.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Improve fontification in java-ts-mode (bug#60492)

	* lisp/progmodes/java-ts-mode.el (java-ts-mode--font-lock-settings):
	Add expression_statement with only identifier support.

2023-04-15  Jostein Kjønigsen  <jostein@kjonigsen.net>

	Fontification improvements in typescript-ts-mode (bug#60500)

	- highlight method-definitins in interfaces.
	- only highlight variable-declarations, not variables
	  everywhere (consistency with other modes).
	- move highlighting of method invocations to level 4

	* lisp/progmodes/typescript-ts-mode.el:
	(typescript-ts-mode--font-lock-settings): Update rules.
	(typescript-ts-mode, tsx-ts-mode): Update feature list.

2023-04-15  Jostein Kjønigsen  <jostein@kjonigsen.net>

	Improve fontification consistency in js-ts-mode (bug#60503)

	* lisp/progmodes/js.el (js--treesit-font-lock-settings): Highlight
	declared parameters in functions, methods and arrow-expressions as
	variables.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(typescript/tsx-ts-mode): Split font-lock feature list into 4 values

	* lisp/progmodes/typescript-ts-mode.el (typescript-ts-mode)
	(tsx-ts-mode): Split font-lock feature list into 4 values.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	js-ts-mode: Move 'string-interpolation' to font-lock level 3

	* lisp/progmodes/js.el (js-ts-mode):
	Move 'string-interpolation' to font-lock level 3.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Fix shrinking of the tab-bar

	* src/haikufns.c (haiku_change_tab_bar_height):
	* src/pgtkfns.c (pgtk_change_tab_bar_height):
	* src/nsfns.m (ns_change_tab_bar_height):
	* src/w32fns.c (w32_change_tab_bar_height):
	* src/xfns.c (x_change_tab_bar_height): Don't let the number of
	tab-bar lines degenerate to zero due to integer division.
	(Bug#60210)

2023-04-15  F. Jason Park  <jp@neverwas.me>

	Fix default-port regression in erc-select-read-args

	* lisp/erc/erc.el (erc--warn-unencrypted): New function, likely
	temporary, to warn new users connecting interactively to the default
	server, "irc.libara.chat", via the default non-TLS port, 6667.
	(erc-select-read-args): Remove stray code from incomplete feature
	introduced by bug#56514.  Ensure connecting always works with default
	port, which is non-TLS.  Respect `erc-prompt-for-password' when user
	pastes URL containing password component into "server" prompt.  Maybe
	add `erc--warn-unencrypted' as one-off hook for impending connection.
	* test/lisp/erc/erc-tests.el (erc-select-read-args): Always expect
	password prompt and sometimes a non-TLS port when `erc' called
	interactively.  (Bug#60428.)

2023-04-15  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6-81-g563a43

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Remove some currently unused functions

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--grand-parent-is)
	(ruby-ts--ancestor-start, ruby-ts--ancestor-is):
	Remove some currently unused functions.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	ruby-ts-mode: Highlight singleton method definitions and setters

	* lisp/progmodes/ruby-ts-mode.el (ruby-ts--font-lock-settings):
	Highlight singleton method definitions and setters.

2023-04-15  Perry Smith  <pedz@easesoftware.com>
	    Dmitry Gutov  <dgutov@yandex.ru>

	Add ruby-ts-mode

	* etc/NEWS: Mention the new mode.

	* lisp/progmodes/ruby-ts-mode.el: New file.

	* test/lisp/progmodes/ruby-ts-mode-tests.el: New file.

	* lisp/progmodes/eglot.el (eglot-server-programs):
	Add ruby-ts-mode to the Ruby entry.

2023-04-15  Daniel Martín  <mardani29@yahoo.es>

	Fix fontification of C++ reference return types (bug#60441)

	* lisp/progmodes/c-ts-mode.el (c-ts-fontify-error): Treat
	reference_declarator nodes the same as pointer_declarator nodes when
	calculating the identifier to fontify.

2023-04-15  Jostein Kjønigsen  <jostein@kjonigsen.net>

	Adjust function-call fontification in csharp-ts-mode (bug#60376)

	- Ensure method-invocations are highlighted only on level 4.
	- Ensure consistent fontification of variable declarations
	  (don't highlight usage of all variables).
	- Fix issues with highlighting types in new() expressions.
	- Fix issues with generic types in variable-declarations not using "var".
	- Use fewer, more general queries for function-invocations. simplify code.

	* lisp/progmodes/csharp-mode.el (csharp-ts-mode--font-lock-settings):
	Change rules.
	(csharp-ts-mode): Update feature list.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Rewrite Antinews in ELisp manual for Emacs 29

	* doc/lispref/anti.texi (Antinews): Rewrite for Emacs 29.
	* doc/lispref/elisp.texi (Top): Update the top-level menu for
	Antinews.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Update Antinews in the user manual for Emacs 29

	* doc/emacs/anti.texi (Antinews): Rewrite for Emacs 29.
	* doc/emacs/emacs.texi (Top): Adjust the top-level menu.

2023-04-15  Mattias Engdegård  <mattiase@acm.org>

	Fix shortdoc-tests failure with respect to regexp-opt-charset

	* test/lisp/emacs-lisp/shortdoc-tests.el (regexp-opt): Require.
	`regexp-opt-charset` is not autoloaded, and whether `regexp-opt` is
	preloaded is configuration-dependent.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Improve documentation of 'isearch-open-overlay-temporary'

	* lisp/isearch.el (isearch-open-overlay-temporary): Document that
	the overlay passed to the 'isearch-open-invisible-temporary'
	function cannot be deleted too early.  (Bug#60399)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Document 'use-package' in the 2 main manuals

	* doc/emacs/custom.texi (Init Examples):
	* doc/lispref/loading.texi (Named Features): Document 'use-package'
	and its most important features.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Build recipe interactively in treesit-install-language-grammar

	If there is not existing recipe for a language, prompt to build the
	recipe interactively.

	* lisp/treesit.el (treesit--install-language-grammar-build-recipe):
	New functions.
	(treesit-install-language-grammar): Use the new function.

2023-04-15  Theodor Thornhill  <theo@thornhill.no>

	Tweak csharp-mode font-lock-settings (bug#60376)

	* lisp/progmodes/csharp-mode.el (csharp-ts-mode--font-lock-settings):
	Rearrange features.
	(csharp-ts-mode): Rearrange features.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Revert a recent change which causes errors

	* lisp/subr.el (buffer-match-p): Undo last change, as it causes an
	error in a timer function of show-paren-mode.

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	Fix misspelled functions in shortdoc groups

	* lisp/emacs-lisp/shortdoc.el (file, list): Fix misspelled function
	names: 'file-writable-p' and 'seq-reduce'.
	* test/lisp/emacs-lisp/shortdoc-tests.el (subr-x): Require.
	(shortdoc-all-functions-fboundp): New test.

2023-04-15  Kévin Le Gouguec  <kevin.legouguec@gmail.com>

	Simplify introduction of use-package manual

	* doc/misc/use-package.texi (Getting Started): Do not advise requiring
	the package, since the macro is autoloaded; also correct the macro's
	name.  (Bug#60366)

2023-04-15  kobarity  <kobarity@gmail.com>

	Fix python-shell-buffer-substring when retrieving a single statement

	* lisp/progmodes/python.el (python-shell-buffer-substring): Do not add
	"if True:" line when retrieving a single statement.
	(python-shell-send-region): Add a reference to
	`python-shell-buffer-substring' in docstring.
	* test/lisp/progmodes/python-tests.el (python-shell-buffer-substring-13)
	(python-shell-buffer-substring-14, python-shell-buffer-substring-15)
	(python-shell-buffer-substring-16, python-shell-buffer-substring-17):
	New tests. (Bug#60142)

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Show tree-sitter query source when signaling query error

	* src/treesit.c (treesit_compose_query_signal_data): Add QUERY_SOURCE
	parameter.
	(treesit_ensure_query_compiled)
	(Ftreesit_query_capture): Add query source.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Add version tags and mention the new options in NEWS

	* etc/NEWS: Mention the new options (bug#60186).

	* lisp/progmodes/ruby-mode.el (ruby-block-indent)
	(ruby-after-operator-indent, ruby-method-call-indent)
	(ruby-parenless-call-arguments-indent): Add version tags.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	Add new options for Ruby code indentation

	* lisp/progmodes/ruby-mode.el (ruby-block-indent)
	(ruby-after-operator-indent, ruby-method-call-indent)
	(ruby-parenless-call-arguments-indent): New options (bug#60186).
	(ruby-smie-grammar): Specify associativity for "?".
	(ruby-smie--indent-to-stmt): Add optional argument.

	* test/lisp/progmodes/ruby-mode-resources/ruby.rb: New cases.

	* test/lisp/progmodes/ruby-mode-resources/ruby-method-call-indent.rb:
	* test/lisp/progmodes/ruby-mode-resources/ruby-block-indent.rb:
	* test/lisp/progmodes/ruby-mode-resources/ruby-after-operator-indent.rb:
	* test/lisp/progmodes/ruby-mode-resources/
	ruby-parenless-call-arguments-indent.rb: New files.

	* test/lisp/progmodes/ruby-mode-tests.el: Add indentation tests for new files.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add treesit-install-language-grammar

	Per discussion on emacs-devel, I added function to install and compile
	language grammars.

	* lisp/treesit.el (treesit-language-source-alist): New variable.
	(treesit-install-language-grammar)
	(treesit--call-process-signal)
	(treesit--install-language-grammar-1): New functions.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add treesit-language-abi-version

	Also rename treesit-language-version to treesit-library-abi-version,
	because the old name is somewhat misleading.

	* doc/lispref/parsing.texi (Language Grammar): Update.
	* src/treesit.c (Ftreesit_library_abi_version): Rename.
	(Ftreesit_language_abi_version): New function.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Change "language definition" to "language grammar" in manual.

	"Language grammar" is apparently the more widely used term among
	people talking about tree-sitter.  To avoid confusion, I think it's
	good to use that rather than "language definition", which is a term
	that I made up :-)

	Feel free to revert this if it is too much change.

	* doc/lispref/elisp.texi:
	* doc/lispref/modes.texi:
	* doc/lispref/parsing.texi:
	* lisp/treesit.el: Change "language definition" to "language grammar".

2023-04-15  Michael Albinus  <michael.albinus@gmx.de>

	* test/lisp/net/tramp-tests.el (tramp-test32-shell-command): Fix test.

	* lisp/eshell/em-tramp.el (tramp): Require also at runtime.  (Bug#60402)

2023-04-15  Roland Winkler  <winkler@gnu.org>

	lisp/textmodes/bibtex.el: fix bibtex-beginning-of-entry (bug#56636)

	lisp/textmodes/bibtex.el (bibtex-beginning-of-entry):
	use bibtex-any-entry-maybe-empty-head (bug#56636)

2023-04-15  Roland Winkler  <winkler@gnu.org>

	lisp/textmodes/bibtex.el: Treat $ as punctuation in BibTeX fields (bug#50202)

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Clarify the documentation of 'set-face-attribute'

	* lisp/faces.el (set-face-attribute): Mention the evaluation order
	of attribute-value pairs in the docstring.

	* doc/lispref/display.texi (Attribute Functions): Likewise, and
	explain with an example that a different argument order might give
	different results.  Also align the documentation in the manual
	with that of the docstring, whose changes were discussed in
	bug#57499 but not included in the manual.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Handle non-string values in pcomplete

	* lisp/pcomplete.el (pcomplete-arg): When
	pcomplete-parse-arguments-function returns a non-string value,
	return the string the user typed in, and attach the value as a
	text property to that string.  Fixes bug#59956 and bug#60021.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Fix completion when completion-auto-select is set

	* lisp/minibuffer.el (completion--do-completion): Do not display
	"Complete, but not unique" messages when completion-auto-select is
	set.  Fixes bug#60359.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add color fontification in css-ts-mode (bug#60405)

	* lisp/textmodes/css-mode.el (css-ts-mode): Add color fontification
	and syntax-propertize-function.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/hi-lock.el (hi-lock--regexps-at-point): Fix bug (bug#60241).

	Handle two cases: when a pattern is a regexp or a function.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* src/keyboard.c (echo_add_key): Use recently rebound C-h key C-q (bug#60249)

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Avoid assertion violations in treesit.c with --enable-checking

	* src/treesit.c (Ftreesit_node_first_child_for_pos)
	(Ftreesit_node_descendant_for_range): Check validity of buffer
	positions before converting them to byte-positions, to avoid
	assertion violations in buf_charpos_to_bytepos.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Clean up treesit-default-defun-skipper and add comments

	* lisp/treesit.el (treesit-default-defun-skipper): Clean up, fix some
	small issue, add comment.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode bracket indentation (bug#60398)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--indent-styles): Use new
	anchor.
	(c-ts-mode--bracket-children-anchor): New anchor function.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Clean up font-lock rules in js-ts-mode

	Changes for each feature:

	- string: Take out string-interpolation bits.
	- string-interpolation: New.
	- declaration: Rename to definition.
	- identifier: Remove.
	- property: Use a pred to filter out methods.
	- expression: Rename to assignment.
	- function: New.
	- pattern: Merge into assignment.

	* lisp/progmodes/js.el (js--treesit-font-lock-settings): See above.
	(js--treesit-property-not-function-p)
	(js--treesit-lhs-identifier-query): New variable.
	(js--treesit-fontify-assignment-lhs): New functions.
	(js-ts-mode): Update feature list.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix syntax for < and > in c++-ts-mode (bug#60351)

	< and > are usually punctuation, e.g., in ->.  But when used for
	templates, they should be considered pairs.  Right now we always
	consider them as pairs which is incorrect.

	* lisp/progmodes/c-ts-mode.el (c++-ts-mode--syntax-table): Remove
	variable.
	(c-ts-mode--syntax-propertize): New function.
	(c++-ts-mode): Remove syntax table.  Setup syntax-propertize-function.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Call tree-sitter parser notifier on the first parse

	* src/treesit.c (treesit_call_after_change_functions): Handle NULL
	old_tree.
	(treesit_ensure_parsed): Remove check for NULL tree.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix tree-sitter parser notifier recursion

	See the comment for detail.

	* src/treesit.c (treesit_ensure_parsed): Move the need_reparse short
	circuit to the very beginning.  Move the call to
	treesit_call_after_change_functions to the very end.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/help.el: Use 'C-h C-q' to toggle 'help-quick' window (bug#60249).

	(help-map): Bind "C-q" to 'help-quick-toggle'.  Rebind "q" to 'help-quit'.
	(help-quick): Replace help-quit-or-quick with help-quick-toggle.
	(help-quick-toggle): New command.
	(help-quit-or-quick): Remove command.
	(help-for-help): Replace help-quick-or-quit with help-quick-toggle.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/isearch.el: Small fixes.

	(isearch-wrap-pause): Mention the new feature of `no' and `no-ding'
	in the docstring.
	(isearch-lax-whitespace, isearch-forward-thing-at-point): Add the
	group 'isearch' since another defgroup changed the default group.
	(isearch-delete-char): Use 'isearch-invisible' instead of 'search-invisible'
	since the users might change the current value with 'M-s i'.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/vc/diff-mode.el (diff-minor-mode-prefix): Replace "ESC" with "\e".

	"ESC" looks like an attempt to use kbd syntax in customization.
	But actually now 'key-description' is used in 'diff-minor-mode-map'
	to convert "\e" to "ESC".

2023-04-15  Juri Linkov  <juri@linkov.net>

	* doc/emacs/display.texi (Text Scale): Improve section about repeating keys.

	Mention that it's possible to use repeating keys without the modifiers
	and copy an example from etc/NEWS.

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/repeat.el (repeat-echo-function): Suggest 'add-function' in docstring.

	(bug#60353)

2023-04-15  Juri Linkov  <juri@linkov.net>

	* lisp/tab-line.el (tab-line-cache-key-default): More cache keys (bug#60340).

	Move more cache keys here from 'tab-line-format' to give users more freedom.

2023-04-15  Stefan Monnier  <monnier@iro.umontreal.ca>

	* etc/package-keyring.gpg: Update with new key

2023-04-15  F. Jason Park  <jp@neverwas.me>

	Warn of absent networks module in ERC

	* doc/misc/erc.texi: Add linkable note in Modules chapter about some
	modules being required.  Also tweak markup in auth-source section.
	* etc/ERC-NEWS: Mention the special role of `networks'.
	* lisp/erc/erc-backend.el (erc--server-post-connect-hook): Add
	internal hook for core modules to perform post-network-process,
	pre-protocol config validation even when they haven't been loaded.
	(erc--register-connection): Run `erc--server-post-connect-hook'.
	* lisp/erc/erc-networks.el (erc-networks--bouncer-targets,
	erc-networks-on-MOTD-end): Fix comments and doc strings.  Also change
	former from constant to internal variable in case adjustment needed
	between releases.
	(erc-networks--warn-on-connect): New function to warn about the
	`networks' module being absent from `erc-modules'.  This could
	probably run at any time up to and including when the logical IRC
	connection is established, but doing so at the process/protocol
	boundary seems ideal.
	* lisp/erc/erc-sasl.el (erc--register-connection): Defer to base
	method instead of calling `erc-login' explicitly.
	* lisp/erc/erc.el (erc-generate-new-buffer-name): Don't reconcile
	buffer names when networks module not in play.
	(erc-format-target-and/or-network): Don't assume networks module
	loaded.
	* test/lisp/erc/erc-scenarios-base-unstable.el:
	(erc-scenarios-networks-no-module): New test.
	* test/lisp/erc/resources/networks/no-module/basic.eld: New test data
	file.  (Bug#60331.)

2023-04-15  F. Jason Park  <jp@neverwas.me>

	Avoid "already compiled" warning in erc-compat

	* lisp/erc/erc-compat.el (erc-compat--29-auth-source-pass-search):
	Don't `byte-compile' sub-29 secrets wrapper.  This was especially
	noisy in tests.  Ditch closed-over vars via HOF instead of suppressing
	because compiling emits "unused lexical" warning on Emacs 27.

2023-04-15  Dmitry Gutov  <dgutov@yandex.ru>

	(python--treesit-settings): Remove duplicate matcher

	* lisp/progmodes/python.el (python--treesit-settings): Remove
	duplicate matcher (which found itself under 'function' in addition
	to 'definition').

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Make last change of w32 GUI dialogs conditional and reversible

	* src/w32term.c (syms_of_w32term) <w32-yes-no-dialog-show-cancel>:
	New boolean variable.
	(w32_initialize): Fix query for visible system caret: 'bool' is a
	single-byte data type, whereas SystemParametersInfo wants a BOOL,
	which is a 32-bit int.
	* src/w32menu.c (simple_dialog_show): Show "Cancel" button only if
	'w32-yes-no-dialog-show-cancel' is non-nil.

	* etc/NEWS: Announce the change.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix tree-sitter typos

	* doc/lispref/parsing.texi (Tree-sitter major modes):
	* lisp/progmodes/java-ts-mode.el:
	* test/src/treesit-tests.el (treesit-defun-navigation-nested-4): Fix
	typo.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Update tree-sitter major modes to use the new Imenu facility

	See previous commit for more explanation.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--defun-name): Handle more
	types.
	(c-ts-mode--imenu-1)
	(c-ts-mode--imenu): Remove functions.
	(c-ts-base-mode): Setup Imenu.
	* lisp/progmodes/csharp-mode.el (csharp-ts-mode--imenu-1)
	(csharp-ts-mode--imenu): Remove functions.
	(csharp-ts-mode): Setup Imenu.
	* lisp/progmodes/java-ts-mode.el (java-ts-mode--imenu-1)
	(java-ts-mode--imenu): Remove functions.
	(java-ts-mode): Setup Imenu.
	* lisp/progmodes/js.el (js--treesit-imenu-1)
	(js--treesit-imenu): Remove functions.
	(js--treesit-valid-imenu-entry): New function.
	(js-ts-mode): Setup Imenu.
	* lisp/progmodes/json-ts-mode.el (json-ts-mode--defun-name): Trim the
	quotes.
	(json-ts-mode--imenu-1)
	(json-ts-mode--imenu): Remove functions.
	(json-ts-mode): Setup Imenu.
	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--imenu)
	(rust-ts-mode--imenu-1): Remove functions.
	(rust-ts-mode): Setup Imenu.
	* lisp/progmodes/typescript-ts-mode.el:
	(typescript-ts-base-mode): Remove treesit-defun-prefer-top-level, it's
	not used anymore.  Setup Imenu.  Setup treesit-defun-name-function.
	* lisp/textmodes/css-mode.el (css--treesit-imenu-1)
	(css--treesit-imenu): Remove functions.
	(css-ts-mode): Setup Imenu.
	* lisp/textmodes/toml-ts-mode.el (toml-ts-mode--defun-name): Fix it
	and add a fallback.
	(toml-ts-mode--imenu-1)
	(toml-ts-mode--imenu): Remove functions.
	(toml-ts-mode): Setup Imenu.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add tree-sitter helper functions for Imenu

	We didn't add an integration for Imenu because we aren't sure what
	should it look like.  Now we have a pretty good idea.  All the major
	modes copy-paste the two Imenu functions and tweaks them in a standard
	way.  With the addition of treesit-defun-type-regexp and
	treesit-defun-name-function, now is a good time to standardize Imenu
	integration.

	In the next commit we update all the major modes to use this
	integration.

	* doc/lispref/modes.texi (Imenu): Add manual.
	* doc/lispref/parsing.texi (Tree-sitter major modes): Update manual.
	* lisp/treesit.el (treesit-simple-imenu-settings): New varaible.
	(treesit--simple-imenu-1)
	(treesit-simple-imenu): New functions.
	(treesit-major-mode-setup): Setup Imenu.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix treesit--things-around (bug#60355)

	Current implementation of treesit--things-around only searches forward
	for REGEXP and go up the tree until it finds a valid thing, if nothing
	matches it gives up.  This makes it sometimes miss defuns.  The new
	implementation tries multiple times (of search forward + go up) until
	it exhausts all possible defun nodes.

	* lisp/treesit.el (treesit--things-around): New implementation.
	(treesit--navigate-defun): Refactor to use treesit-node-top-level to
	simplify code, and add some guards in the predicate function.
	* test/src/treesit-tests.el:
	(treesit--ert-defun-navigation-elixir-program): New variable.
	(treesit-defun-navigation-nested-4): New test.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Improve treesit-node-top-level and treesit-parent-until

	* lisp/treesit.el (treesit-node-top-level): Now it can accept a
	predicate function.  Add an optional argument INCLUDE-NODE.
	(treesit-parent-until): Add an optional argument INCLUDE-NODE.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	* src/w32menu.c (simple_dialog_show): Use MB_YESNOCANCEL style.

2023-04-15  Xi Lu  <lx@shellcodes.org>

	Fix htmlfontify.el command injection vulnerability.

	* lisp/htmlfontify.el (hfy-text-p): Fix command injection
	vulnerability.  (Bug#60295)

2023-04-15  Rudolf Adamkovič  <salutis@me.com>

	Improve support for Scheme R6RS and R7RS libraries (bug#54704)

	* etc/NEWS (Scheme mode): Document improved file-type auto-detection
	and Imenu support for R6RS and R7RS Scheme libraries.
	* lisp/files.el (auto-mode-alist): Associate the '.sls' (R6RS Scheme
	Library Source) and '.sld' (R7RS Scheme Library Definition) file name
	extensions with the Scheme mode.
	* lisp/progmodes/scheme.el (scheme-imenu-generic-expression): Make
	Imenu recognize the members nested (and so indented) inside of
	'library' (R6RS) or 'define-library' (R7RS) forms.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add a new tree-sitter query predicate 'pred'

	I realized that using an arbitrary function as the predicate in
	queries is very helpful for some queries I'm writing for python and
	javascript, and presumably most other languages[1].

	Granted, we can already filter out unwanted nodes by using a function
	instead of a face for the capture name, and (1) determine whether the
	captured node is valid and (2) fontify that node if it's valid.

	However, such approach is a bit more cumbersome and more importantly
	gets in the way of another potential use of the fontification queries:
	context extraction.

	For example, I could use the query for the 'variable' feature to get
	all the variables in a certain region.  In this use-case, we want the
	filtering happen before returning the captured nodes.

	Besides, the change is relatively small and straightforward: most code
	are already there, I just need to add some boilerplate.

	[1] For a code like aa.bb(cc), we want bb to be in function face,
	because obviously its a function.  But for aa.bb, we want bb to be in
	property face, because it's a property.  In the AST, bb is always a
	property, the difference between the two cases is the enclosing node:
	in the first case, aa.bb is in a "call_expression" node, indicating
	that bb is used as a function (a method).  So we want a predicate
	function that checks whether bb is used as a function or a property,
	and determine whether it should be in function or property face.

	* doc/lispref/parsing.texi (Pattern Matching): Update manual.
	* src/treesit.c (Ftreesit_pattern_expand): Handle :pred.
	(treesit_predicate_capture_name_to_node): A new function extracted
	from treesit_predicate_capture_name_to_text.
	(treesit_predicate_capture_name_to_text): Use the newly extracted
	function.
	(treesit_predicate_pred): New predicate function.
	(treesit_eval_predicates): Add new predicate.  Also fix a bug: we want
	to AND the results of each predicate.
	* test/src/treesit-tests.el (treesit--ert-pred-last-sibling): New
	helper function.
	(treesit-query-api): Test #pred predicate.

2023-04-15  Stefan Kangas  <stefankangas@gmail.com>

	Improve gnutls-min-prime-bits docstring

	* lisp/net/gnutls.el (gnutls-min-prime-bits): Doc fix: delete
	out-of-date and now misleading sentence, added back when Emacs'
	default minimum prime bits for a Diffie-Hellman handshake was only 256
	bits.  These days, the default is nil, which means to let GnuTLS
	decide the value.  (See also `nsm-protocol-check--dhe-prime-kx`.)

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Improve handling of tab-bar height.

	* src/xdisp.c (redisplay_tab_bar): When 'auto-resize-tab-bar' is
	not 'grow-only', also consider the case when the tab-bar height
	needs to shrink.  Fixes bug#60210.

2023-04-15  Eli Zaretskii  <eliz@gnu.org>

	Simplify last change (bug#60311)

	* src/json.c (json_available_p): Use original code.  Always return
	true for !WINDOWSNT.
	(ensure_json_available): Now defined only on WINDOWSNT.
	(Fjson_serialize, Fjson_insert, Fjson_parse_string)
	(Fjson_parse_buffer): Call ensure_json_available only on
	WINDOWSNT.

	* lisp/subr.el (json-available-p): Simplify.

2023-04-15  Mattias Engdegård  <mattias.engdegard@gmail.com>

	Fix 'json-available-p' on MS-Windows

	* src/json.c (json_available_p, ensure_json_available)
	(Fjson__available_p): New functions.
	(Fjson_serialize, Fjson_insert, Fjson_parse_string)
	(Fjson_parse_buffer): Use ensure_json_available.
	(syms_of_json): Defsubr json--available-p.

	* lisp/subr.el (json-available-p): Rewrite.

2023-04-15  Kyle Meyer  <kyle@kyleam.com>

	loaddefs-gen: Group results by absolute file name

	loaddefs-generate produced an incomplete output file if 1) it
	was called with a relative file name and 2) that same file was
	specified via a generated-autoload-file cookie in a subset of
	the input files.  In that case, autoload entries were lost
	because loaddefs-generate writes the same output file twice:
	once for the relative name specified by the caller and once
	for the absolute name that loaddefs-generate--parse-file
	returns for the generated-autoload-file value.
	This has been fixed.  (Bug#60318)

	* lisp/emacs-lisp/loaddefs-gen.el (loaddefs-generate): Expand file
	names when grouping loaddef files.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix imenu for c-ts-mode (bug#60296)

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--imenu-1): Use
	c-ts-mode--defun-valid-p to filter out nested matches.
	(c-ts-mode--defun-valid-p): Handle more types of nodes.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Clean up python-ts-mode font-lock features

	* lisp/progmodes/python.el (python--treesit-settings): Remove
	unnecessary override flags, add function and variable feature, fix
	assignment feature.
	(python--treesit-variable-p)
	(python--treesit-fontify-variable): New functions.
	(python-ts-mode): Add function and variable feature.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add comment indent and filling to other tree-sitter major modes

	Extract the setup into a function, and use it in other major modes.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode-comment-setup): New function.
	(c-ts-base-mode): Extract out.
	(c-ts-mode)
	(c++-ts-mode): Remove old setup.

	* lisp/progmodes/csharp-mode.el (csharp-ts-mode--indent-rules): New
	indent rules.
	(csharp-ts-mode): Use new setup function.
	* lisp/progmodes/java-ts-mode.el (java-ts-mode--indent-rules): New
	indent rules.
	(java-ts-mode): Use new setup function.
	* lisp/progmodes/js.el (js--treesit-indent-rules): New indent rules.
	(js-ts-mode): Use new setup function.
	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--indent-rules): New
	indent rules.
	(rust-ts-mode): Use new setup function.
	* lisp/progmodes/typescript-ts-mode.el:
	(typescript-ts-mode--indent-rules): New indent rules.
	(typescript-ts-base-mode): Use new setup function.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add maintainer stub for tree-sitter files

	* lisp/treesit.el:
	* src/treesit.c: Add maintainer.

2023-04-15  Gregory Heytings  <gregory@heytings.org>

	Remove remaining mentions of 'eval-current-buffer'

	* lisp/emacs-lisp/edebug.el (edebug-all-defs):
	* doc/lispref/eval.texi (Eval):
	* doc/lispref/edebug.texi (Instrumenting, Edebug Options):
	Remove remaining mentions of 'eval-current-buffer', obsoleted in
	Emacs 22 and removed in Emacs 26.

2023-04-15  Kyle Meyer  <kyle@kyleam.com>

	Update to Org 9.6-61-g63e073f

2023-04-15  Philip Kaludercic  <philipk@posteo.net>

	Add heuristic to locate lisp code in source packages

	* lisp/emacs-lisp/package-vc.el (package-vc--unpack): Check if a
	"lisp" directory exists and use that instead of PKG-DIR.

	(Bug#60155)

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Further generalize treesit-defun functions

	Two new functions, treesit-beginning/end-of-thing.  And
	treesit-thing-at-point's signature changes.

	* lisp/treesit.el (treesit-block-type-regexp): New variable.
	(treesit-beginning-of-thing)
	(treesit-end-of-thing): Generalized from
	treesit-beginning/end-of-defun.
	(treesit-beginning-of-defun)
	(treesit-end-of-defun): Use the new functions.
	(treesit-thing-at-point): Accept PATTERN rather than REGEXP and PRED.
	(treesit-defun-at-point): Adjust for the new signature of
	treesit-thing-at-point.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Generalize treesit-defun functions to "things"

	Change the "defun" in some functions (e.g. treesit--defuns-around) to
	"thing".  Add a function treesit-thing-at-point.

	* lisp/treesit.el (treesit--thing-unpack-pattern): New subroutine.
	(treesit-beginning-of-defun)
	(treesit-end-of-defun): Use new function treesit--navigate-thing.
	(treesit--defuns-around): Generalize into treesit--thing-around.
	(treesit--top-level-defun): Generalize into treesit--top-level-thing.
	(treesit--navigate-defun): Generalize into treesit--navigate-thing.
	(treesit-thing-at-point): Generalized from treesit-defun-at-point.
	(treesit-defun-at-point): Use treesit-thing-at-point to do tht work.

2023-04-15  Philip Kaludercic  <philipk@posteo.net>

	Reorder optional arguments to 'package-vc-install'

	* lisp/emacs-lisp/package-vc.el (package-vc-install-selected-packages):
	Update 'package-vc-install' invocation.
	(package-vc-install): Reorder and update documentation.

2023-04-15  Philip Kaludercic  <philipk@posteo.net>

	Handle missing dependencies for source packages

	* lisp/emacs-lisp/package-vc.el (package-vc-install-dependencies): Add
	new function.
	(package-vc--unpack-1): Call 'package-vc-install-dependencies' instead
	of 'package-compute-transaction' and 'package-download-transaction'.

	It is unreasonable to abort the installation, since we cannot expect
	all dependencies to be available in the regular archives.  Instead we
	note which packages couldn't be found, and warn the user that these
	will be missing.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix c-ts-mode imenu defun name (bug#60296)

	Extract out c-ts-mode--declarator-identifier from
	c-ts-mode--fontify-declarator.

	* lisp/progmodes/c-ts-mode.el (c-ts-mode--declarator-identifier): New
	function.
	(c-ts-mode--fontify-defun): Extract out.
	(c-ts-mode--defun-name): Use the new function.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Fix treesit--children-covering-range-recurse (bug#60301)

	* lisp/treesit.el (treesit--children-covering-range-recurse): Always
	return a list of node.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Support treesit-defun-name in tree-sitter major modes

	* lisp/progmodes/csharp-mode.el (csharp-ts-mode--defun-name): New
	function.
	(csharp-ts-mode--imenu-1): Extract into new function.
	(csharp-ts-mode): Setup treesit-defun-name-function.
	* lisp/progmodes/java-ts-mode.el (java-ts-mode--defun-name): New
	function.
	(java-ts-mode--imenu-1): Extract into new function.
	(java-ts-mode): Setup treesit-defun-name-function.
	* lisp/progmodes/js.el (js-treesit-current-defun): Remove function.
	This function is not used (for a while already).
	(js--treesit-defun-name): New function.
	(js--treesit-imenu-1): Extract into new function.
	(js-ts-mode): Setup treesit-defun-name-function.
	* lisp/progmodes/json-ts-mode.el (json-ts-mode--defun-name): New
	function.
	(json-ts-mode--imenu-1): Extract into new function.
	(json-ts-mode): Setup treesit-defun-name-function.
	* lisp/progmodes/python.el (python--treesit-defun-name): New function.
	(python--imenu-treesit-create-index-1): Extract into new function.
	(python-ts-mode): Setup treesit-defun-name-function.
	* lisp/progmodes/rust-ts-mode.el (rust-ts-mode--defun-name): New
	function.
	(rust-ts-mode--imenu-1): Extract into new function.
	(rust-ts-mode): Setup treesit-defun-name-function.
	* lisp/textmodes/css-mode.el (css--treesit-defun-name): New function.
	(css--treesit-imenu-1): Extract into new function.
	(css-ts-mode): Setup treesit-defun-name-function.
	* lisp/textmodes/toml-ts-mode.el (toml-ts-mode--get-table-name):
	Remove function.
	(toml-ts-mode--defun-name): New function.
	(toml-ts-mode--imenu-1): Extract into new function.
	(toml-ts-mode): Setup treesit-defun-name-function.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Add treesit-defun-name and friends

	1. We now have treesit-defun-name, powered by
	treesit-defun-name-function.
	2. We now have treesit-add-log-current-defun, which powers
	add-log-current-defun.
	3. c-ts-mode updates its code to take advantage of these new features.
	4. Manual updates.

	* doc/lispref/parsing.texi (Tree-sitter major modes): Add manual for
	new functions.
	* lisp/progmodes/c-ts-mode.el (c-ts-mode--defun-name): New function.
	(c-ts-mode--imenu-1): Extract out into c-ts-mode--defun-name.
	(c-ts-base-mode): Setup treesit-defun-name-function.
	* lisp/treesit.el (treesit-defun-name-function)
	(treesit-add-log-defun-delimiter): New variables.
	(treesit-defun-at-point)
	(treesit-defun-name): New functions.
	(treesit-major-mode-setup): Setup add-log-current-defun-function.

2023-04-15  Yuan Fu  <casouri@gmail.com>

	Make treesit-node-at/on guess language at point

	If PARSER-OR-LANG is nil, it makes more sense to guess the language at
	point by treesit-language-at than to simply use the first parser in
	the parser list.

	* doc/lispref/parsing.texi (Retrieving Nodes): Update manual.
	* lisp/treesit.el (treesit-node-at)
	(treesit-node-on): Guess language at point.  Update docstring.
	(treesit-buffer-root-node): Update docstring.

2023-04-15  Óscar Fuentes  <ofv@wanadoo.es>

	* nt/INSTALL.W64: update instructions for setting up W64 environment

